using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Maths;
using MicrosoftResearch.Infer.Factors;
using MicrosoftResearch.Infer.Collections;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 11:39 on terça-feira, 1 de Outubro de 2013.
	/// </remarks>
	public partial class Model1_EP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the evidence property</summary>
		private bool Evidence;
		/// <summary>Field backing the numTraining property</summary>
		private int NumTraining;
		/// <summary>Field backing the dummyWeightsPosterior property</summary>
		private VectorGaussian DummyWeightsPosterior;
		/// <summary>Field backing the baseFeaturesTest property</summary>
		private Vector[] BaseFeaturesTest;
		/// <summary>Field backing the numEventsTest property</summary>
		private int[] NumEventsTest;
		/// <summary>Field backing the eventsFeatureWeightsPosterior property</summary>
		private VectorGaussian EventsFeatureWeightsPosterior;
		/// <summary>Field backing the eventsFeaturesTest property</summary>
		private Vector[][] EventsFeaturesTest;
		/// <summary>Field backing the observedCountsTest property</summary>
		private double[] ObservedCountsTest;
		/// <summary>The number of iterations last computed by Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0. Set this to zero to force re-execution of Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0</summary>
		public int Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence. Set this to zero to force re-execution of Changed_evidence</summary>
		public int Changed_evidence_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2. Set this to zero to force re-execution of Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2</summary>
		public int Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_iterationsDone;
		/// <summary>True if Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2 has performed initialisation. Set this to false to force re-execution of Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2</summary>
		public bool Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_isInitialised;
		/// <summary>The number of iterations last computed by Changed_evidence_numTraining. Set this to zero to force re-execution of Changed_evidence_numTraining</summary>
		public int Changed_evidence_numTraining_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4. Set this to zero to force re-execution of Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4</summary>
		public int Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_iterationsDone;
		/// <summary>True if Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4 has performed initialisation. Set this to false to force re-execution of Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4</summary>
		public bool Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5. Set this to zero to force re-execution of Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5</summary>
		public int Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6. Set this to zero to force re-execution of Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6</summary>
		public int Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_iterationsDone;
		/// <summary>True if Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6 has performed initialisation. Set this to false to force re-execution of Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6</summary>
		public bool Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_isInitialised;
		/// <summary>The number of iterations last computed by Changed_evidence_numTraining_numEventsTest. Set this to zero to force re-execution of Changed_evidence_numTraining_numEventsTest</summary>
		public int Changed_evidence_numTraining_numEventsTest_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8. Set this to zero to force re-execution of Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8</summary>
		public int Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_iterationsDone;
		/// <summary>True if Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8 has performed initialisation. Set this to false to force re-execution of Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8</summary>
		public bool Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_isInitialised;
		/// <summary>The number of iterations last computed by Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9. Set this to zero to force re-execution of Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9</summary>
		public int Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_iterationsDone;
		/// <summary>True if Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9 has performed initialisation. Set this to false to force re-execution of Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9</summary>
		public bool Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_isInitialised;
		/// <summary>The number of iterations last computed by Changed_evidence_numTraining_eventsFeatureWeightsPosterior. Set this to zero to force re-execution of Changed_evidence_numTraining_eventsFeatureWeightsPosterior</summary>
		public int Changed_evidence_numTraining_eventsFeatureWeightsPosterior_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11. Set this to zero to force re-execution of Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11</summary>
		public int Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_iterationsDone;
		/// <summary>True if Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11 has performed initialisation. Set this to false to force re-execution of Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11</summary>
		public bool Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_isInitialised;
		/// <summary>The number of iterations last computed by Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12. Set this to zero to force re-execution of Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12</summary>
		public int Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_iterationsDone;
		/// <summary>True if Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12 has performed initialisation. Set this to false to force re-execution of Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12</summary>
		public bool Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_isInitialised;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public VectorGaussian vVector8_rep_F_marginal;
		public DistributionRefArray<VectorGaussian,Vector> vVector8_rep_B;
		public DistributionStructArray<Gaussian,double> dummyContributionsTest_F;
		/// <summary>Messages from use of 'dummyContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double>[] dummyContributionsTest_uses_B;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_depth2_B;
		/// <summary>Messages from use of 'eventsContributionsTest'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[] eventsContributionsTest_uses_B;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_F;
		public DistributionRefArray<VectorGaussian,Vector> vVector10_rep_F;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector10_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public VectorGaussian vVector10_rep_F_marginal;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector8_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<Gaussian></summary>
		public DistributionStructArray<Gaussian,double> dummyContributionsTest_uses_F_Ntest__marginal;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>></summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_uses_B_Ntest__toDef;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector10_rep_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> vVector10_rep_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>></summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_uses_F_Ntest__marginal;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<Gaussian></summary>
		public DistributionStructArray<Gaussian,double> dummyContributionsTest_uses_B_Ntest__toDef;
		public DistributionRefArray<VectorGaussian,Vector> vVector8_rep_F;
		/// <summary>Buffer for InnerProductOp.BMean</summary>
		public PositiveDefiniteMatrix[] vVector8_rep_F_Ntest__BVariance;
		/// <summary>Buffer for InnerProductOp.InnerProductAverageConditional</summary>
		public Vector[] vVector8_rep_F_Ntest__BMean;
		public DistributionStructArray<Gaussian,double> vdouble23_F;
		/// <summary>Messages to use of 'dummyContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double>[] dummyContributionsTest_uses_F;
		/// <summary>Messages to use of 'eventsContributionsTest'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[] eventsContributionsTest_uses_F;
		public DistributionStructArray<Gaussian,double> vdouble31_B;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble27_B;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> vVector10_rep_rep_F_marginal;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector10_rep_rep_F;
		/// <summary>Buffer for InnerProductOp.BMean</summary>
		public PositiveDefiniteMatrix[][] vVector10_rep_rep_F_Etest__BVariance;
		/// <summary>Buffer for InnerProductOp.InnerProductAverageConditional</summary>
		public Vector[][] vVector10_rep_rep_F_Etest__BMean;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble27_F;
		public DistributionStructArray<Gaussian,double> vdouble31_F;
		public DistributionStructArray<Gaussian,double> vdouble23_B;
		/// <summary>Message to marginal of 'vVector8'</summary>
		public VectorGaussian vVector8_marginal_F;
		/// <summary>Message to marginal of 'vVector10'</summary>
		public VectorGaussian vVector10_marginal_F;
		/// <summary>Message to marginal of 'dummyContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double> dummyContributionsTest_marginal_F;
		/// <summary>Message to marginal of 'eventsContributionsTest'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_marginal_F;
		public Bernoulli evidence_marginal;
		public PointMass<int> numTraining_marginal;
		public PointMass<VectorGaussian> dummyWeightsPosterior_marginal;
		public PointMass<Vector[]> baseFeaturesTest_marginal;
		public PointMass<int[]> numEventsTest_marginal;
		public PointMass<VectorGaussian> eventsFeatureWeightsPosterior_marginal;
		public PointMass<Vector[][]> eventsFeaturesTest_marginal;
		public DistributionStructArray<Gaussian,double> observedCountsTest_marginal;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'evidence'</summary>
		public bool evidence
		{			get {
				return this.Evidence;
			}
			set {
				if (this.Evidence!=value) {
					this.Evidence = value;
					this.numberOfIterationsDone = 0;
					this.Changed_evidence_iterationsDone = 0;
					this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_iterationsDone = 0;
					this.Changed_evidence_numTraining_iterationsDone = 0;
					this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_iterationsDone = 0;
					this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_iterationsDone = 0;
					this.Changed_evidence_numTraining_numEventsTest_iterationsDone = 0;
					this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_iterationsDone = 0;
					this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_iterationsDone = 0;
					this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_iterationsDone = 0;
					this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_iterationsDone = 0;
					this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_iterationsDone = 0;
					this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
					this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'numTraining'</summary>
		public int numTraining
		{			get {
				return this.NumTraining;
			}
			set {
				if (this.NumTraining!=value) {
					this.NumTraining = value;
					this.numberOfIterationsDone = 0;
					this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_isInitialised = false;
					this.Changed_evidence_numTraining_iterationsDone = 0;
					this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_iterationsDone = 0;
					this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_iterationsDone = 0;
					this.Changed_evidence_numTraining_numEventsTest_iterationsDone = 0;
					this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_iterationsDone = 0;
					this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_iterationsDone = 0;
					this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_iterationsDone = 0;
					this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_iterationsDone = 0;
					this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_isInitialised = false;
					this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
					this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'dummyWeightsPosterior'</summary>
		public VectorGaussian dummyWeightsPosterior
		{			get {
				return this.DummyWeightsPosterior;
			}
			set {
				this.DummyWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_isInitialised = false;
				this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_isInitialised = false;
				this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_isInitialised = false;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_iterationsDone = 0;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_iterationsDone = 0;
				this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'baseFeaturesTest'</summary>
		public Vector[] baseFeaturesTest
		{			get {
				return this.BaseFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTraining)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTraining)+" was expected for variable \'baseFeaturesTest\'");
				}
				this.BaseFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_isInitialised = false;
				this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_isInitialised = false;
				this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_isInitialised = false;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'numEventsTest'</summary>
		public int[] numEventsTest
		{			get {
				return this.NumEventsTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTraining)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTraining)+" was expected for variable \'numEventsTest\'");
				}
				this.NumEventsTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_isInitialised = false;
				this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_iterationsDone = 0;
				this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_iterationsDone = 0;
				this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_iterationsDone = 0;
				this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_isInitialised = false;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsFeatureWeightsPosterior'</summary>
		public VectorGaussian eventsFeatureWeightsPosterior
		{			get {
				return this.EventsFeatureWeightsPosterior;
			}
			set {
				this.EventsFeatureWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_iterationsDone = 0;
				this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_iterationsDone = 0;
				this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_iterationsDone = 0;
				this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_iterationsDone = 0;
				this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_isInitialised = false;
				this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_isInitialised = false;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsFeaturesTest'</summary>
		public Vector[][] eventsFeaturesTest
		{			get {
				return this.EventsFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTraining)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTraining)+" was expected for variable \'eventsFeaturesTest\'");
				}
				this.EventsFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_isInitialised = false;
				this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_isInitialised = false;
				this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_isInitialised = false;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'observedCountsTest'</summary>
		public double[] observedCountsTest
		{			get {
				return this.ObservedCountsTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTraining)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTraining)+" was expected for variable \'observedCountsTest\'");
				}
				this.ObservedCountsTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_isInitialised = false;
				this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_isInitialised = false;
				this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_isInitialised = false;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="evidence") {
				return this.evidence;
			}
			if (variableName=="numTraining") {
				return this.numTraining;
			}
			if (variableName=="dummyWeightsPosterior") {
				return this.dummyWeightsPosterior;
			}
			if (variableName=="baseFeaturesTest") {
				return this.baseFeaturesTest;
			}
			if (variableName=="numEventsTest") {
				return this.numEventsTest;
			}
			if (variableName=="eventsFeatureWeightsPosterior") {
				return this.eventsFeatureWeightsPosterior;
			}
			if (variableName=="eventsFeaturesTest") {
				return this.eventsFeaturesTest;
			}
			if (variableName=="observedCountsTest") {
				return this.observedCountsTest;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="evidence") {
				this.evidence = (bool)value;
				return ;
			}
			if (variableName=="numTraining") {
				this.numTraining = (int)value;
				return ;
			}
			if (variableName=="dummyWeightsPosterior") {
				this.dummyWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="baseFeaturesTest") {
				this.baseFeaturesTest = (Vector[])value;
				return ;
			}
			if (variableName=="numEventsTest") {
				this.numEventsTest = (int[])value;
				return ;
			}
			if (variableName=="eventsFeatureWeightsPosterior") {
				this.eventsFeatureWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="eventsFeaturesTest") {
				this.eventsFeaturesTest = (Vector[][])value;
				return ;
			}
			if (variableName=="observedCountsTest") {
				this.observedCountsTest = (double[])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="vVector8") {
				return this.VVector8Marginal();
			}
			if (variableName=="dummyContributionsTest") {
				return this.DummyContributionsTestMarginal();
			}
			if (variableName=="vVector10") {
				return this.VVector10Marginal();
			}
			if (variableName=="eventsContributionsTest") {
				return this.EventsContributionsTestMarginal();
			}
			if (variableName=="evidence") {
				return this.EvidenceMarginal();
			}
			if (variableName=="numTraining") {
				return this.NumTrainingMarginal();
			}
			if (variableName=="dummyWeightsPosterior") {
				return this.DummyWeightsPosteriorMarginal();
			}
			if (variableName=="baseFeaturesTest") {
				return this.BaseFeaturesTestMarginal();
			}
			if (variableName=="numEventsTest") {
				return this.NumEventsTestMarginal();
			}
			if (variableName=="eventsFeatureWeightsPosterior") {
				return this.EventsFeatureWeightsPosteriorMarginal();
			}
			if (variableName=="eventsFeaturesTest") {
				return this.EventsFeaturesTestMarginal();
			}
			if (variableName=="observedCountsTest") {
				return this.ObservedCountsTestMarginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			if (numberOfIterations<this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone) {
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_isInitialised = false;
				this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_isInitialised = false;
				this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_isInitialised = false;
				this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_isInitialised = false;
				this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
			}
			this.Changed_evidence();
			this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12(initialise);
			this.Changed_evidence_numTraining();
			this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior();
			this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11(initialise);
			this.Changed_evidence_numTraining_numEventsTest();
			this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9(initialise);
			this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8(initialise);
			this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6(initialise);
			this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4(initialise);
			this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2(initialise);
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5(numberOfIterations);
			this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that depend on the observed value of evidence</summary>
		public void Changed_evidence()
		{
			if (this.Changed_evidence_iterationsDone==1) {
				return ;
			}
			this.Changed_evidence_iterationsDone = 1;
			this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_iterationsDone = 0;
			this.Changed_evidence_numTraining_iterationsDone = 0;
			this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and eventsFeatureWeightsPosterior and must reset on changes to numberOfIterationsDecreased and dummyWeightsPosterior and numTraining and baseFeaturesTest and numEventsTest and eventsFeaturesTest and observedCountsTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12(bool initialise)
		{
			if ((this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_iterationsDone==1)&&((!initialise)||this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_isInitialised)) {
				return ;
			}
			if (this.Evidence) {
				// Message to 'vVector10_rep' from Replicate factor
				this.vVector10_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.EventsFeatureWeightsPosterior);
				// Message to 'vVector10_rep' from Replicate factor
				this.vVector10_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.EventsFeatureWeightsPosterior);
			}
			this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_iterationsDone = 1;
			this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWeightsPosterio12_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTraining</summary>
		public void Changed_evidence_numTraining()
		{
			if (this.Changed_evidence_numTraining_iterationsDone==1) {
				return ;
			}
			if (this.Evidence) {
				// Create array for 'vVector8_rep' Backwards messages.
				this.vVector8_rep_B = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
				// Create array for 'dummyContributionsTest' Forwards messages.
				this.dummyContributionsTest_F = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					this.dummyContributionsTest_F[Ntest] = Gaussian.Uniform();
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'dummyContributionsTest_uses_F_Ntest__marginal'
				this.dummyContributionsTest_uses_F_Ntest__marginal = new DistributionStructArray<Gaussian,double>(this.NumTraining);
				// Create array for 'dummyContributionsTest_uses' Backwards messages.
				this.dummyContributionsTest_uses_B = new DistributionStructArray<Gaussian,double>[this.NumTraining];
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for 'dummyContributionsTest_uses' Backwards messages.
					this.dummyContributionsTest_uses_B[Ntest] = new DistributionStructArray<Gaussian,double>(2);
				}
			}
			if (this.Evidence) {
				// Create array for 'eventsContributionsTest_depth2' Backwards messages.
				this.eventsContributionsTest_depth2_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
				// Create array for 'eventsContributionsTest_uses' Backwards messages.
				this.eventsContributionsTest_uses_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[this.NumTraining];
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for 'eventsContributionsTest_uses' Backwards messages.
					this.eventsContributionsTest_uses_B[Ntest] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(2);
				}
			}
			if (this.Evidence) {
				// Create array for 'eventsContributionsTest' Forwards messages.
				this.eventsContributionsTest_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
				// Create array for replicates of 'eventsContributionsTest_uses_B_Ntest__toDef'
				this.eventsContributionsTest_uses_B_Ntest__toDef = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
				// Create array for replicates of 'vVector10_rep_rep_B'
				this.vVector10_rep_rep_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTraining);
				// Create array for 'vVector10_rep' Forwards messages.
				this.vVector10_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
				// Create array for replicates of 'vVector10_rep_rep_B_toDef'
				this.vVector10_rep_rep_B_toDef = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
				// Create array for replicates of 'eventsContributionsTest_uses_F_Ntest__marginal'
				this.eventsContributionsTest_uses_F_Ntest__marginal = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
				// Create array for replicates of 'dummyContributionsTest_uses_B_Ntest__toDef'
				this.dummyContributionsTest_uses_B_Ntest__toDef = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			}
			this.Changed_evidence_numTraining_iterationsDone = 1;
			this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_iterationsDone = 0;
			this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_iterationsDone = 0;
			this.Changed_evidence_numTraining_numEventsTest_iterationsDone = 0;
			this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_iterationsDone = 0;
			this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_iterationsDone = 0;
			this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTraining and eventsFeatureWeightsPosterior</summary>
		public void Changed_evidence_numTraining_eventsFeatureWeightsPosterior()
		{
			if (this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_iterationsDone==1) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					this.vVector10_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsFeatureWeightsPosterior);
				}
			}
			this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_iterationsDone = 1;
			this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTraining and eventsFeatureWeightsPosterior and must reset on changes to numberOfIterationsDecreased and dummyWeightsPosterior and baseFeaturesTest and numEventsTest and eventsFeaturesTest and observedCountsTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11(bool initialise)
		{
			if ((this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_iterationsDone==1)&&((!initialise)||this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Message to 'vVector10_rep_rep' from Replicate factor
					this.vVector10_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.vVector10_rep_F[Ntest]);
				}
			}
			this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_iterationsDone = 1;
			this.Changed_evidence_numTraining_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_dummyWei11_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTraining and numEventsTest</summary>
		public void Changed_evidence_numTraining_numEventsTest()
		{
			if (this.Changed_evidence_numTraining_numEventsTest_iterationsDone==1) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for 'eventsContributionsTest_depth2' Backwards messages.
					this.eventsContributionsTest_depth2_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int _ind = 0; _ind<2; _ind++) {
						// Create array for 'eventsContributionsTest_uses' Backwards messages.
						this.eventsContributionsTest_uses_B[Ntest][_ind] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					}
					// Create array for 'eventsContributionsTest' Forwards messages.
					this.eventsContributionsTest_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.eventsContributionsTest_F[Ntest][Etest] = Gaussian.Uniform();
					}
					// Create array for 'vVector10_rep_rep' Backwards messages.
					this.vVector10_rep_rep_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				}
			}
			this.Changed_evidence_numTraining_numEventsTest_iterationsDone = 1;
			this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_iterationsDone = 0;
			this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTraining and numEventsTest and eventsFeatureWeightsPosterior and must reset on changes to numberOfIterationsDecreased and dummyWeightsPosterior and baseFeaturesTest and eventsFeaturesTest and observedCountsTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9(bool initialise)
		{
			if ((this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_iterationsDone==1)&&((!initialise)||this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.vVector10_rep_rep_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsFeatureWeightsPosterior);
					}
				}
			}
			this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_iterationsDone = 1;
			this.Changed_evidence_numTraining_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecr9_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTraining and numEventsTest and must reset on changes to numberOfIterationsDecreased and eventsFeatureWeightsPosterior and dummyWeightsPosterior and baseFeaturesTest and eventsFeaturesTest and observedCountsTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8(bool initialise)
		{
			if ((this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_iterationsDone==1)&&((!initialise)||this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.eventsContributionsTest_depth2_B[Ntest][Etest] = Gaussian.Uniform();
						for(int _ind = 0; _ind<2; _ind++) {
							this.eventsContributionsTest_uses_B[Ntest][_ind][Etest] = Gaussian.Uniform();
						}
					}
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDefInit<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_F[Ntest]);
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.MarginalInit<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_F[Ntest]);
				}
			}
			this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_iterationsDone = 1;
			this.Changed_evidence_numTraining_numEventsTest_Init_numberOfIterationsDecreased_eventsFeatureWeightsPost8_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTraining and must reset on changes to numberOfIterationsDecreased and eventsFeatureWeightsPosterior and dummyWeightsPosterior and baseFeaturesTest and numEventsTest and eventsFeaturesTest and observedCountsTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6(bool initialise)
		{
			if ((this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_iterationsDone==1)&&((!initialise)||this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Message to 'dummyContributionsTest_uses' from Replicate factor
					this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.MarginalInit<Gaussian>(this.dummyContributionsTest_F[Ntest]);
					for(int _ind = 0; _ind<2; _ind++) {
						this.dummyContributionsTest_uses_B[Ntest][_ind] = Gaussian.Uniform();
					}
					// Message to 'dummyContributionsTest_uses' from Replicate factor
					this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDefInit<Gaussian>(this.dummyContributionsTest_F[Ntest]);
				}
			}
			this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_iterationsDone = 1;
			this.Changed_evidence_numTraining_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterior_dummyWei6_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTraining and dummyWeightsPosterior and must reset on changes to numberOfIterationsDecreased and eventsFeatureWeightsPosterior and baseFeaturesTest and numEventsTest and eventsFeaturesTest and observedCountsTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4(bool initialise)
		{
			if ((this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_iterationsDone==1)&&((!initialise)||this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					this.vVector8_rep_B[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.DummyWeightsPosterior);
				}
			}
			this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_iterationsDone = 1;
			this.Changed_evidence_numTraining_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWei4_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and dummyWeightsPosterior and must reset on changes to numberOfIterationsDecreased and eventsFeatureWeightsPosterior and numTraining and baseFeaturesTest and numEventsTest and eventsFeaturesTest and observedCountsTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2(bool initialise)
		{
			if ((this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_iterationsDone==1)&&((!initialise)||this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_isInitialised)) {
				return ;
			}
			if (this.Evidence) {
				// Message to 'vVector8_rep' from Replicate factor
				this.vVector8_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.DummyWeightsPosterior);
				// Message to 'vVector8_rep' from Replicate factor
				this.vVector8_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.DummyWeightsPosterior);
			}
			this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_iterationsDone = 1;
			this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_eventsFeatureWeightsPosterio2_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numberOfIterationsDecreased and evidence and eventsFeatureWeightsPosterior and dummyWeightsPosterior and numTraining and baseFeaturesTest and numEventsTest and eventsFeaturesTest and observedCountsTest</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		public void Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5(int numberOfIterations)
		{
			if (this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone==numberOfIterations) {
				return ;
			}
			if (this.Evidence) {
				// Create array for 'vVector8_rep' Forwards messages.
				this.vVector8_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					this.vVector8_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.DummyWeightsPosterior);
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vVector8_rep_F_Ntest__BVariance'
				this.vVector8_rep_F_Ntest__BVariance = new PositiveDefiniteMatrix[this.NumTraining];
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Message to 'vdouble23' from InnerProduct factor
					this.vVector8_rep_F_Ntest__BVariance[Ntest] = InnerProductOp.BVarianceInit(this.vVector8_rep_F[Ntest]);
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vVector8_rep_F_Ntest__BMean'
				this.vVector8_rep_F_Ntest__BMean = new Vector[this.NumTraining];
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Message to 'vdouble23' from InnerProduct factor
					this.vVector8_rep_F_Ntest__BMean[Ntest] = InnerProductOp.BMeanInit(this.vVector8_rep_F[Ntest]);
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vdouble23_F'
				this.vdouble23_F = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					this.vdouble23_F[Ntest] = Gaussian.Uniform();
				}
			}
			if (this.Evidence) {
				// Create array for 'dummyContributionsTest_uses' Forwards messages.
				this.dummyContributionsTest_uses_F = new DistributionStructArray<Gaussian,double>[this.NumTraining];
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for 'dummyContributionsTest_uses' Forwards messages.
					this.dummyContributionsTest_uses_F[Ntest] = new DistributionStructArray<Gaussian,double>(2);
					for(int _ind = 0; _ind<2; _ind++) {
						this.dummyContributionsTest_uses_F[Ntest][_ind] = Gaussian.Uniform();
					}
				}
			}
			if (this.Evidence) {
				// Create array for 'eventsContributionsTest_uses' Forwards messages.
				this.eventsContributionsTest_uses_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[this.NumTraining];
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for 'eventsContributionsTest_uses' Forwards messages.
					this.eventsContributionsTest_uses_F[Ntest] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(2);
					for(int _ind = 0; _ind<2; _ind++) {
						// Create array for 'eventsContributionsTest_uses' Forwards messages.
						this.eventsContributionsTest_uses_F[Ntest][_ind] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
						for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
							this.eventsContributionsTest_uses_F[Ntest][_ind][Etest] = Gaussian.Uniform();
						}
					}
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vdouble31_B'
				this.vdouble31_B = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					this.vdouble31_B[Ntest] = Gaussian.Uniform();
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vdouble27_B'
				this.vdouble27_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for replicates of 'vdouble27_B'
					this.vdouble27_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.vdouble27_B[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vVector10_rep_rep_F_marginal'
				this.vVector10_rep_rep_F_marginal = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Message to 'vVector10_rep_rep' from Replicate factor
					this.vVector10_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.vVector10_rep_F[Ntest]);
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vVector10_rep_rep_F'
				this.vVector10_rep_rep_F = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for 'vVector10_rep_rep' Forwards messages.
					this.vVector10_rep_rep_F[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.vVector10_rep_rep_F[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsFeatureWeightsPosterior);
					}
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vVector10_rep_rep_F_Etest__BVariance'
				this.vVector10_rep_rep_F_Etest__BVariance = new PositiveDefiniteMatrix[this.NumTraining][];
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for replicates of 'vVector10_rep_rep_F_Etest__BVariance'
					this.vVector10_rep_rep_F_Etest__BVariance[Ntest] = new PositiveDefiniteMatrix[this.NumEventsTest[Ntest]];
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vdouble27' from InnerProduct factor
						this.vVector10_rep_rep_F_Etest__BVariance[Ntest][Etest] = InnerProductOp.BVarianceInit(this.vVector10_rep_rep_F[Ntest][Etest]);
					}
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vVector10_rep_rep_F_Etest__BMean'
				this.vVector10_rep_rep_F_Etest__BMean = new Vector[this.NumTraining][];
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for replicates of 'vVector10_rep_rep_F_Etest__BMean'
					this.vVector10_rep_rep_F_Etest__BMean[Ntest] = new Vector[this.NumEventsTest[Ntest]];
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vdouble27' from InnerProduct factor
						this.vVector10_rep_rep_F_Etest__BMean[Ntest][Etest] = InnerProductOp.BMeanInit(this.vVector10_rep_rep_F[Ntest][Etest]);
					}
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vdouble27_F'
				this.vdouble27_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for replicates of 'vdouble27_F'
					this.vdouble27_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.vdouble27_F[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vdouble31_F'
				this.vdouble31_F = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					this.vdouble31_F[Ntest] = Gaussian.Uniform();
				}
			}
			if (this.Evidence) {
				// Create array for replicates of 'vdouble23_B'
				this.vdouble23_B = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					this.vdouble23_B[Ntest] = Gaussian.Uniform();
				}
			}
			for(int iteration = this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone; iteration<numberOfIterations; iteration++) {
				if (this.Evidence) {
					// Message to 'vVector10_rep' from Replicate factor
					this.vVector10_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector10_rep_B_toDef, this.EventsFeatureWeightsPosterior, this.vVector10_rep_F_marginal);
					// Message to 'vVector8_rep' from Replicate factor
					this.vVector8_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector8_rep_B_toDef, this.DummyWeightsPosterior, this.vVector8_rep_F_marginal);
				}
				for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
					if (this.Evidence) {
						// Message to 'vVector8_rep' from Replicate factor
						this.vVector8_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector8_rep_B[Ntest], this.vVector8_rep_F_marginal, Ntest, this.vVector8_rep_F[Ntest]);
						// Message to 'vdouble23' from InnerProduct factor
						this.vVector8_rep_F_Ntest__BVariance[Ntest] = InnerProductOp.BVariance(this.vVector8_rep_F[Ntest], this.vVector8_rep_F_Ntest__BVariance[Ntest]);
						// Message to 'vdouble23' from InnerProduct factor
						this.vVector8_rep_F_Ntest__BMean[Ntest] = InnerProductOp.BMean(this.vVector8_rep_F[Ntest], this.vVector8_rep_F_Ntest__BVariance[Ntest], this.vVector8_rep_F_Ntest__BMean[Ntest]);
						// Message to 'vdouble23' from InnerProduct factor
						this.vdouble23_F[Ntest] = InnerProductOp.InnerProductAverageConditional(this.BaseFeaturesTest[Ntest], this.vVector8_rep_F_Ntest__BMean[Ntest], this.vVector8_rep_F_Ntest__BVariance[Ntest]);
						// Message to 'dummyContributionsTest' from GaussianFromMeanAndVariance factor
						this.dummyContributionsTest_F[Ntest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(this.vdouble23_F[Ntest], 5.0);
						// Message to 'vVector10_rep' from Replicate factor
						this.vVector10_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector10_rep_rep_B_toDef[Ntest], this.vVector10_rep_F_marginal, Ntest, this.vVector10_rep_F[Ntest]);
						// Message to 'vVector10_rep_rep' from Replicate factor
						this.vVector10_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector10_rep_rep_B_toDef[Ntest], this.vVector10_rep_F[Ntest], this.vVector10_rep_rep_F_marginal[Ntest]);
						for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
							// Message to 'vVector10_rep_rep' from Replicate factor
							this.vVector10_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector10_rep_rep_B[Ntest][Etest], this.vVector10_rep_rep_F_marginal[Ntest], Etest, this.vVector10_rep_rep_F[Ntest][Etest]);
							// Message to 'vdouble27' from InnerProduct factor
							this.vVector10_rep_rep_F_Etest__BVariance[Ntest][Etest] = InnerProductOp.BVariance(this.vVector10_rep_rep_F[Ntest][Etest], this.vVector10_rep_rep_F_Etest__BVariance[Ntest][Etest]);
							// Message to 'vdouble27' from InnerProduct factor
							this.vVector10_rep_rep_F_Etest__BMean[Ntest][Etest] = InnerProductOp.BMean(this.vVector10_rep_rep_F[Ntest][Etest], this.vVector10_rep_rep_F_Etest__BVariance[Ntest][Etest], this.vVector10_rep_rep_F_Etest__BMean[Ntest][Etest]);
							// Message to 'vdouble27' from InnerProduct factor
							this.vdouble27_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsFeaturesTest[Ntest][Etest], this.vVector10_rep_rep_F_Etest__BMean[Ntest][Etest], this.vVector10_rep_rep_F_Etest__BVariance[Ntest][Etest]);
							// Message to 'eventsContributionsTest' from GaussianFromMeanAndVariance factor
							this.eventsContributionsTest_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(this.vdouble27_F[Ntest][Etest], 5.0);
						}
						// Message to 'eventsContributionsTest_uses' from Replicate factor
						this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest], this.eventsContributionsTest_F[Ntest], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest]);
						// Message to 'eventsContributionsTest_uses' from Replicate factor
						this.eventsContributionsTest_uses_F[Ntest][1] = ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B[Ntest][1], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest], 1, this.eventsContributionsTest_uses_F[Ntest][1]);
						// Message to 'vdouble31' from Sum factor
						this.vdouble31_F[Ntest] = FastSumOp.SumAverageConditional(this.eventsContributionsTest_uses_F[Ntest][1]);
						// Message to 'dummyContributionsTest_uses' from Plus factor
						this.dummyContributionsTest_uses_B[Ntest][1] = DoublePlusOp.AAverageConditional(this.ObservedCountsTest[Ntest], this.vdouble31_F[Ntest]);
						// Message to 'dummyContributionsTest_uses' from Replicate factor
						this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<Gaussian>(this.dummyContributionsTest_uses_B[Ntest], this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest]);
						// Message to 'dummyContributionsTest_uses' from Replicate factor
						this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<Gaussian>(this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest], this.dummyContributionsTest_F[Ntest], this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest]);
						// Message to 'dummyContributionsTest_uses' from Replicate factor
						this.dummyContributionsTest_uses_F[Ntest][0] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.dummyContributionsTest_uses_B[Ntest][0], this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest], 0, this.dummyContributionsTest_uses_F[Ntest][0]);
						// Message to 'dummyContributionsTest_uses' from IsPositive factor
						this.dummyContributionsTest_uses_B[Ntest][0] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), this.dummyContributionsTest_uses_F[Ntest][0]);
						// Message to 'dummyContributionsTest_uses' from Replicate factor
						this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<Gaussian>(this.dummyContributionsTest_uses_B[Ntest], this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest]);
						// Message to 'dummyContributionsTest_uses' from Replicate factor
						this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<Gaussian>(this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest], this.dummyContributionsTest_F[Ntest], this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest]);
						// Message to 'dummyContributionsTest_uses' from Replicate factor
						this.dummyContributionsTest_uses_F[Ntest][1] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.dummyContributionsTest_uses_B[Ntest][1], this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest], 1, this.dummyContributionsTest_uses_F[Ntest][1]);
						// Message to 'vdouble31' from Plus factor
						this.vdouble31_B[Ntest] = DoublePlusOp.BAverageConditional(this.ObservedCountsTest[Ntest], this.dummyContributionsTest_uses_F[Ntest][1]);
						// Message to 'eventsContributionsTest_uses' from Sum factor
						this.eventsContributionsTest_uses_B[Ntest][1] = FastSumOp.ArrayAverageConditional<DistributionStructArray<Gaussian,double>>(this.vdouble31_B[Ntest], this.vdouble31_F[Ntest], this.eventsContributionsTest_uses_F[Ntest][1], this.eventsContributionsTest_uses_B[Ntest][1]);
						// Message to 'eventsContributionsTest_uses' from Replicate factor
						this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B[Ntest], this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest]);
						// Message to 'eventsContributionsTest_uses' from Replicate factor
						this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest], this.eventsContributionsTest_F[Ntest], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest]);
						// Message to 'eventsContributionsTest_uses' from Replicate factor
						this.eventsContributionsTest_uses_F[Ntest][0] = ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_depth2_B[Ntest], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest], 0, this.eventsContributionsTest_uses_F[Ntest][0]);
						for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
							// Message to 'eventsContributionsTest_depth2' from IsPositive factor
							this.eventsContributionsTest_depth2_B[Ntest][Etest] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), this.eventsContributionsTest_uses_F[Ntest][0][Etest]);
							// Message to 'eventsContributionsTest_uses' from Copy factor
							this.eventsContributionsTest_uses_B[Ntest][0][Etest] = ArrayHelper.SetTo<Gaussian>(this.eventsContributionsTest_uses_B[Ntest][0][Etest], this.eventsContributionsTest_depth2_B[Ntest][Etest]);
						}
						// Message to 'eventsContributionsTest_uses' from Replicate factor
						this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B[Ntest], this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest]);
						for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
							// Message to 'vdouble27' from GaussianFromMeanAndVariance factor
							this.vdouble27_B[Ntest][Etest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest][Etest], 5.0);
							// Message to 'vVector10_rep_rep' from InnerProduct factor
							this.vVector10_rep_rep_B[Ntest][Etest] = InnerProductOp.BAverageConditional(this.vdouble27_B[Ntest][Etest], this.EventsFeaturesTest[Ntest][Etest], this.vVector10_rep_rep_B[Ntest][Etest]);
						}
						// Message to 'vVector10_rep_rep' from Replicate factor
						this.vVector10_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector10_rep_rep_B[Ntest], this.vVector10_rep_rep_B_toDef[Ntest]);
						// Message to 'vdouble23' from GaussianFromMeanAndVariance factor
						this.vdouble23_B[Ntest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest], 5.0);
						// Message to 'vVector8_rep' from InnerProduct factor
						this.vVector8_rep_B[Ntest] = InnerProductOp.BAverageConditional(this.vdouble23_B[Ntest], this.BaseFeaturesTest[Ntest], this.vVector8_rep_B[Ntest]);
						this.vVector10_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<VectorGaussian>(this.vVector10_rep_F_marginal, this.vVector10_rep_F[Ntest], this.vVector10_rep_rep_B_toDef[Ntest]);
						this.vVector8_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<VectorGaussian>(this.vVector8_rep_F_marginal, this.vVector8_rep_F[Ntest], this.vVector8_rep_B[Ntest]);
					}
				}
				if (this.Evidence) {
					// Message to 'vVector8_rep' from Replicate factor
					this.vVector8_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector8_rep_B, this.vVector8_rep_B_toDef);
					// Message to 'vVector10_rep' from Replicate factor
					this.vVector10_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector10_rep_rep_B_toDef, this.vVector10_rep_B_toDef);
				}
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			if (this.Evidence) {
				this.vVector8_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.DummyWeightsPosterior);
				// Message to 'vVector8_marginal' from Variable factor
				this.vVector8_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector8_rep_B_toDef, this.DummyWeightsPosterior, this.vVector8_marginal_F);
				this.vVector10_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsFeatureWeightsPosterior);
				// Message to 'vVector10_marginal' from Variable factor
				this.vVector10_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector10_rep_B_toDef, this.EventsFeatureWeightsPosterior, this.vVector10_marginal_F);
				// Create array for 'dummyContributionsTest_marginal' Forwards messages.
				this.dummyContributionsTest_marginal_F = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					this.dummyContributionsTest_marginal_F[Ntest] = Gaussian.Uniform();
					// Message to 'dummyContributionsTest_marginal' from Variable factor
					this.dummyContributionsTest_marginal_F[Ntest] = VariableOp.MarginalAverageConditional<Gaussian>(this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest], this.dummyContributionsTest_F[Ntest], this.dummyContributionsTest_marginal_F[Ntest]);
				}
			}
			if (this.Evidence) {
				// Create array for 'eventsContributionsTest_marginal' Forwards messages.
				this.eventsContributionsTest_marginal_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTraining);
			}
			for(int Ntest = 0; Ntest<this.NumTraining; Ntest++) {
				if (this.Evidence) {
					// Create array for 'eventsContributionsTest_marginal' Forwards messages.
					this.eventsContributionsTest_marginal_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.eventsContributionsTest_marginal_F[Ntest][Etest] = Gaussian.Uniform();
						// Message to 'eventsContributionsTest_marginal' from Variable factor
						this.eventsContributionsTest_marginal_F[Ntest][Etest] = VariableOp.MarginalAverageConditional<Gaussian>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest][Etest], this.eventsContributionsTest_F[Ntest][Etest], this.eventsContributionsTest_marginal_F[Ntest][Etest]);
					}
				}
			}
			this.Changed_numberOfIterationsDecreased_evidence_eventsFeatureWeightsPosterior_dummyWeightsPosterior_num5_iterationsDone = numberOfIterations;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector8' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector8Marginal()
		{
			return this.vVector8_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'dummyContributionsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> DummyContributionsTestMarginal()
		{
			return this.dummyContributionsTest_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector10' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector10Marginal()
		{
			return this.vVector10_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsContributionsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> EventsContributionsTestMarginal()
		{
			return this.eventsContributionsTest_marginal_F;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTraining and dummyWeightsPosterior and baseFeaturesTest and numEventsTest and eventsFeatureWeightsPosterior and eventsFeaturesTest and observedCountsTest</summary>
		public void Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0()
		{
			if (this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone==1) {
				return ;
			}
			this.evidence_marginal = Bernoulli.Uniform();
			this.evidence_marginal = Distribution.SetPoint<Bernoulli,bool>(this.evidence_marginal, this.Evidence);
			this.numTraining_marginal = new PointMass<int>(this.NumTraining);
			this.dummyWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.DummyWeightsPosterior);
			this.baseFeaturesTest_marginal = new PointMass<Vector[]>(this.BaseFeaturesTest);
			this.numEventsTest_marginal = new PointMass<int[]>(this.NumEventsTest);
			this.eventsFeatureWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.EventsFeatureWeightsPosterior);
			this.eventsFeaturesTest_marginal = new PointMass<Vector[][]>(this.EventsFeaturesTest);
			this.observedCountsTest_marginal = new DistributionStructArray<Gaussian,double>(this.NumTraining, delegate(int Ntest) {
				return Gaussian.Uniform();
			});
			this.observedCountsTest_marginal = Distribution.SetPoint<DistributionStructArray<Gaussian,double>,double[]>(this.observedCountsTest_marginal, this.ObservedCountsTest);
			this.Changed_evidence_numTraining_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeigh0_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'evidence' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public Bernoulli EvidenceMarginal()
		{
			return this.evidence_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numTraining' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int> NumTrainingMarginal()
		{
			return this.numTraining_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'dummyWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> DummyWeightsPosteriorMarginal()
		{
			return this.dummyWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'baseFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[]> BaseFeaturesTestMarginal()
		{
			return this.baseFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numEventsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int[]> NumEventsTestMarginal()
		{
			return this.numEventsTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsFeatureWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> EventsFeatureWeightsPosteriorMarginal()
		{
			return this.eventsFeatureWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsFeaturesTestMarginal()
		{
			return this.eventsFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'observedCountsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> ObservedCountsTestMarginal()
		{
			return this.observedCountsTest_marginal;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
