using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Maths;
using MicrosoftResearch.Infer.Factors;
using MicrosoftResearch.Infer.Collections;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 23:58 on quinta-feira, 5 de Setembro de 2013.
	/// </remarks>
	public partial class Model2_EP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the numTesting property</summary>
		private int NumTesting;
		/// <summary>Field backing the routineWeightsPosterior property</summary>
		private VectorGaussian RoutineWeightsPosterior;
		/// <summary>Field backing the routineFeaturesTest property</summary>
		private Vector[] RoutineFeaturesTest;
		/// <summary>Field backing the numEventsTest property</summary>
		private int[] NumEventsTest;
		/// <summary>Field backing the eventsWeightsPosterior property</summary>
		private VectorGaussian EventsWeightsPosterior;
		/// <summary>Field backing the eventsStartTimeWeightsPosterior property</summary>
		private VectorGaussian EventsStartTimeWeightsPosterior;
		/// <summary>Field backing the eventsEndTimeWeightsPosterior property</summary>
		private VectorGaussian EventsEndTimeWeightsPosterior;
		/// <summary>Field backing the eventsFeaturesTest property</summary>
		private Vector[][] EventsFeaturesTest;
		/// <summary>Field backing the eventsStartTimeFeaturesTest property</summary>
		private Vector[][] EventsStartTimeFeaturesTest;
		/// <summary>Field backing the eventsMissingStartTimesTest property</summary>
		private bool[][] EventsMissingStartTimesTest;
		/// <summary>Field backing the eventsEndTimeFeaturesTest property</summary>
		private Vector[][] EventsEndTimeFeaturesTest;
		/// <summary>Field backing the eventsMissingEndTimesTest property</summary>
		private bool[][] EventsMissingEndTimesTest;
		/// <summary>Field backing the observedCountsTest property</summary>
		private double[] ObservedCountsTest;
		/// <summary>The number of iterations last computed by Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0. Set this to zero to force re-execution of Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0</summary>
		public int Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone;
		/// <summary>The number of iterations last computed by Constant. Set this to zero to force re-execution of Constant</summary>
		public int Constant_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2. Set this to zero to force re-execution of Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2</summary>
		public int Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_iterationsDone;
		/// <summary>True if Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2 has performed initialisation. Set this to false to force re-execution of Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2</summary>
		public bool Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting. Set this to zero to force re-execution of Changed_numTesting</summary>
		public int Changed_numTesting_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4. Set this to zero to force re-execution of Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4</summary>
		public int Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_iterationsDone;
		/// <summary>True if Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4</summary>
		public bool Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5. Set this to zero to force re-execution of Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5</summary>
		public int Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6. Set this to zero to force re-execution of Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6</summary>
		public int Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_iterationsDone;
		/// <summary>True if Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6</summary>
		public bool Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_numEventsTest. Set this to zero to force re-execution of Changed_numTesting_numEventsTest</summary>
		public int Changed_numTesting_numEventsTest_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8. Set this to zero to force re-execution of Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8</summary>
		public int Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_iterationsDone;
		/// <summary>True if Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8</summary>
		public bool Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9. Set this to zero to force re-execution of Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9</summary>
		public int Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_iterationsDone;
		/// <summary>True if Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9</summary>
		public bool Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsEndTimeWeightsPosterior. Set this to zero to force re-execution of Changed_numTesting_eventsEndTimeWeightsPosterior</summary>
		public int Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11. Set this to zero to force re-execution of Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11</summary>
		public int Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_iterationsDone;
		/// <summary>True if Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11</summary>
		public bool Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised;
		/// <summary>The number of iterations last computed by Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12. Set this to zero to force re-execution of Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12</summary>
		public int Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_iterationsDone;
		/// <summary>True if Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12 has performed initialisation. Set this to false to force re-execution of Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12</summary>
		public bool Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13. Set this to zero to force re-execution of Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13</summary>
		public int Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_iterationsDone;
		/// <summary>True if Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13</summary>
		public bool Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsStartTimeWeightsPosterior. Set this to zero to force re-execution of Changed_numTesting_eventsStartTimeWeightsPosterior</summary>
		public int Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15. Set this to zero to force re-execution of Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15</summary>
		public int Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_iterationsDone;
		/// <summary>True if Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15</summary>
		public bool Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised;
		/// <summary>The number of iterations last computed by Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16. Set this to zero to force re-execution of Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16</summary>
		public int Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_iterationsDone;
		/// <summary>True if Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16 has performed initialisation. Set this to false to force re-execution of Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16</summary>
		public bool Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17. Set this to zero to force re-execution of Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17</summary>
		public int Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_iterationsDone;
		/// <summary>True if Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17</summary>
		public bool Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsWeightsPosterior. Set this to zero to force re-execution of Changed_numTesting_eventsWeightsPosterior</summary>
		public int Changed_numTesting_eventsWeightsPosterior_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19. Set this to zero to force re-execution of Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19</summary>
		public int Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_iterationsDone;
		/// <summary>True if Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19 has performed initialisation. Set this to false to force re-execution of Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19</summary>
		public bool Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised;
		/// <summary>The number of iterations last computed by Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20. Set this to zero to force re-execution of Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20</summary>
		public int Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_iterationsDone;
		/// <summary>True if Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20 has performed initialisation. Set this to false to force re-execution of Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20</summary>
		public bool Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public VectorGaussian vVector22_rep_F_marginal;
		public DistributionRefArray<VectorGaussian,Vector> vVector22_rep_B;
		public DistributionStructArray<Gaussian,double> routineContributionsTest_F;
		/// <summary>Messages from use of 'routineContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double>[] routineContributionsTest_uses_B;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_depth2_B;
		/// <summary>Messages from use of 'eventsContributionsTest'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[] eventsContributionsTest_uses_B;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_F;
		public DistributionRefArray<VectorGaussian,Vector> vVector26_rep_F;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector26_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public VectorGaussian vVector26_rep_F_marginal;
		public DistributionRefArray<VectorGaussian,Vector> vVector25_rep_F;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector25_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public VectorGaussian vVector25_rep_F_marginal;
		public DistributionRefArray<VectorGaussian,Vector> vVector24_rep_F;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector24_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public VectorGaussian vVector24_rep_F_marginal;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector22_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<Gaussian></summary>
		public DistributionStructArray<Gaussian,double> routineContributionsTest_uses_F_Ntest__marginal;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>></summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_uses_B_Ntest__toDef;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector26_rep_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> vVector26_rep_rep_B_toDef;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector25_rep_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> vVector25_rep_rep_B_toDef;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector24_rep_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> vVector24_rep_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>></summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_uses_F_Ntest__marginal;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<Gaussian></summary>
		public DistributionStructArray<Gaussian,double> routineContributionsTest_uses_B_Ntest__toDef;
		/// <summary>Message to marginal of 'vVector22'</summary>
		public VectorGaussian vVector22_marginal_F;
		/// <summary>Message to marginal of 'vVector24'</summary>
		public VectorGaussian vVector24_marginal_F;
		/// <summary>Message to marginal of 'vVector25'</summary>
		public VectorGaussian vVector25_marginal_F;
		/// <summary>Message to marginal of 'vVector26'</summary>
		public VectorGaussian vVector26_marginal_F;
		/// <summary>Message to marginal of 'routineContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double> routineContributionsTest_marginal_F;
		/// <summary>Message to marginal of 'eventsContributionsTest'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_marginal_F;
		public PointMass<int> numTesting_marginal;
		public PointMass<VectorGaussian> routineWeightsPosterior_marginal;
		public PointMass<Vector[]> routineFeaturesTest_marginal;
		public PointMass<int[]> numEventsTest_marginal;
		public PointMass<VectorGaussian> eventsWeightsPosterior_marginal;
		public PointMass<VectorGaussian> eventsStartTimeWeightsPosterior_marginal;
		public PointMass<VectorGaussian> eventsEndTimeWeightsPosterior_marginal;
		public PointMass<Vector[][]> eventsFeaturesTest_marginal;
		public PointMass<Vector[][]> eventsStartTimeFeaturesTest_marginal;
		public DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> eventsMissingStartTimesTest_marginal;
		public PointMass<Vector[][]> eventsEndTimeFeaturesTest_marginal;
		public DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> eventsMissingEndTimesTest_marginal;
		public DistributionStructArray<Gaussian,double> observedCountsTest_marginal;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'numTesting'</summary>
		public int numTesting
		{			get {
				return this.NumTesting;
			}
			set {
				if (this.NumTesting!=value) {
					this.NumTesting = value;
					this.numberOfIterationsDone = 0;
					this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
					this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
					this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
					this.Changed_numTesting_iterationsDone = 0;
					this.Changed_numTesting_eventsWeightsPosterior_iterationsDone = 0;
					this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_iterationsDone = 0;
					this.Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone = 0;
					this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_iterationsDone = 0;
					this.Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone = 0;
					this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_iterationsDone = 0;
					this.Changed_numTesting_numEventsTest_iterationsDone = 0;
					this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_iterationsDone = 0;
					this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_iterationsDone = 0;
					this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_iterationsDone = 0;
					this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_iterationsDone = 0;
					this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_iterationsDone = 0;
					this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_iterationsDone = 0;
					this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
					this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
					this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'routineWeightsPosterior'</summary>
		public VectorGaussian routineWeightsPosterior
		{			get {
				return this.RoutineWeightsPosterior;
			}
			set {
				this.RoutineWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_iterationsDone = 0;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_iterationsDone = 0;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'routineFeaturesTest'</summary>
		public Vector[] routineFeaturesTest
		{			get {
				return this.RoutineFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'routineFeaturesTest\'");
				}
				this.RoutineFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'numEventsTest'</summary>
		public int[] numEventsTest
		{			get {
				return this.NumEventsTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'numEventsTest\'");
				}
				this.NumEventsTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_iterationsDone = 0;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsWeightsPosterior'</summary>
		public VectorGaussian eventsWeightsPosterior
		{			get {
				return this.EventsWeightsPosterior;
			}
			set {
				this.EventsWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_iterationsDone = 0;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_iterationsDone = 0;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_iterationsDone = 0;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsStartTimeWeightsPosterior'</summary>
		public VectorGaussian eventsStartTimeWeightsPosterior
		{			get {
				return this.EventsStartTimeWeightsPosterior;
			}
			set {
				this.EventsStartTimeWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_iterationsDone = 0;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone = 0;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_iterationsDone = 0;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsEndTimeWeightsPosterior'</summary>
		public VectorGaussian eventsEndTimeWeightsPosterior
		{			get {
				return this.EventsEndTimeWeightsPosterior;
			}
			set {
				this.EventsEndTimeWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_iterationsDone = 0;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone = 0;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsFeaturesTest'</summary>
		public Vector[][] eventsFeaturesTest
		{			get {
				return this.EventsFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsFeaturesTest\'");
				}
				this.EventsFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsStartTimeFeaturesTest'</summary>
		public Vector[][] eventsStartTimeFeaturesTest
		{			get {
				return this.EventsStartTimeFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsStartTimeFeaturesTest\'");
				}
				this.EventsStartTimeFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsMissingStartTimesTest'</summary>
		public bool[][] eventsMissingStartTimesTest
		{			get {
				return this.EventsMissingStartTimesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsMissingStartTimesTest\'");
				}
				this.EventsMissingStartTimesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsEndTimeFeaturesTest'</summary>
		public Vector[][] eventsEndTimeFeaturesTest
		{			get {
				return this.EventsEndTimeFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsEndTimeFeaturesTest\'");
				}
				this.EventsEndTimeFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsMissingEndTimesTest'</summary>
		public bool[][] eventsMissingEndTimesTest
		{			get {
				return this.EventsMissingEndTimesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsMissingEndTimesTest\'");
				}
				this.EventsMissingEndTimesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_iterationsDone = 0;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'observedCountsTest'</summary>
		public double[] observedCountsTest
		{			get {
				return this.ObservedCountsTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'observedCountsTest\'");
				}
				this.ObservedCountsTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
				this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="numTesting") {
				return this.numTesting;
			}
			if (variableName=="routineWeightsPosterior") {
				return this.routineWeightsPosterior;
			}
			if (variableName=="routineFeaturesTest") {
				return this.routineFeaturesTest;
			}
			if (variableName=="numEventsTest") {
				return this.numEventsTest;
			}
			if (variableName=="eventsWeightsPosterior") {
				return this.eventsWeightsPosterior;
			}
			if (variableName=="eventsStartTimeWeightsPosterior") {
				return this.eventsStartTimeWeightsPosterior;
			}
			if (variableName=="eventsEndTimeWeightsPosterior") {
				return this.eventsEndTimeWeightsPosterior;
			}
			if (variableName=="eventsFeaturesTest") {
				return this.eventsFeaturesTest;
			}
			if (variableName=="eventsStartTimeFeaturesTest") {
				return this.eventsStartTimeFeaturesTest;
			}
			if (variableName=="eventsMissingStartTimesTest") {
				return this.eventsMissingStartTimesTest;
			}
			if (variableName=="eventsEndTimeFeaturesTest") {
				return this.eventsEndTimeFeaturesTest;
			}
			if (variableName=="eventsMissingEndTimesTest") {
				return this.eventsMissingEndTimesTest;
			}
			if (variableName=="observedCountsTest") {
				return this.observedCountsTest;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="numTesting") {
				this.numTesting = (int)value;
				return ;
			}
			if (variableName=="routineWeightsPosterior") {
				this.routineWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="routineFeaturesTest") {
				this.routineFeaturesTest = (Vector[])value;
				return ;
			}
			if (variableName=="numEventsTest") {
				this.numEventsTest = (int[])value;
				return ;
			}
			if (variableName=="eventsWeightsPosterior") {
				this.eventsWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="eventsStartTimeWeightsPosterior") {
				this.eventsStartTimeWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="eventsEndTimeWeightsPosterior") {
				this.eventsEndTimeWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="eventsFeaturesTest") {
				this.eventsFeaturesTest = (Vector[][])value;
				return ;
			}
			if (variableName=="eventsStartTimeFeaturesTest") {
				this.eventsStartTimeFeaturesTest = (Vector[][])value;
				return ;
			}
			if (variableName=="eventsMissingStartTimesTest") {
				this.eventsMissingStartTimesTest = (bool[][])value;
				return ;
			}
			if (variableName=="eventsEndTimeFeaturesTest") {
				this.eventsEndTimeFeaturesTest = (Vector[][])value;
				return ;
			}
			if (variableName=="eventsMissingEndTimesTest") {
				this.eventsMissingEndTimesTest = (bool[][])value;
				return ;
			}
			if (variableName=="observedCountsTest") {
				this.observedCountsTest = (double[])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="vVector22") {
				return this.VVector22Marginal();
			}
			if (variableName=="routineContributionsTest") {
				return this.RoutineContributionsTestMarginal();
			}
			if (variableName=="vVector24") {
				return this.VVector24Marginal();
			}
			if (variableName=="vVector25") {
				return this.VVector25Marginal();
			}
			if (variableName=="vVector26") {
				return this.VVector26Marginal();
			}
			if (variableName=="eventsContributionsTest") {
				return this.EventsContributionsTestMarginal();
			}
			if (variableName=="numTesting") {
				return this.NumTestingMarginal();
			}
			if (variableName=="routineWeightsPosterior") {
				return this.RoutineWeightsPosteriorMarginal();
			}
			if (variableName=="routineFeaturesTest") {
				return this.RoutineFeaturesTestMarginal();
			}
			if (variableName=="numEventsTest") {
				return this.NumEventsTestMarginal();
			}
			if (variableName=="eventsWeightsPosterior") {
				return this.EventsWeightsPosteriorMarginal();
			}
			if (variableName=="eventsStartTimeWeightsPosterior") {
				return this.EventsStartTimeWeightsPosteriorMarginal();
			}
			if (variableName=="eventsEndTimeWeightsPosterior") {
				return this.EventsEndTimeWeightsPosteriorMarginal();
			}
			if (variableName=="eventsFeaturesTest") {
				return this.EventsFeaturesTestMarginal();
			}
			if (variableName=="eventsStartTimeFeaturesTest") {
				return this.EventsStartTimeFeaturesTestMarginal();
			}
			if (variableName=="eventsMissingStartTimesTest") {
				return this.EventsMissingStartTimesTestMarginal();
			}
			if (variableName=="eventsEndTimeFeaturesTest") {
				return this.EventsEndTimeFeaturesTestMarginal();
			}
			if (variableName=="eventsMissingEndTimesTest") {
				return this.EventsMissingEndTimesTestMarginal();
			}
			if (variableName=="observedCountsTest") {
				return this.ObservedCountsTestMarginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			if (numberOfIterations<this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone) {
				this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = false;
				this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = false;
				this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = false;
				this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = false;
				this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = false;
				this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = false;
				this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = false;
				this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = false;
				this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = false;
				this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = false;
				this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
			}
			this.Constant();
			this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20(initialise);
			this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16(initialise);
			this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12(initialise);
			this.Changed_numTesting();
			this.Changed_numTesting_eventsWeightsPosterior();
			this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19(initialise);
			this.Changed_numTesting_eventsStartTimeWeightsPosterior();
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15(initialise);
			this.Changed_numTesting_eventsEndTimeWeightsPosterior();
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11(initialise);
			this.Changed_numTesting_numEventsTest();
			this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17(initialise);
			this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13(initialise);
			this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9(initialise);
			this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8(initialise);
			this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6(initialise);
			this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4(initialise);
			this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2(initialise);
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5(numberOfIterations);
			this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that do not depend on observed values</summary>
		public void Constant()
		{
			if (this.Constant_iterationsDone==1) {
				return ;
			}
			this.Constant_iterationsDone = 1;
			this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_iterationsDone = 0;
			this.Changed_numTesting_iterationsDone = 0;
			this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_iterationsDone = 0;
			this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_iterationsDone = 0;
			this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of eventsWeightsPosterior and must reset on changes to numberOfIterationsDecreased and numTesting and numEventsTest and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20(bool initialise)
		{
			if ((this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_iterationsDone==1)&&((!initialise)||this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised)) {
				return ;
			}
			// Message to 'vVector24_rep' from Replicate factor
			this.vVector24_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.EventsWeightsPosterior);
			// Message to 'vVector24_rep' from Replicate factor
			this.vVector24_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.EventsWeightsPosterior);
			this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_iterationsDone = 1;
			this.Changed_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_numEventsTest_eventsMissi20_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of eventsStartTimeWeightsPosterior and must reset on changes to numberOfIterationsDecreased and eventsWeightsPosterior and numTesting and numEventsTest and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsEndTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16(bool initialise)
		{
			if ((this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_iterationsDone==1)&&((!initialise)||this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised)) {
				return ;
			}
			// Message to 'vVector25_rep' from Replicate factor
			this.vVector25_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
			// Message to 'vVector25_rep' from Replicate factor
			this.vVector25_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
			this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_iterationsDone = 1;
			this.Changed_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numT16_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of eventsEndTimeWeightsPosterior and must reset on changes to numberOfIterationsDecreased and eventsWeightsPosterior and numTesting and numEventsTest and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12(bool initialise)
		{
			if ((this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_iterationsDone==1)&&((!initialise)||this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised)) {
				return ;
			}
			// Message to 'vVector26_rep' from Replicate factor
			this.vVector26_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
			// Message to 'vVector26_rep' from Replicate factor
			this.vVector26_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
			this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_iterationsDone = 1;
			this.Changed_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTes12_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting</summary>
		public void Changed_numTesting()
		{
			if (this.Changed_numTesting_iterationsDone==1) {
				return ;
			}
			// Create array for 'vVector22_rep' Backwards messages.
			this.vVector22_rep_B = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for 'routineContributionsTest' Forwards messages.
			this.routineContributionsTest_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.routineContributionsTest_F[Ntest] = Gaussian.Uniform();
			}
			// Create array for replicates of 'routineContributionsTest_uses_F_Ntest__marginal'
			this.routineContributionsTest_uses_F_Ntest__marginal = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			// Create array for 'routineContributionsTest_uses' Backwards messages.
			this.routineContributionsTest_uses_B = new DistributionStructArray<Gaussian,double>[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'routineContributionsTest_uses' Backwards messages.
				this.routineContributionsTest_uses_B[Ntest] = new DistributionStructArray<Gaussian,double>(2);
			}
			// Create array for 'eventsContributionsTest_depth2' Backwards messages.
			this.eventsContributionsTest_depth2_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			// Create array for 'eventsContributionsTest_uses' Backwards messages.
			this.eventsContributionsTest_uses_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'eventsContributionsTest_uses' Backwards messages.
				this.eventsContributionsTest_uses_B[Ntest] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(2);
			}
			// Create array for 'eventsContributionsTest' Forwards messages.
			this.eventsContributionsTest_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			// Create array for replicates of 'eventsContributionsTest_uses_B_Ntest__toDef'
			this.eventsContributionsTest_uses_B_Ntest__toDef = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			// Create array for replicates of 'vVector26_rep_rep_B'
			this.vVector26_rep_rep_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			// Create array for 'vVector26_rep' Forwards messages.
			this.vVector26_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'vVector26_rep_rep_B_toDef'
			this.vVector26_rep_rep_B_toDef = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'vVector25_rep_rep_B'
			this.vVector25_rep_rep_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			// Create array for 'vVector25_rep' Forwards messages.
			this.vVector25_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'vVector25_rep_rep_B_toDef'
			this.vVector25_rep_rep_B_toDef = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'vVector24_rep_rep_B'
			this.vVector24_rep_rep_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			// Create array for 'vVector24_rep' Forwards messages.
			this.vVector24_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'vVector24_rep_rep_B_toDef'
			this.vVector24_rep_rep_B_toDef = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			// Create array for replicates of 'eventsContributionsTest_uses_F_Ntest__marginal'
			this.eventsContributionsTest_uses_F_Ntest__marginal = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			// Create array for replicates of 'routineContributionsTest_uses_B_Ntest__toDef'
			this.routineContributionsTest_uses_B_Ntest__toDef = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			this.Changed_numTesting_iterationsDone = 1;
			this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_iterationsDone = 0;
			this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_iterationsDone = 0;
			this.Changed_numTesting_numEventsTest_iterationsDone = 0;
			this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_iterationsDone = 0;
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone = 0;
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_iterationsDone = 0;
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone = 0;
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_iterationsDone = 0;
			this.Changed_numTesting_eventsWeightsPosterior_iterationsDone = 0;
			this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsWeightsPosterior</summary>
		public void Changed_numTesting_eventsWeightsPosterior()
		{
			if (this.Changed_numTesting_eventsWeightsPosterior_iterationsDone==1) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.vVector24_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsWeightsPosterior);
			}
			this.Changed_numTesting_eventsWeightsPosterior_iterationsDone = 1;
			this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsWeightsPosterior and must reset on changes to numberOfIterationsDecreased and numEventsTest and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19(bool initialise)
		{
			if ((this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector24_rep_rep' from Replicate factor
				this.vVector24_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.vVector24_rep_F[Ntest]);
			}
			this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_iterationsDone = 1;
			this.Changed_numTesting_eventsWeightsPosterior_Init_numberOfIterationsDecreased_numEventsTest_eventsMissi19_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsStartTimeWeightsPosterior</summary>
		public void Changed_numTesting_eventsStartTimeWeightsPosterior()
		{
			if (this.Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone==1) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.vVector25_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
			}
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_iterationsDone = 1;
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsStartTimeWeightsPosterior and must reset on changes to numberOfIterationsDecreased and eventsWeightsPosterior and numEventsTest and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsEndTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15(bool initialise)
		{
			if ((this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector25_rep_rep' from Replicate factor
				this.vVector25_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.vVector25_rep_F[Ntest]);
			}
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_iterationsDone = 1;
			this.Changed_numTesting_eventsStartTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPos15_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsEndTimeWeightsPosterior</summary>
		public void Changed_numTesting_eventsEndTimeWeightsPosterior()
		{
			if (this.Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone==1) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.vVector26_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
			}
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_iterationsDone = 1;
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and eventsEndTimeWeightsPosterior and must reset on changes to numberOfIterationsDecreased and eventsWeightsPosterior and numEventsTest and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11(bool initialise)
		{
			if ((this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector26_rep_rep' from Replicate factor
				this.vVector26_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.vVector26_rep_F[Ntest]);
			}
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_iterationsDone = 1;
			this.Changed_numTesting_eventsEndTimeWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPoste11_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and numEventsTest</summary>
		public void Changed_numTesting_numEventsTest()
		{
			if (this.Changed_numTesting_numEventsTest_iterationsDone==1) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'eventsContributionsTest_depth2' Backwards messages.
				this.eventsContributionsTest_depth2_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int _ind = 0; _ind<2; _ind++) {
					// Create array for 'eventsContributionsTest_uses' Backwards messages.
					this.eventsContributionsTest_uses_B[Ntest][_ind] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				}
				// Create array for 'eventsContributionsTest' Forwards messages.
				this.eventsContributionsTest_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.eventsContributionsTest_F[Ntest][Etest] = Gaussian.Uniform();
				}
				// Create array for 'vVector26_rep_rep' Backwards messages.
				this.vVector26_rep_rep_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				// Create array for 'vVector25_rep_rep' Backwards messages.
				this.vVector25_rep_rep_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				// Create array for 'vVector24_rep_rep' Backwards messages.
				this.vVector24_rep_rep_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
			}
			this.Changed_numTesting_numEventsTest_iterationsDone = 1;
			this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_iterationsDone = 0;
			this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_iterationsDone = 0;
			this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_iterationsDone = 0;
			this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and numEventsTest and eventsWeightsPosterior and must reset on changes to numberOfIterationsDecreased and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17(bool initialise)
		{
			if ((this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.vVector24_rep_rep_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsWeightsPosterior);
				}
			}
			this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_iterationsDone = 1;
			this.Changed_numTesting_numEventsTest_eventsWeightsPosterior_Init_numberOfIterationsDecreased_eventsMissi17_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and numEventsTest and eventsStartTimeWeightsPosterior and eventsMissingStartTimesTest and must reset on changes to numberOfIterationsDecreased and eventsWeightsPosterior and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsEndTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13(bool initialise)
		{
			if ((this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.vVector25_rep_rep_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
				}
			}
			this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_iterationsDone = 1;
			this.Changed_numTesting_numEventsTest_eventsStartTimeWeightsPosterior_eventsMissingStartTimesTest_Init_nu13_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and numEventsTest and eventsEndTimeWeightsPosterior and eventsMissingEndTimesTest and must reset on changes to numberOfIterationsDecreased and eventsWeightsPosterior and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9(bool initialise)
		{
			if ((this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.vVector26_rep_rep_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
				}
			}
			this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_iterationsDone = 1;
			this.Changed_numTesting_numEventsTest_eventsEndTimeWeightsPosterior_eventsMissingEndTimesTest_Init_number9_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and numEventsTest and must reset on changes to numberOfIterationsDecreased and eventsWeightsPosterior and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8(bool initialise)
		{
			if ((this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.eventsContributionsTest_depth2_B[Ntest][Etest] = Gaussian.Uniform();
					for(int _ind = 0; _ind<2; _ind++) {
						this.eventsContributionsTest_uses_B[Ntest][_ind][Etest] = Gaussian.Uniform();
					}
				}
				// Message to 'eventsContributionsTest_uses' from Replicate factor
				this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDefInit<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_F[Ntest]);
				// Message to 'eventsContributionsTest_uses' from Replicate factor
				this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.MarginalInit<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_F[Ntest]);
			}
			this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_iterationsDone = 1;
			this.Changed_numTesting_numEventsTest_Init_numberOfIterationsDecreased_eventsWeightsPosterior_eventsMissi8_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and must reset on changes to numberOfIterationsDecreased and eventsWeightsPosterior and numEventsTest and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6(bool initialise)
		{
			if ((this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'routineContributionsTest_uses' from Replicate factor
				this.routineContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.MarginalInit<Gaussian>(this.routineContributionsTest_F[Ntest]);
				for(int _ind = 0; _ind<2; _ind++) {
					this.routineContributionsTest_uses_B[Ntest][_ind] = Gaussian.Uniform();
				}
				// Message to 'routineContributionsTest_uses' from Replicate factor
				this.routineContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDefInit<Gaussian>(this.routineContributionsTest_F[Ntest]);
			}
			this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_iterationsDone = 1;
			this.Changed_numTesting_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numEventsTest_eventsMissi6_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numTesting and routineWeightsPosterior and must reset on changes to numberOfIterationsDecreased and eventsWeightsPosterior and numEventsTest and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4(bool initialise)
		{
			if ((this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_iterationsDone==1)&&((!initialise)||this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised)) {
				return ;
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.vVector22_rep_B[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.RoutineWeightsPosterior);
			}
			this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_iterationsDone = 1;
			this.Changed_numTesting_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_n4_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of routineWeightsPosterior and must reset on changes to numberOfIterationsDecreased and eventsWeightsPosterior and numTesting and numEventsTest and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2(bool initialise)
		{
			if ((this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_iterationsDone==1)&&((!initialise)||this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised)) {
				return ;
			}
			// Message to 'vVector22_rep' from Replicate factor
			this.vVector22_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.RoutineWeightsPosterior);
			// Message to 'vVector22_rep' from Replicate factor
			this.vVector22_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.RoutineWeightsPosterior);
			this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_iterationsDone = 1;
			this.Changed_routineWeightsPosterior_Init_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_n2_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numberOfIterationsDecreased and eventsWeightsPosterior and numTesting and numEventsTest and eventsMissingStartTimesTest and eventsStartTimeFeaturesTest and eventsMissingEndTimesTest and eventsEndTimeFeaturesTest and routineWeightsPosterior and routineFeaturesTest and eventsFeaturesTest and observedCountsTest and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		public void Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5(int numberOfIterations)
		{
			if (this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone==numberOfIterations) {
				return ;
			}
			DistributionRefArray<VectorGaussian,Vector> vVector22_rep_F = default(DistributionRefArray<VectorGaussian,Vector>);
			// Create array for 'vVector22_rep' Forwards messages.
			vVector22_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				vVector22_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.RoutineWeightsPosterior);
			}
			// Buffer for InnerProductOp.BMean
			// Create array for replicates of 'vVector22_rep_F_Ntest__BVariance'
			PositiveDefiniteMatrix[] vVector22_rep_F_Ntest__BVariance = new PositiveDefiniteMatrix[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vdouble49' from InnerProduct factor
				vVector22_rep_F_Ntest__BVariance[Ntest] = InnerProductOp.BVarianceInit(vVector22_rep_F[Ntest]);
			}
			// Buffer for InnerProductOp.InnerProductAverageConditional
			// Create array for replicates of 'vVector22_rep_F_Ntest__BMean'
			Vector[] vVector22_rep_F_Ntest__BMean = new Vector[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vdouble49' from InnerProduct factor
				vVector22_rep_F_Ntest__BMean[Ntest] = InnerProductOp.BMeanInit(vVector22_rep_F[Ntest]);
			}
			// Create array for replicates of 'vdouble49_F'
			DistributionStructArray<Gaussian,double> vdouble49_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				vdouble49_F[Ntest] = Gaussian.Uniform();
			}
			// Messages to use of 'routineContributionsTest'
			DistributionStructArray<Gaussian,double>[] routineContributionsTest_uses_F = default(DistributionStructArray<Gaussian,double>[]);
			// Create array for 'routineContributionsTest_uses' Forwards messages.
			routineContributionsTest_uses_F = new DistributionStructArray<Gaussian,double>[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'routineContributionsTest_uses' Forwards messages.
				routineContributionsTest_uses_F[Ntest] = new DistributionStructArray<Gaussian,double>(2);
				for(int _ind = 0; _ind<2; _ind++) {
					routineContributionsTest_uses_F[Ntest][_ind] = Gaussian.Uniform();
				}
			}
			// Messages to use of 'eventsContributionsTest'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[] eventsContributionsTest_uses_F = default(DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[]);
			// Create array for 'eventsContributionsTest_uses' Forwards messages.
			eventsContributionsTest_uses_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[this.NumTesting];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'eventsContributionsTest_uses' Forwards messages.
				eventsContributionsTest_uses_F[Ntest] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(2);
				for(int _ind = 0; _ind<2; _ind++) {
					// Create array for 'eventsContributionsTest_uses' Forwards messages.
					eventsContributionsTest_uses_F[Ntest][_ind] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						eventsContributionsTest_uses_F[Ntest][_ind][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble73_B'
			DistributionStructArray<Gaussian,double> vdouble73_B = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				vdouble73_B[Ntest] = Gaussian.Uniform();
			}
			// Create array for replicates of 'vdouble57_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble57_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble57_B'
				vdouble57_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble57_B[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble64_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble64_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble64_B'
				vdouble64_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						vdouble64_B[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B'
				vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
					}
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			// Create array for replicates of 'vVector26_rep_rep_F_marginal'
			DistributionRefArray<VectorGaussian,Vector> vVector26_rep_rep_F_marginal = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector26_rep_rep' from Replicate factor
				vVector26_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.vVector26_rep_F[Ntest]);
			}
			// Create array for replicates of 'vVector26_rep_rep_F'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector26_rep_rep_F = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'vVector26_rep_rep' Forwards messages.
				vVector26_rep_rep_F[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vVector26_rep_rep_F[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
				}
			}
			// Buffer for InnerProductOp.BMean
			// Create array for replicates of 'vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance'
			PositiveDefiniteMatrix[][] vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance = new PositiveDefiniteMatrix[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance'
				vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest] = new PositiveDefiniteMatrix[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						// Message to 'vdouble64' from InnerProduct factor
						vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVarianceInit(vVector26_rep_rep_F[Ntest][Etest]);
					}
				}
			}
			// Buffer for InnerProductOp.InnerProductAverageConditional
			// Create array for replicates of 'vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean'
			Vector[][] vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean = new Vector[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean'
				vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest] = new Vector[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						// Message to 'vdouble64' from InnerProduct factor
						vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMeanInit(vVector26_rep_rep_F[Ntest][Etest]);
					}
				}
			}
			// Create array for replicates of 'vdouble64_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble64_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble64_F'
				vdouble64_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						vdouble64_F[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble57_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble57_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble57_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F'
				vdouble57_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						vdouble57_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble57_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble57_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble57_F'
				vdouble57_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble57_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			Gaussian _hoist2 = default(Gaussian);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingEndTimesTest[Ntest][Etest]) {
						_hoist2 = Gaussian.Uniform();
						Ntest = this.NumTesting-1;
						Etest = this.NumEventsTest[Ntest]-1;
					}
				}
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingEndTimesTest[Ntest][Etest]) {
						_hoist2 = GaussianOpBase.SampleAverageConditional(0.0, 1.0);
						Ntest = this.NumTesting-1;
						Etest = this.NumEventsTest[Ntest]-1;
					}
				}
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingEndTimesTest[Ntest][Etest]) {
						// Message to 'vdouble57' from Copy factor
						vdouble57_F[Ntest][Etest] = ArrayHelper.SetTo<Gaussian>(vdouble57_F[Ntest][Etest], _hoist2);
					}
				}
			}
			// Create array for replicates of 'vdouble70_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble70_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble70_B'
				vdouble70_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble70_B[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble56_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble56_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble56_B'
				vdouble56_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble56_B[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble58_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble58_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble58_B'
				vdouble58_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						vdouble58_B[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B'
				vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
					}
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			// Create array for replicates of 'vVector25_rep_rep_F_marginal'
			DistributionRefArray<VectorGaussian,Vector> vVector25_rep_rep_F_marginal = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector25_rep_rep' from Replicate factor
				vVector25_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.vVector25_rep_F[Ntest]);
			}
			// Create array for replicates of 'vVector25_rep_rep_F'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector25_rep_rep_F = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'vVector25_rep_rep' Forwards messages.
				vVector25_rep_rep_F[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vVector25_rep_rep_F[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
				}
			}
			// Buffer for InnerProductOp.BMean
			// Create array for replicates of 'vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance'
			PositiveDefiniteMatrix[][] vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance = new PositiveDefiniteMatrix[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance'
				vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest] = new PositiveDefiniteMatrix[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						// Message to 'vdouble58' from InnerProduct factor
						vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVarianceInit(vVector25_rep_rep_F[Ntest][Etest]);
					}
				}
			}
			// Buffer for InnerProductOp.InnerProductAverageConditional
			// Create array for replicates of 'vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean'
			Vector[][] vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean = new Vector[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean'
				vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest] = new Vector[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						// Message to 'vdouble58' from InnerProduct factor
						vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMeanInit(vVector25_rep_rep_F[Ntest][Etest]);
					}
				}
			}
			// Create array for replicates of 'vdouble58_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble58_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble58_F'
				vdouble58_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						vdouble58_F[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble56_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble56_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble56_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F'
				vdouble56_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						vdouble56_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F[Ntest][Etest] = Gaussian.Uniform();
					}
				}
			}
			// Create array for replicates of 'vdouble56_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble56_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble56_F'
				vdouble56_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble56_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			Gaussian _hoist = default(Gaussian);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingStartTimesTest[Ntest][Etest]) {
						_hoist = Gaussian.Uniform();
						Ntest = this.NumTesting-1;
						Etest = this.NumEventsTest[Ntest]-1;
					}
				}
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingStartTimesTest[Ntest][Etest]) {
						_hoist = GaussianOpBase.SampleAverageConditional(0.0, 1.0);
						Ntest = this.NumTesting-1;
						Etest = this.NumEventsTest[Ntest]-1;
					}
				}
			}
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					if (this.EventsMissingStartTimesTest[Ntest][Etest]) {
						// Message to 'vdouble56' from Copy factor
						vdouble56_F[Ntest][Etest] = ArrayHelper.SetTo<Gaussian>(vdouble56_F[Ntest][Etest], _hoist);
					}
				}
			}
			// Message from use of 'vdouble55'
			// Create array for replicates of 'vdouble55_use_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble55_use_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble55_use_B'
				vdouble55_use_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble55_use_B[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble53_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble53_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble53_B'
				vdouble53_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble53_B[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>
			// Create array for replicates of 'vVector24_rep_rep_F_marginal'
			DistributionRefArray<VectorGaussian,Vector> vVector24_rep_rep_F_marginal = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector24_rep_rep' from Replicate factor
				vVector24_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.vVector24_rep_F[Ntest]);
			}
			// Create array for replicates of 'vVector24_rep_rep_F'
			DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector24_rep_rep_F = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'vVector24_rep_rep' Forwards messages.
				vVector24_rep_rep_F[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vVector24_rep_rep_F[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsWeightsPosterior);
				}
			}
			// Buffer for InnerProductOp.BMean
			// Create array for replicates of 'vVector24_rep_rep_F_Etest__BVariance'
			PositiveDefiniteMatrix[][] vVector24_rep_rep_F_Etest__BVariance = new PositiveDefiniteMatrix[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector24_rep_rep_F_Etest__BVariance'
				vVector24_rep_rep_F_Etest__BVariance[Ntest] = new PositiveDefiniteMatrix[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					// Message to 'vdouble53' from InnerProduct factor
					vVector24_rep_rep_F_Etest__BVariance[Ntest][Etest] = InnerProductOp.BVarianceInit(vVector24_rep_rep_F[Ntest][Etest]);
				}
			}
			// Buffer for InnerProductOp.InnerProductAverageConditional
			// Create array for replicates of 'vVector24_rep_rep_F_Etest__BMean'
			Vector[][] vVector24_rep_rep_F_Etest__BMean = new Vector[this.NumTesting][];
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vVector24_rep_rep_F_Etest__BMean'
				vVector24_rep_rep_F_Etest__BMean[Ntest] = new Vector[this.NumEventsTest[Ntest]];
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					// Message to 'vdouble53' from InnerProduct factor
					vVector24_rep_rep_F_Etest__BMean[Ntest][Etest] = InnerProductOp.BMeanInit(vVector24_rep_rep_F[Ntest][Etest]);
				}
			}
			// Create array for replicates of 'vdouble53_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble53_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble53_F'
				vdouble53_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble53_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble55_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble55_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble55_F'
				vdouble55_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble55_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble70_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble70_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for replicates of 'vdouble70_F'
				vdouble70_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble70_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble73_F'
			DistributionStructArray<Gaussian,double> vdouble73_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				vdouble73_F[Ntest] = Gaussian.Uniform();
			}
			// Create array for replicates of 'vdouble49_B'
			DistributionStructArray<Gaussian,double> vdouble49_B = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				vdouble49_B[Ntest] = Gaussian.Uniform();
			}
			// Message to 'vVector25_rep' from Replicate factor
			this.vVector25_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector25_rep_B_toDef, this.EventsStartTimeWeightsPosterior, this.vVector25_rep_F_marginal);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector25_rep' from Replicate factor
				this.vVector25_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector25_rep_rep_B_toDef[Ntest], this.vVector25_rep_F_marginal, Ntest, this.vVector25_rep_F[Ntest]);
				this.vVector25_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<VectorGaussian>(this.vVector25_rep_F_marginal, this.vVector25_rep_F[Ntest], this.vVector25_rep_rep_B_toDef[Ntest]);
				// Message to 'vVector25_rep_rep' from Replicate factor
				vVector25_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector25_rep_rep_B_toDef[Ntest], this.vVector25_rep_F[Ntest], vVector25_rep_rep_F_marginal[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					// Message to 'vVector25_rep_rep' from Replicate factor
					vVector25_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector25_rep_rep_B[Ntest][Etest], vVector25_rep_rep_F_marginal[Ntest], Etest, vVector25_rep_rep_F[Ntest][Etest]);
					if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
						// Message to 'vdouble58' from InnerProduct factor
						vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector25_rep_rep_F[Ntest][Etest], vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
						// Message to 'vdouble58' from InnerProduct factor
						vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMean(vVector25_rep_rep_F[Ntest][Etest], vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest], vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest]);
					}
				}
			}
			// Message to 'vVector26_rep' from Replicate factor
			this.vVector26_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector26_rep_B_toDef, this.EventsEndTimeWeightsPosterior, this.vVector26_rep_F_marginal);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Message to 'vVector26_rep' from Replicate factor
				this.vVector26_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector26_rep_rep_B_toDef[Ntest], this.vVector26_rep_F_marginal, Ntest, this.vVector26_rep_F[Ntest]);
				this.vVector26_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<VectorGaussian>(this.vVector26_rep_F_marginal, this.vVector26_rep_F[Ntest], this.vVector26_rep_rep_B_toDef[Ntest]);
				// Message to 'vVector26_rep_rep' from Replicate factor
				vVector26_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector26_rep_rep_B_toDef[Ntest], this.vVector26_rep_F[Ntest], vVector26_rep_rep_F_marginal[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					// Message to 'vVector26_rep_rep' from Replicate factor
					vVector26_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector26_rep_rep_B[Ntest][Etest], vVector26_rep_rep_F_marginal[Ntest], Etest, vVector26_rep_rep_F[Ntest][Etest]);
					if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
						// Message to 'vdouble64' from InnerProduct factor
						vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector26_rep_rep_F[Ntest][Etest], vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
						// Message to 'vdouble64' from InnerProduct factor
						vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMean(vVector26_rep_rep_F[Ntest][Etest], vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest], vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest]);
					}
				}
			}
			for(int iteration = this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone; iteration<numberOfIterations; iteration++) {
				// Message to 'vVector24_rep' from Replicate factor
				this.vVector24_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector24_rep_B_toDef, this.EventsWeightsPosterior, this.vVector24_rep_F_marginal);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
							// Message to 'vdouble58' from InnerProduct factor
							vdouble58_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsStartTimeFeaturesTest[Ntest][Etest], vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest], vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
							// Message to 'vdouble56_cond_eventsMissingStartTimesTest_Ntest__Etest__1' from GaussianFromMeanAndVariance factor
							vdouble56_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble58_F[Ntest][Etest], 1.0);
							// Message to 'vdouble56' from Copy factor
							vdouble56_F[Ntest][Etest] = ArrayHelper.SetTo<Gaussian>(vdouble56_F[Ntest][Etest], vdouble56_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F[Ntest][Etest]);
						}
					}
				}
				// vdouble56_F[Ntest][Etest] is now updated in all contexts
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
							// Message to 'vdouble64' from InnerProduct factor
							vdouble64_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsEndTimeFeaturesTest[Ntest][Etest], vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest], vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
							// Message to 'vdouble57_cond_eventsMissingEndTimesTest_Ntest__Etest__1' from GaussianFromMeanAndVariance factor
							vdouble57_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble64_F[Ntest][Etest], 1.0);
							// Message to 'vdouble57' from Copy factor
							vdouble57_F[Ntest][Etest] = ArrayHelper.SetTo<Gaussian>(vdouble57_F[Ntest][Etest], vdouble57_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F[Ntest][Etest]);
						}
					}
				}
				// vdouble57_F[Ntest][Etest] is now updated in all contexts
				// Message to 'vVector22_rep' from Replicate factor
				this.vVector22_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector22_rep_B_toDef, this.RoutineWeightsPosterior, this.vVector22_rep_F_marginal);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector22_rep' from Replicate factor
					vVector22_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector22_rep_B[Ntest], this.vVector22_rep_F_marginal, Ntest, vVector22_rep_F[Ntest]);
					// Message to 'vdouble49' from InnerProduct factor
					vVector22_rep_F_Ntest__BVariance[Ntest] = InnerProductOp.BVariance(vVector22_rep_F[Ntest], vVector22_rep_F_Ntest__BVariance[Ntest]);
					// Message to 'vdouble49' from InnerProduct factor
					vVector22_rep_F_Ntest__BMean[Ntest] = InnerProductOp.BMean(vVector22_rep_F[Ntest], vVector22_rep_F_Ntest__BVariance[Ntest], vVector22_rep_F_Ntest__BMean[Ntest]);
					// Message to 'vdouble49' from InnerProduct factor
					vdouble49_F[Ntest] = InnerProductOp.InnerProductAverageConditional(this.RoutineFeaturesTest[Ntest], vVector22_rep_F_Ntest__BMean[Ntest], vVector22_rep_F_Ntest__BVariance[Ntest]);
					// Message to 'routineContributionsTest' from GaussianFromMeanAndVariance factor
					this.routineContributionsTest_F[Ntest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble49_F[Ntest], 1.0);
					// Message to 'vVector24_rep' from Replicate factor
					this.vVector24_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector24_rep_rep_B_toDef[Ntest], this.vVector24_rep_F_marginal, Ntest, this.vVector24_rep_F[Ntest]);
					// Message to 'vVector24_rep_rep' from Replicate factor
					vVector24_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector24_rep_rep_B_toDef[Ntest], this.vVector24_rep_F[Ntest], vVector24_rep_rep_F_marginal[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vVector24_rep_rep' from Replicate factor
						vVector24_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector24_rep_rep_B[Ntest][Etest], vVector24_rep_rep_F_marginal[Ntest], Etest, vVector24_rep_rep_F[Ntest][Etest]);
						// Message to 'vdouble53' from InnerProduct factor
						vVector24_rep_rep_F_Etest__BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector24_rep_rep_F[Ntest][Etest], vVector24_rep_rep_F_Etest__BVariance[Ntest][Etest]);
						// Message to 'vdouble53' from InnerProduct factor
						vVector24_rep_rep_F_Etest__BMean[Ntest][Etest] = InnerProductOp.BMean(vVector24_rep_rep_F[Ntest][Etest], vVector24_rep_rep_F_Etest__BVariance[Ntest][Etest], vVector24_rep_rep_F_Etest__BMean[Ntest][Etest]);
						// Message to 'vdouble53' from InnerProduct factor
						vdouble53_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsFeaturesTest[Ntest][Etest], vVector24_rep_rep_F_Etest__BMean[Ntest][Etest], vVector24_rep_rep_F_Etest__BVariance[Ntest][Etest]);
						// Message to 'vdouble55' from GaussianFromMeanAndVariance factor
						vdouble55_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble53_F[Ntest][Etest], 1.0);
						// Message to 'vdouble70' from Plus factor
						vdouble70_F[Ntest][Etest] = DoublePlusOp.SumAverageConditional(vdouble55_F[Ntest][Etest], vdouble56_F[Ntest][Etest]);
						// Message to 'eventsContributionsTest' from Plus factor
						this.eventsContributionsTest_F[Ntest][Etest] = DoublePlusOp.SumAverageConditional(vdouble70_F[Ntest][Etest], vdouble57_F[Ntest][Etest]);
					}
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest], this.eventsContributionsTest_F[Ntest], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest]);
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					eventsContributionsTest_uses_F[Ntest][1] = ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B[Ntest][1], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest], 1, eventsContributionsTest_uses_F[Ntest][1]);
					// Message to 'vdouble73' from Sum factor
					vdouble73_F[Ntest] = FastSumOp.SumAverageConditional(eventsContributionsTest_uses_F[Ntest][1]);
					// Message to 'routineContributionsTest_uses' from Plus factor
					this.routineContributionsTest_uses_B[Ntest][1] = DoublePlusOp.AAverageConditional(this.ObservedCountsTest[Ntest], vdouble73_F[Ntest]);
					// Message to 'routineContributionsTest_uses' from Replicate factor
					this.routineContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<Gaussian>(this.routineContributionsTest_uses_B[Ntest], this.routineContributionsTest_uses_B_Ntest__toDef[Ntest]);
					// Message to 'routineContributionsTest_uses' from Replicate factor
					this.routineContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<Gaussian>(this.routineContributionsTest_uses_B_Ntest__toDef[Ntest], this.routineContributionsTest_F[Ntest], this.routineContributionsTest_uses_F_Ntest__marginal[Ntest]);
					// Message to 'routineContributionsTest_uses' from Replicate factor
					routineContributionsTest_uses_F[Ntest][0] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.routineContributionsTest_uses_B[Ntest][0], this.routineContributionsTest_uses_F_Ntest__marginal[Ntest], 0, routineContributionsTest_uses_F[Ntest][0]);
					// Message to 'routineContributionsTest_uses' from IsPositive factor
					this.routineContributionsTest_uses_B[Ntest][0] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), routineContributionsTest_uses_F[Ntest][0]);
					// Message to 'routineContributionsTest_uses' from Replicate factor
					this.routineContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<Gaussian>(this.routineContributionsTest_uses_B[Ntest], this.routineContributionsTest_uses_B_Ntest__toDef[Ntest]);
					// Message to 'routineContributionsTest_uses' from Replicate factor
					this.routineContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<Gaussian>(this.routineContributionsTest_uses_B_Ntest__toDef[Ntest], this.routineContributionsTest_F[Ntest], this.routineContributionsTest_uses_F_Ntest__marginal[Ntest]);
					// Message to 'routineContributionsTest_uses' from Replicate factor
					routineContributionsTest_uses_F[Ntest][1] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.routineContributionsTest_uses_B[Ntest][1], this.routineContributionsTest_uses_F_Ntest__marginal[Ntest], 1, routineContributionsTest_uses_F[Ntest][1]);
					// Message to 'vdouble73' from Plus factor
					vdouble73_B[Ntest] = DoublePlusOp.BAverageConditional(this.ObservedCountsTest[Ntest], routineContributionsTest_uses_F[Ntest][1]);
					// Message to 'eventsContributionsTest_uses' from Sum factor
					this.eventsContributionsTest_uses_B[Ntest][1] = FastSumOp.ArrayAverageConditional<DistributionStructArray<Gaussian,double>>(vdouble73_B[Ntest], vdouble73_F[Ntest], eventsContributionsTest_uses_F[Ntest][1], this.eventsContributionsTest_uses_B[Ntest][1]);
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B[Ntest], this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest]);
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest], this.eventsContributionsTest_F[Ntest], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest]);
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					eventsContributionsTest_uses_F[Ntest][0] = ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_depth2_B[Ntest], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest], 0, eventsContributionsTest_uses_F[Ntest][0]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'eventsContributionsTest_depth2' from IsPositive factor
						this.eventsContributionsTest_depth2_B[Ntest][Etest] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), eventsContributionsTest_uses_F[Ntest][0][Etest]);
						// Message to 'eventsContributionsTest_uses' from Copy factor
						this.eventsContributionsTest_uses_B[Ntest][0][Etest] = ArrayHelper.SetTo<Gaussian>(this.eventsContributionsTest_uses_B[Ntest][0][Etest], this.eventsContributionsTest_depth2_B[Ntest][Etest]);
					}
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B[Ntest], this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vdouble70' from Plus factor
						vdouble70_B[Ntest][Etest] = DoublePlusOp.AAverageConditional(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest][Etest], vdouble57_F[Ntest][Etest]);
						// Message to 'vdouble55_use' from Plus factor
						vdouble55_use_B[Ntest][Etest] = DoublePlusOp.AAverageConditional(vdouble70_B[Ntest][Etest], vdouble56_F[Ntest][Etest]);
						// Message to 'vdouble53' from GaussianFromMeanAndVariance factor
						vdouble53_B[Ntest][Etest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(vdouble55_use_B[Ntest][Etest], 1.0);
						// Message to 'vVector24_rep_rep' from InnerProduct factor
						this.vVector24_rep_rep_B[Ntest][Etest] = InnerProductOp.BAverageConditional(vdouble53_B[Ntest][Etest], this.EventsFeaturesTest[Ntest][Etest], this.vVector24_rep_rep_B[Ntest][Etest]);
					}
					// Message to 'vVector24_rep_rep' from Replicate factor
					this.vVector24_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector24_rep_rep_B[Ntest], this.vVector24_rep_rep_B_toDef[Ntest]);
					// Message to 'vdouble49' from GaussianFromMeanAndVariance factor
					vdouble49_B[Ntest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(this.routineContributionsTest_uses_B_Ntest__toDef[Ntest], 1.0);
					// Message to 'vVector22_rep' from InnerProduct factor
					this.vVector22_rep_B[Ntest] = InnerProductOp.BAverageConditional(vdouble49_B[Ntest], this.RoutineFeaturesTest[Ntest], this.vVector22_rep_B[Ntest]);
					this.vVector24_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<VectorGaussian>(this.vVector24_rep_F_marginal, this.vVector24_rep_F[Ntest], this.vVector24_rep_rep_B_toDef[Ntest]);
					this.vVector22_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<VectorGaussian>(this.vVector22_rep_F_marginal, vVector22_rep_F[Ntest], this.vVector22_rep_B[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vdouble56' from Plus factor
						vdouble56_B[Ntest][Etest] = DoublePlusOp.BAverageConditional(vdouble70_B[Ntest][Etest], vdouble55_F[Ntest][Etest]);
						if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
							// Message to 'vdouble58' from GaussianFromMeanAndVariance factor
							vdouble58_B[Ntest][Etest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(vdouble56_B[Ntest][Etest], 1.0);
							// Message to 'vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1' from InnerProduct factor
							vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B[Ntest][Etest] = InnerProductOp.BAverageConditional(vdouble58_B[Ntest][Etest], this.EventsStartTimeFeaturesTest[Ntest][Etest], vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B[Ntest][Etest]);
							// Message to 'vVector25_rep_rep' from Copy factor
							this.vVector25_rep_rep_B[Ntest][Etest] = ArrayHelper.SetTo<VectorGaussian>(this.vVector25_rep_rep_B[Ntest][Etest], vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_B[Ntest][Etest]);
						}
					}
					// Message to 'vVector25_rep_rep' from Replicate factor
					this.vVector25_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector25_rep_rep_B[Ntest], this.vVector25_rep_rep_B_toDef[Ntest]);
				}
				// Message to 'vVector25_rep' from Replicate factor
				this.vVector25_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector25_rep_rep_B_toDef, this.vVector25_rep_B_toDef);
				// Message to 'vVector25_rep' from Replicate factor
				this.vVector25_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector25_rep_B_toDef, this.EventsStartTimeWeightsPosterior, this.vVector25_rep_F_marginal);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector25_rep' from Replicate factor
					this.vVector25_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector25_rep_rep_B_toDef[Ntest], this.vVector25_rep_F_marginal, Ntest, this.vVector25_rep_F[Ntest]);
					this.vVector25_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<VectorGaussian>(this.vVector25_rep_F_marginal, this.vVector25_rep_F[Ntest], this.vVector25_rep_rep_B_toDef[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vdouble57' from Plus factor
						vdouble57_B[Ntest][Etest] = DoublePlusOp.BAverageConditional(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest][Etest], vdouble70_F[Ntest][Etest]);
						if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
							// Message to 'vdouble64' from GaussianFromMeanAndVariance factor
							vdouble64_B[Ntest][Etest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(vdouble57_B[Ntest][Etest], 1.0);
							// Message to 'vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1' from InnerProduct factor
							vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B[Ntest][Etest] = InnerProductOp.BAverageConditional(vdouble64_B[Ntest][Etest], this.EventsEndTimeFeaturesTest[Ntest][Etest], vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B[Ntest][Etest]);
							// Message to 'vVector26_rep_rep' from Copy factor
							this.vVector26_rep_rep_B[Ntest][Etest] = ArrayHelper.SetTo<VectorGaussian>(this.vVector26_rep_rep_B[Ntest][Etest], vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_B[Ntest][Etest]);
						}
					}
					// Message to 'vVector26_rep_rep' from Replicate factor
					this.vVector26_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector26_rep_rep_B[Ntest], this.vVector26_rep_rep_B_toDef[Ntest]);
				}
				// Message to 'vVector26_rep' from Replicate factor
				this.vVector26_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector26_rep_rep_B_toDef, this.vVector26_rep_B_toDef);
				// Message to 'vVector26_rep' from Replicate factor
				this.vVector26_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector26_rep_B_toDef, this.EventsEndTimeWeightsPosterior, this.vVector26_rep_F_marginal);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector26_rep' from Replicate factor
					this.vVector26_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector26_rep_rep_B_toDef[Ntest], this.vVector26_rep_F_marginal, Ntest, this.vVector26_rep_F[Ntest]);
					this.vVector26_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<VectorGaussian>(this.vVector26_rep_F_marginal, this.vVector26_rep_F[Ntest], this.vVector26_rep_rep_B_toDef[Ntest]);
				}
				// Message to 'vVector22_rep' from Replicate factor
				this.vVector22_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector22_rep_B, this.vVector22_rep_B_toDef);
				// Message to 'vVector24_rep' from Replicate factor
				this.vVector24_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector24_rep_rep_B_toDef, this.vVector24_rep_B_toDef);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector25_rep_rep' from Replicate factor
					vVector25_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector25_rep_rep_B_toDef[Ntest], this.vVector25_rep_F[Ntest], vVector25_rep_rep_F_marginal[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vVector25_rep_rep' from Replicate factor
						vVector25_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector25_rep_rep_B[Ntest][Etest], vVector25_rep_rep_F_marginal[Ntest], Etest, vVector25_rep_rep_F[Ntest][Etest]);
						if (!this.EventsMissingStartTimesTest[Ntest][Etest]) {
							// Message to 'vdouble58' from InnerProduct factor
							vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector25_rep_rep_F[Ntest][Etest], vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
							// Message to 'vdouble58' from InnerProduct factor
							vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMean(vVector25_rep_rep_F[Ntest][Etest], vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest], vVector25_cond_eventsMissingStartTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest]);
						}
					}
					// Message to 'vVector26_rep_rep' from Replicate factor
					vVector26_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector26_rep_rep_B_toDef[Ntest], this.vVector26_rep_F[Ntest], vVector26_rep_rep_F_marginal[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vVector26_rep_rep' from Replicate factor
						vVector26_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector26_rep_rep_B[Ntest][Etest], vVector26_rep_rep_F_marginal[Ntest], Etest, vVector26_rep_rep_F[Ntest][Etest]);
						if (!this.EventsMissingEndTimesTest[Ntest][Etest]) {
							// Message to 'vdouble64' from InnerProduct factor
							vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest] = InnerProductOp.BVariance(vVector26_rep_rep_F[Ntest][Etest], vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest]);
							// Message to 'vdouble64' from InnerProduct factor
							vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest] = InnerProductOp.BMean(vVector26_rep_rep_F[Ntest][Etest], vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BVariance[Ntest][Etest], vVector26_cond_eventsMissingEndTimesTest_Ntest__Etest__1_F_BMean[Ntest][Etest]);
						}
					}
				}
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			this.vVector22_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.RoutineWeightsPosterior);
			// Message to 'vVector22_marginal' from Variable factor
			this.vVector22_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector22_rep_B_toDef, this.RoutineWeightsPosterior, this.vVector22_marginal_F);
			this.vVector24_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsWeightsPosterior);
			// Message to 'vVector24_marginal' from Variable factor
			this.vVector24_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector24_rep_B_toDef, this.EventsWeightsPosterior, this.vVector24_marginal_F);
			this.vVector25_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
			// Message to 'vVector25_marginal' from Variable factor
			this.vVector25_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector25_rep_B_toDef, this.EventsStartTimeWeightsPosterior, this.vVector25_marginal_F);
			this.vVector26_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
			// Message to 'vVector26_marginal' from Variable factor
			this.vVector26_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector26_rep_B_toDef, this.EventsEndTimeWeightsPosterior, this.vVector26_marginal_F);
			// Create array for 'routineContributionsTest_marginal' Forwards messages.
			this.routineContributionsTest_marginal_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				this.routineContributionsTest_marginal_F[Ntest] = Gaussian.Uniform();
				// Message to 'routineContributionsTest_marginal' from Variable factor
				this.routineContributionsTest_marginal_F[Ntest] = VariableOp.MarginalAverageConditional<Gaussian>(this.routineContributionsTest_uses_B_Ntest__toDef[Ntest], this.routineContributionsTest_F[Ntest], this.routineContributionsTest_marginal_F[Ntest]);
			}
			// Create array for 'eventsContributionsTest_marginal' Forwards messages.
			this.eventsContributionsTest_marginal_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
				// Create array for 'eventsContributionsTest_marginal' Forwards messages.
				this.eventsContributionsTest_marginal_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.eventsContributionsTest_marginal_F[Ntest][Etest] = Gaussian.Uniform();
					// Message to 'eventsContributionsTest_marginal' from DerivedVariable factor
					this.eventsContributionsTest_marginal_F[Ntest][Etest] = DerivedVariableOp.MarginalAverageConditional<Gaussian>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest][Etest], this.eventsContributionsTest_F[Ntest][Etest], this.eventsContributionsTest_marginal_F[Ntest][Etest]);
				}
			}
			this.Changed_numberOfIterationsDecreased_eventsWeightsPosterior_numTesting_numEventsTest_eventsMissingSta5_iterationsDone = numberOfIterations;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector22' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector22Marginal()
		{
			return this.vVector22_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineContributionsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> RoutineContributionsTestMarginal()
		{
			return this.routineContributionsTest_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector24' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector24Marginal()
		{
			return this.vVector24_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector25' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector25Marginal()
		{
			return this.vVector25_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector26' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector26Marginal()
		{
			return this.vVector26_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsContributionsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> EventsContributionsTestMarginal()
		{
			return this.eventsContributionsTest_marginal_F;
		}

		/// <summary>Computations that depend on the observed value of numTesting and routineWeightsPosterior and routineFeaturesTest and numEventsTest and eventsWeightsPosterior and eventsStartTimeWeightsPosterior and eventsEndTimeWeightsPosterior and eventsFeaturesTest and eventsStartTimeFeaturesTest and eventsMissingStartTimesTest and eventsEndTimeFeaturesTest and eventsMissingEndTimesTest and observedCountsTest</summary>
		public void Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0()
		{
			if (this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone==1) {
				return ;
			}
			this.numTesting_marginal = new PointMass<int>(this.NumTesting);
			this.routineWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.RoutineWeightsPosterior);
			this.routineFeaturesTest_marginal = new PointMass<Vector[]>(this.RoutineFeaturesTest);
			this.numEventsTest_marginal = new PointMass<int[]>(this.NumEventsTest);
			this.eventsWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.EventsWeightsPosterior);
			this.eventsStartTimeWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.EventsStartTimeWeightsPosterior);
			this.eventsEndTimeWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.EventsEndTimeWeightsPosterior);
			this.eventsFeaturesTest_marginal = new PointMass<Vector[][]>(this.EventsFeaturesTest);
			this.eventsStartTimeFeaturesTest_marginal = new PointMass<Vector[][]>(this.EventsStartTimeFeaturesTest);
			this.eventsMissingStartTimesTest_marginal = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(this.NumTesting, delegate(int Ntest) {
				return new DistributionStructArray<Bernoulli,bool>(this.NumEventsTest[Ntest], delegate(int Etest) {
					return Bernoulli.Uniform();
				});
			});
			this.eventsMissingStartTimesTest_marginal = Distribution.SetPoint<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>(this.eventsMissingStartTimesTest_marginal, this.EventsMissingStartTimesTest);
			this.eventsEndTimeFeaturesTest_marginal = new PointMass<Vector[][]>(this.EventsEndTimeFeaturesTest);
			this.eventsMissingEndTimesTest_marginal = new DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>(this.NumTesting, delegate(int Ntest) {
				return new DistributionStructArray<Bernoulli,bool>(this.NumEventsTest[Ntest], delegate(int Etest) {
					return Bernoulli.Uniform();
				});
			});
			this.eventsMissingEndTimesTest_marginal = Distribution.SetPoint<DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]>,bool[][]>(this.eventsMissingEndTimesTest_marginal, this.EventsMissingEndTimesTest);
			this.observedCountsTest_marginal = new DistributionStructArray<Gaussian,double>(this.NumTesting, delegate(int Ntest) {
				return Gaussian.Uniform();
			});
			this.observedCountsTest_marginal = Distribution.SetPoint<DistributionStructArray<Gaussian,double>,double[]>(this.observedCountsTest_marginal, this.ObservedCountsTest);
			this.Changed_numTesting_routineWeightsPosterior_routineFeaturesTest_numEventsTest_eventsWeightsPosterior_0_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numTesting' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int> NumTestingMarginal()
		{
			return this.numTesting_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> RoutineWeightsPosteriorMarginal()
		{
			return this.routineWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[]> RoutineFeaturesTestMarginal()
		{
			return this.routineFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numEventsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int[]> NumEventsTestMarginal()
		{
			return this.numEventsTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> EventsWeightsPosteriorMarginal()
		{
			return this.eventsWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsStartTimeWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> EventsStartTimeWeightsPosteriorMarginal()
		{
			return this.eventsStartTimeWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsEndTimeWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> EventsEndTimeWeightsPosteriorMarginal()
		{
			return this.eventsEndTimeWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsFeaturesTestMarginal()
		{
			return this.eventsFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsStartTimeFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsStartTimeFeaturesTestMarginal()
		{
			return this.eventsStartTimeFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsMissingStartTimesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> EventsMissingStartTimesTestMarginal()
		{
			return this.eventsMissingStartTimesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsEndTimeFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsEndTimeFeaturesTestMarginal()
		{
			return this.eventsEndTimeFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsMissingEndTimesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Bernoulli,bool>,bool[]> EventsMissingEndTimesTestMarginal()
		{
			return this.eventsMissingEndTimesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'observedCountsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> ObservedCountsTestMarginal()
		{
			return this.observedCountsTest_marginal;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
