using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Maths;
using MicrosoftResearch.Infer.Collections;
using MicrosoftResearch.Infer.Factors;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 03:01 on sexta-feira, 6 de Setembro de 2013.
	/// </remarks>
	public partial class Model6_EP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the priorRoutine property</summary>
		private SparseGP PriorRoutine;
		/// <summary>Field backing the priorEvents property</summary>
		private SparseGP PriorEvents;
		/// <summary>Field backing the routineFeaturesTrain property</summary>
		private Vector[] RoutineFeaturesTrain;
		/// <summary>Field backing the numEventsTrain property</summary>
		private int[] NumEventsTrain;
		/// <summary>Field backing the eventsFeaturesTrain property</summary>
		private Vector[][] EventsFeaturesTrain;
		/// <summary>Field backing the observedCountsTrain property</summary>
		private double[] ObservedCountsTrain;
		/// <summary>The number of iterations last computed by Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0. Set this to zero to force re-execution of Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0</summary>
		public int Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0_iterationsDone;
		/// <summary>The number of iterations last computed by Constant. Set this to zero to force re-execution of Constant</summary>
		public int Constant_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2. Set this to zero to force re-execution of Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2</summary>
		public int Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_iterationsDone;
		/// <summary>True if Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2 has performed initialisation. Set this to false to force re-execution of Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2</summary>
		public bool Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3. Set this to zero to force re-execution of Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3</summary>
		public int Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numEventsTrain. Set this to zero to force re-execution of Changed_numEventsTrain</summary>
		public int Changed_numEventsTrain_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5. Set this to zero to force re-execution of Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5</summary>
		public int Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_iterationsDone;
		/// <summary>True if Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5 has performed initialisation. Set this to false to force re-execution of Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5</summary>
		public bool Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_isInitialised;
		/// <summary>The number of iterations last computed by Changed_priorEvents. Set this to zero to force re-execution of Changed_priorEvents</summary>
		public int Changed_priorEvents_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7. Set this to zero to force re-execution of Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7</summary>
		public int Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_iterationsDone;
		/// <summary>True if Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7 has performed initialisation. Set this to false to force re-execution of Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7</summary>
		public bool Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_isInitialised;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<SparseGP></summary>
		public SparseGP fRoutineTrain_rep_F_marginal;
		public DistributionRefArray<SparseGP,IFunction> fRoutineTrain_rep_B;
		public DistributionRefArray<DistributionRefArray<SparseGP,IFunction>,IFunction[]> fEventsTrain_rep_rep_B;
		public DistributionRefArray<SparseGP,IFunction> fEventsTrain_rep_F;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<SparseGP></summary>
		public DistributionRefArray<SparseGP,IFunction> fEventsTrain_rep_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<SparseGP></summary>
		public SparseGP fEventsTrain_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<SparseGP></summary>
		public SparseGP fEventsTrain_rep_F_marginal;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<SparseGP></summary>
		public SparseGP fRoutineTrain_rep_B_toDef;
		/// <summary>Message to marginal of 'fRoutineTrain'</summary>
		public SparseGP fRoutineTrain_marginal_F;
		/// <summary>Message to marginal of 'fEventsTrain'</summary>
		public SparseGP fEventsTrain_marginal_F;
		/// <summary>Message to marginal of 'routineContributionsTrain'</summary>
		public DistributionStructArray<Gaussian,double> routineContributionsTrain_marginal_F;
		/// <summary>Message to marginal of 'eventsContributionsTrain'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTrain_marginal_F;
		public PointMass<SparseGP> priorRoutine_marginal;
		public PointMass<SparseGP> priorEvents_marginal;
		public PointMass<Vector[]> routineFeaturesTrain_marginal;
		public PointMass<int[]> numEventsTrain_marginal;
		public PointMass<Vector[][]> eventsFeaturesTrain_marginal;
		public DistributionStructArray<Gaussian,double> observedCountsTrain_marginal;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'priorRoutine'</summary>
		public SparseGP priorRoutine
		{			get {
				return this.PriorRoutine;
			}
			set {
				this.PriorRoutine = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_isInitialised = false;
				this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_isInitialised = false;
				this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_iterationsDone = 0;
				this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'priorEvents'</summary>
		public SparseGP priorEvents
		{			get {
				return this.PriorEvents;
			}
			set {
				this.PriorEvents = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_iterationsDone = 0;
				this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_iterationsDone = 0;
				this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_iterationsDone = 0;
				this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'routineFeaturesTrain'</summary>
		public Vector[] routineFeaturesTrain
		{			get {
				return this.RoutineFeaturesTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=4031)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+4031)+" was expected for variable \'routineFeaturesTrain\'");
				}
				this.RoutineFeaturesTrain = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_isInitialised = false;
				this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_isInitialised = false;
				this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'numEventsTrain'</summary>
		public int[] numEventsTrain
		{			get {
				return this.NumEventsTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=4031)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+4031)+" was expected for variable \'numEventsTrain\'");
				}
				this.NumEventsTrain = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_isInitialised = false;
				this.Changed_numEventsTrain_iterationsDone = 0;
				this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_iterationsDone = 0;
				this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsFeaturesTrain'</summary>
		public Vector[][] eventsFeaturesTrain
		{			get {
				return this.EventsFeaturesTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=4031)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+4031)+" was expected for variable \'eventsFeaturesTrain\'");
				}
				this.EventsFeaturesTrain = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_isInitialised = false;
				this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_isInitialised = false;
				this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'observedCountsTrain'</summary>
		public double[] observedCountsTrain
		{			get {
				return this.ObservedCountsTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=4031)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+4031)+" was expected for variable \'observedCountsTrain\'");
				}
				this.ObservedCountsTrain = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_isInitialised = false;
				this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_isInitialised = false;
				this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="priorRoutine") {
				return this.priorRoutine;
			}
			if (variableName=="priorEvents") {
				return this.priorEvents;
			}
			if (variableName=="routineFeaturesTrain") {
				return this.routineFeaturesTrain;
			}
			if (variableName=="numEventsTrain") {
				return this.numEventsTrain;
			}
			if (variableName=="eventsFeaturesTrain") {
				return this.eventsFeaturesTrain;
			}
			if (variableName=="observedCountsTrain") {
				return this.observedCountsTrain;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="priorRoutine") {
				this.priorRoutine = (SparseGP)value;
				return ;
			}
			if (variableName=="priorEvents") {
				this.priorEvents = (SparseGP)value;
				return ;
			}
			if (variableName=="routineFeaturesTrain") {
				this.routineFeaturesTrain = (Vector[])value;
				return ;
			}
			if (variableName=="numEventsTrain") {
				this.numEventsTrain = (int[])value;
				return ;
			}
			if (variableName=="eventsFeaturesTrain") {
				this.eventsFeaturesTrain = (Vector[][])value;
				return ;
			}
			if (variableName=="observedCountsTrain") {
				this.observedCountsTrain = (double[])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="fRoutineTrain") {
				return this.FRoutineTrainMarginal();
			}
			if (variableName=="fEventsTrain") {
				return this.FEventsTrainMarginal();
			}
			if (variableName=="routineContributionsTrain") {
				return this.RoutineContributionsTrainMarginal();
			}
			if (variableName=="eventsContributionsTrain") {
				return this.EventsContributionsTrainMarginal();
			}
			if (variableName=="priorRoutine") {
				return this.PriorRoutineMarginal();
			}
			if (variableName=="priorEvents") {
				return this.PriorEventsMarginal();
			}
			if (variableName=="routineFeaturesTrain") {
				return this.RoutineFeaturesTrainMarginal();
			}
			if (variableName=="numEventsTrain") {
				return this.NumEventsTrainMarginal();
			}
			if (variableName=="eventsFeaturesTrain") {
				return this.EventsFeaturesTrainMarginal();
			}
			if (variableName=="observedCountsTrain") {
				return this.ObservedCountsTrainMarginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			if (numberOfIterations<this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone) {
				this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_isInitialised = false;
				this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_isInitialised = false;
				this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
			}
			this.Constant();
			this.Changed_priorEvents();
			this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7(initialise);
			this.Changed_numEventsTrain();
			this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5(initialise);
			this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2(initialise);
			this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3(numberOfIterations);
			this.Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that do not depend on observed values</summary>
		public void Constant()
		{
			if (this.Constant_iterationsDone==1) {
				return ;
			}
			// Create array for 'fRoutineTrain_rep' Backwards messages.
			this.fRoutineTrain_rep_B = new DistributionRefArray<SparseGP,IFunction>(4031);
			// Create array for replicates of 'fEventsTrain_rep_rep_B'
			this.fEventsTrain_rep_rep_B = new DistributionRefArray<DistributionRefArray<SparseGP,IFunction>,IFunction[]>(4031);
			// Create array for 'fEventsTrain_rep' Forwards messages.
			this.fEventsTrain_rep_F = new DistributionRefArray<SparseGP,IFunction>(4031);
			// Create array for replicates of 'fEventsTrain_rep_rep_B_toDef'
			this.fEventsTrain_rep_rep_B_toDef = new DistributionRefArray<SparseGP,IFunction>(4031);
			this.Constant_iterationsDone = 1;
			this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_iterationsDone = 0;
			this.Changed_numEventsTrain_iterationsDone = 0;
			this.Changed_priorEvents_iterationsDone = 0;
			this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of priorEvents</summary>
		public void Changed_priorEvents()
		{
			if (this.Changed_priorEvents_iterationsDone==1) {
				return ;
			}
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				this.fEventsTrain_rep_F[Ntrain] = ArrayHelper.MakeUniform<SparseGP>(this.PriorEvents);
			}
			this.Changed_priorEvents_iterationsDone = 1;
			this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of priorEvents and must reset on changes to numberOfIterationsDecreased and priorRoutine and routineFeaturesTrain and observedCountsTrain and numEventsTrain and eventsFeaturesTrain</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7(bool initialise)
		{
			if ((this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_iterationsDone==1)&&((!initialise)||this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_isInitialised)) {
				return ;
			}
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				// Message to 'fEventsTrain_rep_rep' from Replicate factor
				this.fEventsTrain_rep_rep_B_toDef[Ntrain] = ReplicateOp_Divide.ToDefInit<SparseGP>(this.fEventsTrain_rep_F[Ntrain]);
			}
			// Message to 'fEventsTrain_rep' from Replicate factor
			this.fEventsTrain_rep_B_toDef = ReplicateOp_Divide.ToDefInit<SparseGP>(this.PriorEvents);
			// Message to 'fEventsTrain_rep' from Replicate factor
			this.fEventsTrain_rep_F_marginal = ReplicateOp_Divide.MarginalInit<SparseGP>(this.PriorEvents);
			this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_iterationsDone = 1;
			this.Changed_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrain_observedCount7_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numEventsTrain</summary>
		public void Changed_numEventsTrain()
		{
			if (this.Changed_numEventsTrain_iterationsDone==1) {
				return ;
			}
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				// Create array for 'fEventsTrain_rep_rep' Backwards messages.
				this.fEventsTrain_rep_rep_B[Ntrain] = new DistributionRefArray<SparseGP,IFunction>(this.NumEventsTrain[Ntrain]);
			}
			this.Changed_numEventsTrain_iterationsDone = 1;
			this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numEventsTrain and priorEvents and must reset on changes to numberOfIterationsDecreased and priorRoutine and routineFeaturesTrain and observedCountsTrain and eventsFeaturesTrain</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5(bool initialise)
		{
			if ((this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_iterationsDone==1)&&((!initialise)||this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_isInitialised)) {
				return ;
			}
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					this.fEventsTrain_rep_rep_B[Ntrain][Etrain] = ArrayHelper.MakeUniform<SparseGP>(this.PriorEvents);
				}
			}
			this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_iterationsDone = 1;
			this.Changed_numEventsTrain_priorEvents_Init_numberOfIterationsDecreased_priorRoutine_routineFeaturesTrai5_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of priorRoutine and must reset on changes to numberOfIterationsDecreased and priorEvents and routineFeaturesTrain and observedCountsTrain and numEventsTrain and eventsFeaturesTrain</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2(bool initialise)
		{
			if ((this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_iterationsDone==1)&&((!initialise)||this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_isInitialised)) {
				return ;
			}
			// Message to 'fRoutineTrain_rep' from Replicate factor
			this.fRoutineTrain_rep_F_marginal = ReplicateOp_Divide.MarginalInit<SparseGP>(this.PriorRoutine);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				this.fRoutineTrain_rep_B[Ntrain] = ArrayHelper.MakeUniform<SparseGP>(this.PriorRoutine);
			}
			// Message to 'fRoutineTrain_rep' from Replicate factor
			this.fRoutineTrain_rep_B_toDef = ReplicateOp_Divide.ToDefInit<SparseGP>(this.PriorRoutine);
			this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_iterationsDone = 1;
			this.Changed_priorRoutine_Init_numberOfIterationsDecreased_priorEvents_routineFeaturesTrain_observedCount2_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numberOfIterationsDecreased and priorEvents and priorRoutine and routineFeaturesTrain and observedCountsTrain and numEventsTrain and eventsFeaturesTrain</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		public void Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3(int numberOfIterations)
		{
			if (this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone==numberOfIterations) {
				return ;
			}
			DistributionRefArray<SparseGP,IFunction> fRoutineTrain_rep_F = default(DistributionRefArray<SparseGP,IFunction>);
			// Create array for 'fRoutineTrain_rep' Forwards messages.
			fRoutineTrain_rep_F = new DistributionRefArray<SparseGP,IFunction>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				fRoutineTrain_rep_F[Ntrain] = ArrayHelper.MakeUniform<SparseGP>(this.PriorRoutine);
			}
			// Create array for replicates of 'vdouble126_F'
			DistributionStructArray<Gaussian,double> vdouble126_F = new DistributionStructArray<Gaussian,double>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				vdouble126_F[Ntrain] = Gaussian.Uniform();
			}
			DistributionStructArray<Gaussian,double> routineContributionsTrain_F = default(DistributionStructArray<Gaussian,double>);
			// Create array for 'routineContributionsTrain' Forwards messages.
			routineContributionsTrain_F = new DistributionStructArray<Gaussian,double>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				routineContributionsTrain_F[Ntrain] = Gaussian.Uniform();
			}
			// Create array for replicates of 'vdouble134_B'
			DistributionStructArray<Gaussian,double> vdouble134_B = new DistributionStructArray<Gaussian,double>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				vdouble134_B[Ntrain] = Gaussian.Uniform();
			}
			// Message from use of 'eventsContributionsTrain'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTrain_use_B = default(DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>);
			// Create array for 'eventsContributionsTrain_use' Backwards messages.
			eventsContributionsTrain_use_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				// Create array for 'eventsContributionsTrain_use' Backwards messages.
				eventsContributionsTrain_use_B[Ntrain] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					eventsContributionsTrain_use_B[Ntrain][Etrain] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble130_B'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble130_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				// Create array for replicates of 'vdouble130_B'
				vdouble130_B[Ntrain] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					vdouble130_B[Ntrain][Etrain] = Gaussian.Uniform();
				}
			}
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<SparseGP>
			// Create array for replicates of 'fEventsTrain_rep_rep_F_marginal'
			DistributionRefArray<SparseGP,IFunction> fEventsTrain_rep_rep_F_marginal = new DistributionRefArray<SparseGP,IFunction>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				// Message to 'fEventsTrain_rep_rep' from Replicate factor
				fEventsTrain_rep_rep_F_marginal[Ntrain] = ReplicateOp_Divide.MarginalInit<SparseGP>(this.fEventsTrain_rep_F[Ntrain]);
			}
			// Create array for replicates of 'fEventsTrain_rep_rep_F'
			DistributionRefArray<DistributionRefArray<SparseGP,IFunction>,IFunction[]> fEventsTrain_rep_rep_F = new DistributionRefArray<DistributionRefArray<SparseGP,IFunction>,IFunction[]>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				// Create array for 'fEventsTrain_rep_rep' Forwards messages.
				fEventsTrain_rep_rep_F[Ntrain] = new DistributionRefArray<SparseGP,IFunction>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					fEventsTrain_rep_rep_F[Ntrain][Etrain] = ArrayHelper.MakeUniform<SparseGP>(this.PriorEvents);
				}
			}
			// Create array for replicates of 'vdouble130_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble130_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				// Create array for replicates of 'vdouble130_F'
				vdouble130_F[Ntrain] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					vdouble130_F[Ntrain][Etrain] = Gaussian.Uniform();
				}
			}
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTrain_F = default(DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>);
			// Create array for 'eventsContributionsTrain' Forwards messages.
			eventsContributionsTrain_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				// Create array for 'eventsContributionsTrain' Forwards messages.
				eventsContributionsTrain_F[Ntrain] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					eventsContributionsTrain_F[Ntrain][Etrain] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'vdouble134_F'
			DistributionStructArray<Gaussian,double> vdouble134_F = new DistributionStructArray<Gaussian,double>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				vdouble134_F[Ntrain] = Gaussian.Uniform();
			}
			// Message from use of 'routineContributionsTrain'
			DistributionStructArray<Gaussian,double> routineContributionsTrain_use_B = default(DistributionStructArray<Gaussian,double>);
			// Create array for 'routineContributionsTrain_use' Backwards messages.
			routineContributionsTrain_use_B = new DistributionStructArray<Gaussian,double>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				routineContributionsTrain_use_B[Ntrain] = Gaussian.Uniform();
			}
			// Create array for replicates of 'vdouble126_B'
			DistributionStructArray<Gaussian,double> vdouble126_B = new DistributionStructArray<Gaussian,double>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				vdouble126_B[Ntrain] = Gaussian.Uniform();
			}
			for(int iteration = this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone; iteration<numberOfIterations; iteration++) {
				// Message to 'fEventsTrain_rep' from Replicate factor
				this.fEventsTrain_rep_F_marginal = ReplicateOp_Divide.Marginal<SparseGP>(this.fEventsTrain_rep_B_toDef, this.PriorEvents, this.fEventsTrain_rep_F_marginal);
				// Message to 'fRoutineTrain_rep' from Replicate factor
				this.fRoutineTrain_rep_F_marginal = ReplicateOp_Divide.Marginal<SparseGP>(this.fRoutineTrain_rep_B_toDef, this.PriorRoutine, this.fRoutineTrain_rep_F_marginal);
				for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
					// Message to 'fEventsTrain_rep' from Replicate factor
					this.fEventsTrain_rep_F[Ntrain] = ReplicateOp_Divide.UsesAverageConditional<SparseGP>(this.fEventsTrain_rep_rep_B_toDef[Ntrain], this.fEventsTrain_rep_F_marginal, Ntrain, this.fEventsTrain_rep_F[Ntrain]);
					// Message to 'fRoutineTrain_rep' from Replicate factor
					fRoutineTrain_rep_F[Ntrain] = ReplicateOp_Divide.UsesAverageConditional<SparseGP>(this.fRoutineTrain_rep_B[Ntrain], this.fRoutineTrain_rep_F_marginal, Ntrain, fRoutineTrain_rep_F[Ntrain]);
					// Message to 'vdouble126' from FunctionEvaluate factor
					vdouble126_F[Ntrain] = SparseGPOp.YAverageConditional(fRoutineTrain_rep_F[Ntrain], this.RoutineFeaturesTrain[Ntrain]);
					// Message to 'routineContributionsTrain' from GaussianFromMeanAndVariance factor
					routineContributionsTrain_F[Ntrain] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble126_F[Ntrain], 0.1);
					// Message to 'vdouble134' from Plus factor
					vdouble134_B[Ntrain] = DoublePlusOp.BAverageConditional(this.ObservedCountsTrain[Ntrain], routineContributionsTrain_F[Ntrain]);
					// Message to 'fEventsTrain_rep_rep' from Replicate factor
					fEventsTrain_rep_rep_F_marginal[Ntrain] = ReplicateOp_Divide.Marginal<SparseGP>(this.fEventsTrain_rep_rep_B_toDef[Ntrain], this.fEventsTrain_rep_F[Ntrain], fEventsTrain_rep_rep_F_marginal[Ntrain]);
					for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
						// Message to 'fEventsTrain_rep_rep' from Replicate factor
						fEventsTrain_rep_rep_F[Ntrain][Etrain] = ReplicateOp_Divide.UsesAverageConditional<SparseGP>(this.fEventsTrain_rep_rep_B[Ntrain][Etrain], fEventsTrain_rep_rep_F_marginal[Ntrain], Etrain, fEventsTrain_rep_rep_F[Ntrain][Etrain]);
						// Message to 'vdouble130' from FunctionEvaluate factor
						vdouble130_F[Ntrain][Etrain] = SparseGPOp.YAverageConditional(fEventsTrain_rep_rep_F[Ntrain][Etrain], this.EventsFeaturesTrain[Ntrain][Etrain]);
						// Message to 'eventsContributionsTrain' from GaussianFromMeanAndVariance factor
						eventsContributionsTrain_F[Ntrain][Etrain] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble130_F[Ntrain][Etrain], 0.1);
					}
					// Message to 'vdouble134' from Sum factor
					vdouble134_F[Ntrain] = FastSumOp.SumAverageConditional(eventsContributionsTrain_F[Ntrain]);
					// Message to 'eventsContributionsTrain_use' from Sum factor
					eventsContributionsTrain_use_B[Ntrain] = FastSumOp.ArrayAverageConditional<DistributionStructArray<Gaussian,double>>(vdouble134_B[Ntrain], vdouble134_F[Ntrain], eventsContributionsTrain_F[Ntrain], eventsContributionsTrain_use_B[Ntrain]);
					for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
						// Message to 'vdouble130' from GaussianFromMeanAndVariance factor
						vdouble130_B[Ntrain][Etrain] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(eventsContributionsTrain_use_B[Ntrain][Etrain], 0.1);
						// Message to 'fEventsTrain_rep_rep' from FunctionEvaluate factor
						this.fEventsTrain_rep_rep_B[Ntrain][Etrain] = SparseGPOp.FuncAverageConditional(vdouble130_B[Ntrain][Etrain], fEventsTrain_rep_rep_F[Ntrain][Etrain], this.EventsFeaturesTrain[Ntrain][Etrain], this.fEventsTrain_rep_rep_B[Ntrain][Etrain]);
					}
					// Message to 'fEventsTrain_rep_rep' from Replicate factor
					this.fEventsTrain_rep_rep_B_toDef[Ntrain] = ReplicateOp_Divide.ToDef<SparseGP>(this.fEventsTrain_rep_rep_B[Ntrain], this.fEventsTrain_rep_rep_B_toDef[Ntrain]);
					// Message to 'routineContributionsTrain_use' from Plus factor
					routineContributionsTrain_use_B[Ntrain] = DoublePlusOp.AAverageConditional(this.ObservedCountsTrain[Ntrain], vdouble134_F[Ntrain]);
					// Message to 'vdouble126' from GaussianFromMeanAndVariance factor
					vdouble126_B[Ntrain] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(routineContributionsTrain_use_B[Ntrain], 0.1);
					// Message to 'fRoutineTrain_rep' from FunctionEvaluate factor
					this.fRoutineTrain_rep_B[Ntrain] = SparseGPOp.FuncAverageConditional(vdouble126_B[Ntrain], fRoutineTrain_rep_F[Ntrain], this.RoutineFeaturesTrain[Ntrain], this.fRoutineTrain_rep_B[Ntrain]);
					this.fEventsTrain_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<SparseGP>(this.fEventsTrain_rep_F_marginal, this.fEventsTrain_rep_F[Ntrain], this.fEventsTrain_rep_rep_B_toDef[Ntrain]);
					this.fRoutineTrain_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<SparseGP>(this.fRoutineTrain_rep_F_marginal, fRoutineTrain_rep_F[Ntrain], this.fRoutineTrain_rep_B[Ntrain]);
				}
				// Message to 'fRoutineTrain_rep' from Replicate factor
				this.fRoutineTrain_rep_B_toDef = ReplicateOp_Divide.ToDef<SparseGP>(this.fRoutineTrain_rep_B, this.fRoutineTrain_rep_B_toDef);
				// Message to 'fEventsTrain_rep' from Replicate factor
				this.fEventsTrain_rep_B_toDef = ReplicateOp_Divide.ToDef<SparseGP>(this.fEventsTrain_rep_rep_B_toDef, this.fEventsTrain_rep_B_toDef);
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			this.fRoutineTrain_marginal_F = ArrayHelper.MakeUniform<SparseGP>(this.PriorRoutine);
			// Message to 'fRoutineTrain_marginal' from Variable factor
			this.fRoutineTrain_marginal_F = VariableOp.MarginalAverageConditional<SparseGP>(this.fRoutineTrain_rep_B_toDef, this.PriorRoutine, this.fRoutineTrain_marginal_F);
			this.fEventsTrain_marginal_F = ArrayHelper.MakeUniform<SparseGP>(this.PriorEvents);
			// Message to 'fEventsTrain_marginal' from Variable factor
			this.fEventsTrain_marginal_F = VariableOp.MarginalAverageConditional<SparseGP>(this.fEventsTrain_rep_B_toDef, this.PriorEvents, this.fEventsTrain_marginal_F);
			// Create array for 'routineContributionsTrain_marginal' Forwards messages.
			this.routineContributionsTrain_marginal_F = new DistributionStructArray<Gaussian,double>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				this.routineContributionsTrain_marginal_F[Ntrain] = Gaussian.Uniform();
				// Message to 'routineContributionsTrain_marginal' from Variable factor
				this.routineContributionsTrain_marginal_F[Ntrain] = VariableOp.MarginalAverageConditional<Gaussian>(routineContributionsTrain_use_B[Ntrain], routineContributionsTrain_F[Ntrain], this.routineContributionsTrain_marginal_F[Ntrain]);
			}
			// Create array for 'eventsContributionsTrain_marginal' Forwards messages.
			this.eventsContributionsTrain_marginal_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(4031);
			for(int Ntrain = 0; Ntrain<4031; Ntrain++) {
				// Create array for 'eventsContributionsTrain_marginal' Forwards messages.
				this.eventsContributionsTrain_marginal_F[Ntrain] = new DistributionStructArray<Gaussian,double>(this.NumEventsTrain[Ntrain]);
				for(int Etrain = 0; Etrain<this.NumEventsTrain[Ntrain]; Etrain++) {
					this.eventsContributionsTrain_marginal_F[Ntrain][Etrain] = Gaussian.Uniform();
					// Message to 'eventsContributionsTrain_marginal' from Variable factor
					this.eventsContributionsTrain_marginal_F[Ntrain][Etrain] = VariableOp.MarginalAverageConditional<Gaussian>(eventsContributionsTrain_use_B[Ntrain][Etrain], eventsContributionsTrain_F[Ntrain][Etrain], this.eventsContributionsTrain_marginal_F[Ntrain][Etrain]);
				}
			}
			this.Changed_numberOfIterationsDecreased_priorEvents_priorRoutine_routineFeaturesTrain_observedCountsTrai3_iterationsDone = numberOfIterations;
		}

		/// <summary>
		/// Returns the marginal distribution for 'fRoutineTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public SparseGP FRoutineTrainMarginal()
		{
			return this.fRoutineTrain_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'fEventsTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public SparseGP FEventsTrainMarginal()
		{
			return this.fEventsTrain_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineContributionsTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> RoutineContributionsTrainMarginal()
		{
			return this.routineContributionsTrain_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsContributionsTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> EventsContributionsTrainMarginal()
		{
			return this.eventsContributionsTrain_marginal_F;
		}

		/// <summary>Computations that depend on the observed value of priorRoutine and priorEvents and routineFeaturesTrain and numEventsTrain and eventsFeaturesTrain and observedCountsTrain</summary>
		public void Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0()
		{
			if (this.Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0_iterationsDone==1) {
				return ;
			}
			this.priorRoutine_marginal = new PointMass<SparseGP>(this.PriorRoutine);
			this.priorEvents_marginal = new PointMass<SparseGP>(this.PriorEvents);
			this.routineFeaturesTrain_marginal = new PointMass<Vector[]>(this.RoutineFeaturesTrain);
			this.numEventsTrain_marginal = new PointMass<int[]>(this.NumEventsTrain);
			this.eventsFeaturesTrain_marginal = new PointMass<Vector[][]>(this.EventsFeaturesTrain);
			this.observedCountsTrain_marginal = new DistributionStructArray<Gaussian,double>(4031, delegate(int Ntrain) {
				return Gaussian.Uniform();
			});
			this.observedCountsTrain_marginal = Distribution.SetPoint<DistributionStructArray<Gaussian,double>,double[]>(this.observedCountsTrain_marginal, this.ObservedCountsTrain);
			this.Changed_priorRoutine_priorEvents_routineFeaturesTrain_numEventsTrain_eventsFeaturesTrain_observedCou0_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'priorRoutine' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<SparseGP> PriorRoutineMarginal()
		{
			return this.priorRoutine_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'priorEvents' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<SparseGP> PriorEventsMarginal()
		{
			return this.priorEvents_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineFeaturesTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[]> RoutineFeaturesTrainMarginal()
		{
			return this.routineFeaturesTrain_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numEventsTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int[]> NumEventsTrainMarginal()
		{
			return this.numEventsTrain_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsFeaturesTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsFeaturesTrainMarginal()
		{
			return this.eventsFeaturesTrain_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'observedCountsTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> ObservedCountsTrainMarginal()
		{
			return this.observedCountsTrain_marginal;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
