using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Maths;
using MicrosoftResearch.Infer.Factors;
using MicrosoftResearch.Infer.Collections;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 06:31 on sexta-feira, 6 de Setembro de 2013.
	/// </remarks>
	public partial class Model7_EP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the priorRoutine property</summary>
		private SparseGP PriorRoutine;
		/// <summary>Field backing the priorEvents property</summary>
		private SparseGP PriorEvents;
		/// <summary>Field backing the routineFeaturesTest property</summary>
		private Vector[] RoutineFeaturesTest;
		/// <summary>Field backing the numEventsTest property</summary>
		private int[] NumEventsTest;
		/// <summary>Field backing the eventsFeaturesTest property</summary>
		private Vector[][] EventsFeaturesTest;
		/// <summary>The number of iterations last computed by Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest. Set this to zero to force re-execution of Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest</summary>
		public int Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1. Set this to zero to force re-execution of Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1</summary>
		public int Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone;
		/// <summary>The number of iterations last computed by Constant. Set this to zero to force re-execution of Constant</summary>
		public int Constant_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3. Set this to zero to force re-execution of Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3</summary>
		public int Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_iterationsDone;
		/// <summary>True if Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3 has performed initialisation. Set this to false to force re-execution of Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3</summary>
		public bool Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_isInitialised;
		/// <summary>The number of iterations last computed by Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4. Set this to zero to force re-execution of Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4</summary>
		public int Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_iterationsDone;
		/// <summary>True if Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4 has performed initialisation. Set this to false to force re-execution of Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4</summary>
		public bool Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_isInitialised;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<SparseGP></summary>
		public SparseGP fRoutineTest_rep_F_marginal;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<SparseGP></summary>
		public SparseGP fEventsTest_rep_F_marginal;
		/// <summary>Message to marginal of 'fRoutineTest'</summary>
		public SparseGP fRoutineTest_marginal_F;
		/// <summary>Message to marginal of 'fEventsTest'</summary>
		public SparseGP fEventsTest_marginal_F;
		/// <summary>Message to marginal of 'routineContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double> routineContributionsTest_marginal_F;
		/// <summary>Message to marginal of 'eventsContributionsTest'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_marginal_F;
		/// <summary>Message to marginal of 'observedCountsTest'</summary>
		public DistributionStructArray<Gaussian,double> observedCountsTest_marginal_F;
		public PointMass<SparseGP> priorRoutine_marginal;
		public PointMass<SparseGP> priorEvents_marginal;
		public PointMass<Vector[]> routineFeaturesTest_marginal;
		public PointMass<int[]> numEventsTest_marginal;
		public PointMass<Vector[][]> eventsFeaturesTest_marginal;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'priorRoutine'</summary>
		public SparseGP priorRoutine
		{			get {
				return this.PriorRoutine;
			}
			set {
				this.PriorRoutine = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_isInitialised = false;
				this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'priorEvents'</summary>
		public SparseGP priorEvents
		{			get {
				return this.PriorEvents;
			}
			set {
				this.PriorEvents = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_iterationsDone = 0;
				this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_isInitialised = false;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'routineFeaturesTest'</summary>
		public Vector[] routineFeaturesTest
		{			get {
				return this.RoutineFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=1729)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+1729)+" was expected for variable \'routineFeaturesTest\'");
				}
				this.RoutineFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_isInitialised = false;
				this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_isInitialised = false;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'numEventsTest'</summary>
		public int[] numEventsTest
		{			get {
				return this.NumEventsTest;
			}
			set {
				if ((value!=null)&&(value.Length!=1729)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+1729)+" was expected for variable \'numEventsTest\'");
				}
				this.NumEventsTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_isInitialised = false;
				this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_isInitialised = false;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsFeaturesTest'</summary>
		public Vector[][] eventsFeaturesTest
		{			get {
				return this.EventsFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=1729)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+1729)+" was expected for variable \'eventsFeaturesTest\'");
				}
				this.EventsFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_isInitialised = false;
				this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_isInitialised = false;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone = 0;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="priorRoutine") {
				return this.priorRoutine;
			}
			if (variableName=="priorEvents") {
				return this.priorEvents;
			}
			if (variableName=="routineFeaturesTest") {
				return this.routineFeaturesTest;
			}
			if (variableName=="numEventsTest") {
				return this.numEventsTest;
			}
			if (variableName=="eventsFeaturesTest") {
				return this.eventsFeaturesTest;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="priorRoutine") {
				this.priorRoutine = (SparseGP)value;
				return ;
			}
			if (variableName=="priorEvents") {
				this.priorEvents = (SparseGP)value;
				return ;
			}
			if (variableName=="routineFeaturesTest") {
				this.routineFeaturesTest = (Vector[])value;
				return ;
			}
			if (variableName=="numEventsTest") {
				this.numEventsTest = (int[])value;
				return ;
			}
			if (variableName=="eventsFeaturesTest") {
				this.eventsFeaturesTest = (Vector[][])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="fRoutineTest") {
				return this.FRoutineTestMarginal();
			}
			if (variableName=="fEventsTest") {
				return this.FEventsTestMarginal();
			}
			if (variableName=="routineContributionsTest") {
				return this.RoutineContributionsTestMarginal();
			}
			if (variableName=="eventsContributionsTest") {
				return this.EventsContributionsTestMarginal();
			}
			if (variableName=="observedCountsTest") {
				return this.ObservedCountsTestMarginal();
			}
			if (variableName=="priorRoutine") {
				return this.PriorRoutineMarginal();
			}
			if (variableName=="priorEvents") {
				return this.PriorEventsMarginal();
			}
			if (variableName=="routineFeaturesTest") {
				return this.RoutineFeaturesTestMarginal();
			}
			if (variableName=="numEventsTest") {
				return this.NumEventsTestMarginal();
			}
			if (variableName=="eventsFeaturesTest") {
				return this.EventsFeaturesTestMarginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			if (numberOfIterations<this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone) {
				this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_isInitialised = false;
				this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_isInitialised = false;
				this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone = 0;
			}
			this.Constant();
			this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4(initialise);
			this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3(initialise);
			this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1(numberOfIterations);
			this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that do not depend on observed values</summary>
		public void Constant()
		{
			if (this.Constant_iterationsDone==1) {
				return ;
			}
			this.Constant_iterationsDone = 1;
			this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_iterationsDone = 0;
			this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of priorEvents and must reset on changes to priorRoutine and routineFeaturesTest and numEventsTest and eventsFeaturesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4(bool initialise)
		{
			if ((this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_iterationsDone==1)&&((!initialise)||this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_isInitialised)) {
				return ;
			}
			// Message to 'fEventsTest_rep' from Replicate factor
			this.fEventsTest_rep_F_marginal = ReplicateOp_Divide.MarginalInit<SparseGP>(this.PriorEvents);
			this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_iterationsDone = 1;
			this.Changed_priorEvents_Init_priorRoutine_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI4_isInitialised = true;
			this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of priorRoutine and must reset on changes to priorEvents and routineFeaturesTest and numEventsTest and eventsFeaturesTest and numberOfIterationsDecreased</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3(bool initialise)
		{
			if ((this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_iterationsDone==1)&&((!initialise)||this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_isInitialised)) {
				return ;
			}
			// Message to 'fRoutineTest_rep' from Replicate factor
			this.fRoutineTest_rep_F_marginal = ReplicateOp_Divide.MarginalInit<SparseGP>(this.PriorRoutine);
			this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_iterationsDone = 1;
			this.Changed_priorRoutine_Init_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfI3_isInitialised = true;
			this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of priorRoutine and priorEvents and routineFeaturesTest and numEventsTest and eventsFeaturesTest and numberOfIterationsDecreased</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		public void Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1(int numberOfIterations)
		{
			if (this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone==numberOfIterations) {
				return ;
			}
			this.fRoutineTest_marginal_F = ArrayHelper.MakeUniform<SparseGP>(this.PriorRoutine);
			// Buffer for ReplicateOp_Divide.Marginal<SparseGP>
			SparseGP fRoutineTest_rep_B_toDef = default(SparseGP);
			// Message to 'fRoutineTest_rep' from Replicate factor
			fRoutineTest_rep_B_toDef = ReplicateOp_Divide.ToDefInit<SparseGP>(this.PriorRoutine);
			// Message to 'fRoutineTest_marginal' from Variable factor
			this.fRoutineTest_marginal_F = VariableOp.MarginalAverageConditional<SparseGP>(fRoutineTest_rep_B_toDef, this.PriorRoutine, this.fRoutineTest_marginal_F);
			this.fEventsTest_marginal_F = ArrayHelper.MakeUniform<SparseGP>(this.PriorEvents);
			// Buffer for ReplicateOp_Divide.Marginal<SparseGP>
			SparseGP fEventsTest_rep_B_toDef = default(SparseGP);
			// Message to 'fEventsTest_rep' from Replicate factor
			fEventsTest_rep_B_toDef = ReplicateOp_Divide.ToDefInit<SparseGP>(this.PriorEvents);
			// Message to 'fEventsTest_marginal' from Variable factor
			this.fEventsTest_marginal_F = VariableOp.MarginalAverageConditional<SparseGP>(fEventsTest_rep_B_toDef, this.PriorEvents, this.fEventsTest_marginal_F);
			DistributionRefArray<SparseGP,IFunction> fRoutineTest_rep_F = default(DistributionRefArray<SparseGP,IFunction>);
			DistributionRefArray<SparseGP,IFunction> fRoutineTest_rep_B = default(DistributionRefArray<SparseGP,IFunction>);
			// Create array for 'fRoutineTest_rep' Forwards messages.
			fRoutineTest_rep_F = new DistributionRefArray<SparseGP,IFunction>(1729);
			// Create array for 'fRoutineTest_rep' Backwards messages.
			fRoutineTest_rep_B = new DistributionRefArray<SparseGP,IFunction>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				fRoutineTest_rep_B[Ntest] = ArrayHelper.MakeUniform<SparseGP>(this.PriorRoutine);
				fRoutineTest_rep_F[Ntest] = ArrayHelper.MakeUniform<SparseGP>(this.PriorRoutine);
			}
			// Message to 'fRoutineTest_rep' from Replicate factor
			this.fRoutineTest_rep_F_marginal = ReplicateOp_Divide.Marginal<SparseGP>(fRoutineTest_rep_B_toDef, this.PriorRoutine, this.fRoutineTest_rep_F_marginal);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				// Message to 'fRoutineTest_rep' from Replicate factor
				fRoutineTest_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<SparseGP>(fRoutineTest_rep_B[Ntest], this.fRoutineTest_rep_F_marginal, Ntest, fRoutineTest_rep_F[Ntest]);
				this.fRoutineTest_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<SparseGP>(this.fRoutineTest_rep_F_marginal, fRoutineTest_rep_F[Ntest], fRoutineTest_rep_B[Ntest]);
			}
			DistributionStructArray<Gaussian,double> routineContributionsTest_F = default(DistributionStructArray<Gaussian,double>);
			// Create array for 'routineContributionsTest' Forwards messages.
			routineContributionsTest_F = new DistributionStructArray<Gaussian,double>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				routineContributionsTest_F[Ntest] = Gaussian.Uniform();
			}
			// Create array for replicates of 'vdouble140_F'
			DistributionStructArray<Gaussian,double> vdouble140_F = new DistributionStructArray<Gaussian,double>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				vdouble140_F[Ntest] = Gaussian.Uniform();
				// Message to 'vdouble140' from FunctionEvaluate factor
				vdouble140_F[Ntest] = SparseGPOp.YAverageConditional(fRoutineTest_rep_F[Ntest], this.RoutineFeaturesTest[Ntest]);
			}
			// Create array for 'routineContributionsTest_marginal' Forwards messages.
			this.routineContributionsTest_marginal_F = new DistributionStructArray<Gaussian,double>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				this.routineContributionsTest_marginal_F[Ntest] = Gaussian.Uniform();
			}
			// Message from use of 'routineContributionsTest'
			DistributionStructArray<Gaussian,double> routineContributionsTest_use_B = default(DistributionStructArray<Gaussian,double>);
			// Create array for 'routineContributionsTest_use' Backwards messages.
			routineContributionsTest_use_B = new DistributionStructArray<Gaussian,double>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				routineContributionsTest_use_B[Ntest] = Gaussian.Uniform();
				// Message to 'routineContributionsTest' from GaussianFromMeanAndVariance factor
				routineContributionsTest_F[Ntest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble140_F[Ntest], 0.1);
				// Message to 'routineContributionsTest_marginal' from Variable factor
				this.routineContributionsTest_marginal_F[Ntest] = VariableOp.MarginalAverageConditional<Gaussian>(routineContributionsTest_use_B[Ntest], routineContributionsTest_F[Ntest], this.routineContributionsTest_marginal_F[Ntest]);
			}
			DistributionRefArray<SparseGP,IFunction> fEventsTest_rep_F = default(DistributionRefArray<SparseGP,IFunction>);
			// Create array for 'fEventsTest_rep' Forwards messages.
			fEventsTest_rep_F = new DistributionRefArray<SparseGP,IFunction>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				fEventsTest_rep_F[Ntest] = ArrayHelper.MakeUniform<SparseGP>(this.PriorEvents);
			}
			// Message to 'fEventsTest_rep' from Replicate factor
			this.fEventsTest_rep_F_marginal = ReplicateOp_Divide.Marginal<SparseGP>(fEventsTest_rep_B_toDef, this.PriorEvents, this.fEventsTest_rep_F_marginal);
			// Buffer for ReplicateOp_Divide.Marginal<SparseGP>
			// Create array for replicates of 'fEventsTest_rep_rep_B_toDef'
			DistributionRefArray<SparseGP,IFunction> fEventsTest_rep_rep_B_toDef = new DistributionRefArray<SparseGP,IFunction>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				// Message to 'fEventsTest_rep_rep' from Replicate factor
				fEventsTest_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDefInit<SparseGP>(fEventsTest_rep_F[Ntest]);
				// Message to 'fEventsTest_rep' from Replicate factor
				fEventsTest_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<SparseGP>(fEventsTest_rep_rep_B_toDef[Ntest], this.fEventsTest_rep_F_marginal, Ntest, fEventsTest_rep_F[Ntest]);
				this.fEventsTest_rep_F_marginal = ReplicateOp_Divide.MarginalIncrement<SparseGP>(this.fEventsTest_rep_F_marginal, fEventsTest_rep_F[Ntest], fEventsTest_rep_rep_B_toDef[Ntest]);
			}
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_F = default(DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>);
			// Create array for 'eventsContributionsTest' Forwards messages.
			eventsContributionsTest_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				// Create array for 'eventsContributionsTest' Forwards messages.
				eventsContributionsTest_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					eventsContributionsTest_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			DistributionStructArray<Gaussian,double> observedCountsTest_F = default(DistributionStructArray<Gaussian,double>);
			// Create array for 'observedCountsTest' Forwards messages.
			observedCountsTest_F = new DistributionStructArray<Gaussian,double>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				observedCountsTest_F[Ntest] = Gaussian.Uniform();
			}
			// Create array for replicates of 'vdouble144_F'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble144_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				// Create array for replicates of 'vdouble144_F'
				vdouble144_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					vdouble144_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Create array for replicates of 'fEventsTest_rep_rep_F'
			DistributionRefArray<DistributionRefArray<SparseGP,IFunction>,IFunction[]> fEventsTest_rep_rep_F = new DistributionRefArray<DistributionRefArray<SparseGP,IFunction>,IFunction[]>(1729);
			// Create array for replicates of 'fEventsTest_rep_rep_B'
			DistributionRefArray<DistributionRefArray<SparseGP,IFunction>,IFunction[]> fEventsTest_rep_rep_B = new DistributionRefArray<DistributionRefArray<SparseGP,IFunction>,IFunction[]>(1729);
			// Buffer for ReplicateOp_Divide.UsesAverageConditional<SparseGP>
			// Create array for replicates of 'fEventsTest_rep_rep_F_marginal'
			DistributionRefArray<SparseGP,IFunction> fEventsTest_rep_rep_F_marginal = new DistributionRefArray<SparseGP,IFunction>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				// Create array for 'fEventsTest_rep_rep' Forwards messages.
				fEventsTest_rep_rep_F[Ntest] = new DistributionRefArray<SparseGP,IFunction>(this.NumEventsTest[Ntest]);
				// Create array for 'fEventsTest_rep_rep' Backwards messages.
				fEventsTest_rep_rep_B[Ntest] = new DistributionRefArray<SparseGP,IFunction>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					fEventsTest_rep_rep_B[Ntest][Etest] = ArrayHelper.MakeUniform<SparseGP>(this.PriorEvents);
					fEventsTest_rep_rep_F[Ntest][Etest] = ArrayHelper.MakeUniform<SparseGP>(this.PriorEvents);
				}
				// Message to 'fEventsTest_rep_rep' from Replicate factor
				fEventsTest_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.MarginalInit<SparseGP>(fEventsTest_rep_F[Ntest]);
				// Message to 'fEventsTest_rep_rep' from Replicate factor
				fEventsTest_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<SparseGP>(fEventsTest_rep_rep_B_toDef[Ntest], fEventsTest_rep_F[Ntest], fEventsTest_rep_rep_F_marginal[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					// Message to 'fEventsTest_rep_rep' from Replicate factor
					fEventsTest_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<SparseGP>(fEventsTest_rep_rep_B[Ntest][Etest], fEventsTest_rep_rep_F_marginal[Ntest], Etest, fEventsTest_rep_rep_F[Ntest][Etest]);
					// Message to 'vdouble144' from FunctionEvaluate factor
					vdouble144_F[Ntest][Etest] = SparseGPOp.YAverageConditional(fEventsTest_rep_rep_F[Ntest][Etest], this.EventsFeaturesTest[Ntest][Etest]);
				}
			}
			// Create array for 'eventsContributionsTest_marginal' Forwards messages.
			this.eventsContributionsTest_marginal_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				// Create array for 'eventsContributionsTest_marginal' Forwards messages.
				this.eventsContributionsTest_marginal_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					this.eventsContributionsTest_marginal_F[Ntest][Etest] = Gaussian.Uniform();
				}
			}
			// Message from use of 'eventsContributionsTest'
			DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_use_B = default(DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>);
			// Create array for 'eventsContributionsTest_use' Backwards messages.
			eventsContributionsTest_use_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				// Create array for 'eventsContributionsTest_use' Backwards messages.
				eventsContributionsTest_use_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
					eventsContributionsTest_use_B[Ntest][Etest] = Gaussian.Uniform();
					// Message to 'eventsContributionsTest' from GaussianFromMeanAndVariance factor
					eventsContributionsTest_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(vdouble144_F[Ntest][Etest], 0.1);
					// Message to 'eventsContributionsTest_marginal' from Variable factor
					this.eventsContributionsTest_marginal_F[Ntest][Etest] = VariableOp.MarginalAverageConditional<Gaussian>(eventsContributionsTest_use_B[Ntest][Etest], eventsContributionsTest_F[Ntest][Etest], this.eventsContributionsTest_marginal_F[Ntest][Etest]);
				}
			}
			// Create array for replicates of 'vdouble148_F'
			DistributionStructArray<Gaussian,double> vdouble148_F = new DistributionStructArray<Gaussian,double>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				vdouble148_F[Ntest] = Gaussian.Uniform();
				// Message to 'vdouble148' from Sum factor
				vdouble148_F[Ntest] = FastSumOp.SumAverageConditional(eventsContributionsTest_F[Ntest]);
			}
			// Create array for 'observedCountsTest_marginal' Forwards messages.
			this.observedCountsTest_marginal_F = new DistributionStructArray<Gaussian,double>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				this.observedCountsTest_marginal_F[Ntest] = Gaussian.Uniform();
			}
			// Message from use of 'observedCountsTest'
			DistributionStructArray<Gaussian,double> observedCountsTest_use_B = default(DistributionStructArray<Gaussian,double>);
			// Create array for 'observedCountsTest_use' Backwards messages.
			observedCountsTest_use_B = new DistributionStructArray<Gaussian,double>(1729);
			for(int Ntest = 0; Ntest<1729; Ntest++) {
				observedCountsTest_use_B[Ntest] = Gaussian.Uniform();
				// Message to 'observedCountsTest' from Plus factor
				observedCountsTest_F[Ntest] = DoublePlusOp.SumAverageConditional(routineContributionsTest_F[Ntest], vdouble148_F[Ntest]);
				// Message to 'observedCountsTest_marginal' from DerivedVariable factor
				this.observedCountsTest_marginal_F[Ntest] = DerivedVariableOp.MarginalAverageConditional<Gaussian>(observedCountsTest_use_B[Ntest], observedCountsTest_F[Ntest], this.observedCountsTest_marginal_F[Ntest]);
			}
			this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_numberOfIterat1_iterationsDone = numberOfIterations;
		}

		/// <summary>
		/// Returns the marginal distribution for 'fRoutineTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public SparseGP FRoutineTestMarginal()
		{
			return this.fRoutineTest_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'fEventsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public SparseGP FEventsTestMarginal()
		{
			return this.fEventsTest_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineContributionsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> RoutineContributionsTestMarginal()
		{
			return this.routineContributionsTest_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsContributionsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> EventsContributionsTestMarginal()
		{
			return this.eventsContributionsTest_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'observedCountsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> ObservedCountsTestMarginal()
		{
			return this.observedCountsTest_marginal_F;
		}

		/// <summary>Computations that depend on the observed value of priorRoutine and priorEvents and routineFeaturesTest and numEventsTest and eventsFeaturesTest</summary>
		public void Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest()
		{
			if (this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_iterationsDone==1) {
				return ;
			}
			this.priorRoutine_marginal = new PointMass<SparseGP>(this.PriorRoutine);
			this.priorEvents_marginal = new PointMass<SparseGP>(this.PriorEvents);
			this.routineFeaturesTest_marginal = new PointMass<Vector[]>(this.RoutineFeaturesTest);
			this.numEventsTest_marginal = new PointMass<int[]>(this.NumEventsTest);
			this.eventsFeaturesTest_marginal = new PointMass<Vector[][]>(this.EventsFeaturesTest);
			this.Changed_priorRoutine_priorEvents_routineFeaturesTest_numEventsTest_eventsFeaturesTest_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'priorRoutine' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<SparseGP> PriorRoutineMarginal()
		{
			return this.priorRoutine_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'priorEvents' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<SparseGP> PriorEventsMarginal()
		{
			return this.priorEvents_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'routineFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[]> RoutineFeaturesTestMarginal()
		{
			return this.routineFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numEventsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int[]> NumEventsTestMarginal()
		{
			return this.numEventsTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsFeaturesTestMarginal()
		{
			return this.eventsFeaturesTest_marginal;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
