using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Maths;
using MicrosoftResearch.Infer.Collections;
using MicrosoftResearch.Infer.Factors;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 15:10 on segunda-feira, 29 de Julho de 2013.
	/// </remarks>
	public partial class Model0_VMP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the numTesting property</summary>
		private int NumTesting;
		/// <summary>Field backing the weightsPosterior property</summary>
		private VectorGaussian WeightsPosterior;
		/// <summary>Field backing the xTest property</summary>
		private Vector[] XTest;
		/// <summary>The number of iterations last computed by Changed_numTesting_weightsPosterior_xTest. Set this to zero to force re-execution of Changed_numTesting_weightsPosterior_xTest</summary>
		public int Changed_numTesting_weightsPosterior_xTest_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest. Set this to zero to force re-execution of Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest</summary>
		public int Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest. Set this to zero to force re-execution of Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest</summary>
		public int Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest_iterationsDone;
		/// <summary>True if Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest has performed initialisation. Set this to false to force re-execution of Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest</summary>
		public bool Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest_isInitialised;
		/// <summary>Message from use of 'vVector4'</summary>
		public VectorGaussian vVector4_use_B;
		/// <summary>Message to marginal of 'vVector4'</summary>
		public VectorGaussian vVector4_marginal_F;
		/// <summary>Message to marginal of 'yTest'</summary>
		public DistributionStructArray<Gaussian,double> yTest_marginal_F;
		public PointMass<int> numTesting_marginal;
		public PointMass<VectorGaussian> weightsPosterior_marginal;
		public PointMass<Vector[]> xTest_marginal;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'numTesting'</summary>
		public int numTesting
		{			get {
				return this.NumTesting;
			}
			set {
				if (this.NumTesting!=value) {
					this.NumTesting = value;
					this.numberOfIterationsDone = 0;
					this.Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest_isInitialised = false;
					this.Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest_iterationsDone = 0;
					this.Changed_numTesting_weightsPosterior_xTest_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'weightsPosterior'</summary>
		public VectorGaussian weightsPosterior
		{			get {
				return this.WeightsPosterior;
			}
			set {
				this.WeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest_iterationsDone = 0;
				this.Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest_iterationsDone = 0;
				this.Changed_numTesting_weightsPosterior_xTest_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'xTest'</summary>
		public Vector[] xTest
		{			get {
				return this.XTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'xTest\'");
				}
				this.XTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest_iterationsDone = 0;
				this.Changed_numTesting_weightsPosterior_xTest_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="numTesting") {
				return this.numTesting;
			}
			if (variableName=="weightsPosterior") {
				return this.weightsPosterior;
			}
			if (variableName=="xTest") {
				return this.xTest;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="numTesting") {
				this.numTesting = (int)value;
				return ;
			}
			if (variableName=="weightsPosterior") {
				this.weightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="xTest") {
				this.xTest = (Vector[])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="vVector4") {
				return this.VVector4Marginal();
			}
			if (variableName=="yTest") {
				return this.YTestMarginal();
			}
			if (variableName=="numTesting") {
				return this.NumTestingMarginal();
			}
			if (variableName=="weightsPosterior") {
				return this.WeightsPosteriorMarginal();
			}
			if (variableName=="xTest") {
				return this.XTestMarginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			if (numberOfIterations<this.Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest_iterationsDone) {
				this.Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest_iterationsDone = 0;
			}
			this.Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest(initialise);
			this.Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest(numberOfIterations);
			this.Changed_numTesting_weightsPosterior_xTest();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that depend on the observed value of weightsPosterior and must reset on changes to numberOfIterationsDecreased and numTesting and xTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest(bool initialise)
		{
			if ((this.Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest_iterationsDone==1)&&((!initialise)||this.Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest_isInitialised)) {
				return ;
			}
			this.vVector4_use_B = ArrayHelper.MakeUniform<VectorGaussian>(this.WeightsPosterior);
			this.Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest_iterationsDone = 1;
			this.Changed_weightsPosterior_Init_numberOfIterationsDecreased_numTesting_xTest_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numberOfIterationsDecreased and weightsPosterior and numTesting and xTest</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		public void Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest(int numberOfIterations)
		{
			if (this.Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest_iterationsDone==numberOfIterations) {
				return ;
			}
			this.vVector4_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.WeightsPosterior);
			// Message from use of 'yTest'
			DistributionStructArray<Gaussian,double> yTest_use_B = default(DistributionStructArray<Gaussian,double>);
			// Create array for 'yTest_use' Backwards messages.
			yTest_use_B = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int iTest = 0; iTest<this.NumTesting; iTest++) {
				yTest_use_B[iTest] = Gaussian.Uniform();
			}
			PositiveDefiniteMatrix _hoist2 = default(PositiveDefiniteMatrix);
			_hoist2 = InnerProductOp.BVarianceInit(this.vVector4_marginal_F);
			PositiveDefiniteMatrix _hoist3 = default(PositiveDefiniteMatrix);
			for(int iTest = 0; iTest<this.NumTesting; iTest++) {
				_hoist3 = ArrayHelper.CopyStorage<PositiveDefiniteMatrix>(_hoist2);
				iTest = this.NumTesting-1;
			}
			Vector _hoist = default(Vector);
			_hoist = InnerProductOp.BMeanInit(this.vVector4_marginal_F);
			Vector _hoist4 = default(Vector);
			for(int iTest = 0; iTest<this.NumTesting; iTest++) {
				_hoist4 = ArrayHelper.CopyStorage<Vector>(_hoist);
				iTest = this.NumTesting-1;
			}
			// Create array for replicates of 'vdouble6_F'
			DistributionStructArray<Gaussian,double> vdouble6_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int iTest = 0; iTest<this.NumTesting; iTest++) {
				vdouble6_F[iTest] = Gaussian.Uniform();
			}
			DistributionStructArray<Gaussian,double> yTest_F = default(DistributionStructArray<Gaussian,double>);
			// Create array for 'yTest' Forwards messages.
			yTest_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int iTest = 0; iTest<this.NumTesting; iTest++) {
				yTest_F[iTest] = Gaussian.Uniform();
			}
			// Create array for 'yTest_marginal' Forwards messages.
			this.yTest_marginal_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int iTest = 0; iTest<this.NumTesting; iTest++) {
				this.yTest_marginal_F[iTest] = Gaussian.Uniform();
			}
			// Create array for replicates of 'vdouble6_B'
			DistributionStructArray<Gaussian,double> vdouble6_B = new DistributionStructArray<Gaussian,double>(this.NumTesting);
			for(int iTest = 0; iTest<this.NumTesting; iTest++) {
				vdouble6_B[iTest] = Gaussian.Uniform();
			}
			DistributionRefArray<VectorGaussian,Vector> vVector4_rep_B = default(DistributionRefArray<VectorGaussian,Vector>);
			// Create array for 'vVector4_rep' Backwards messages.
			vVector4_rep_B = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
			for(int iTest = 0; iTest<this.NumTesting; iTest++) {
				vVector4_rep_B[iTest] = ArrayHelper.MakeUniform<VectorGaussian>(this.WeightsPosterior);
			}
			for(int iteration = this.Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest_iterationsDone; iteration<numberOfIterations; iteration++) {
				// Message to 'vVector4_marginal' from Variable factor
				this.vVector4_marginal_F = VariableVmpOp.MarginalAverageLogarithm<VectorGaussian>(this.vVector4_use_B, this.WeightsPosterior, this.vVector4_marginal_F);
				for(int iTest = 0; iTest<this.NumTesting; iTest++) {
					_hoist3 = InnerProductOp.BVariance(this.vVector4_marginal_F, _hoist3);
					iTest = this.NumTesting-1;
				}
				for(int iTest = 0; iTest<this.NumTesting; iTest++) {
					_hoist4 = InnerProductOp.BMean(this.vVector4_marginal_F, _hoist3, _hoist4);
					iTest = this.NumTesting-1;
				}
				for(int iTest = 0; iTest<this.NumTesting; iTest++) {
					// Message to 'vdouble6' from InnerProduct factor
					vdouble6_F[iTest] = InnerProductOp.InnerProductAverageLogarithm(this.XTest[iTest], _hoist4, _hoist3);
					// Message to 'yTest' from GaussianFromMeanAndVariance factor
					yTest_F[iTest] = GaussianFromMeanAndVarianceOp.SampleAverageLogarithm(vdouble6_F[iTest], 1.0);
					// Message to 'yTest_marginal' from Variable factor
					this.yTest_marginal_F[iTest] = VariableVmpOp.MarginalAverageLogarithm<Gaussian>(yTest_use_B[iTest], yTest_F[iTest], this.yTest_marginal_F[iTest]);
					// Message to 'vdouble6' from GaussianFromMeanAndVariance factor
					vdouble6_B[iTest] = GaussianFromMeanAndVarianceOp.MeanAverageLogarithm(this.yTest_marginal_F[iTest], 1.0);
					// Message to 'vVector4_rep' from InnerProduct factor
					vVector4_rep_B[iTest] = InnerProductOp.BAverageLogarithm(vdouble6_B[iTest], this.XTest[iTest], vVector4_rep_B[iTest]);
				}
				// Message to 'vVector4_use' from Replicate factor
				this.vVector4_use_B = ReplicateOp.DefAverageLogarithm<VectorGaussian>(vVector4_rep_B, this.vVector4_use_B);
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			// Message to 'vVector4_marginal' from Variable factor
			this.vVector4_marginal_F = VariableVmpOp.MarginalAverageLogarithm<VectorGaussian>(this.vVector4_use_B, this.WeightsPosterior, this.vVector4_marginal_F);
			this.Changed_numberOfIterationsDecreased_weightsPosterior_numTesting_xTest_iterationsDone = numberOfIterations;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector4' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector4Marginal()
		{
			return this.vVector4_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'yTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> YTestMarginal()
		{
			return this.yTest_marginal_F;
		}

		/// <summary>Computations that depend on the observed value of numTesting and weightsPosterior and xTest</summary>
		public void Changed_numTesting_weightsPosterior_xTest()
		{
			if (this.Changed_numTesting_weightsPosterior_xTest_iterationsDone==1) {
				return ;
			}
			this.numTesting_marginal = new PointMass<int>(this.NumTesting);
			this.weightsPosterior_marginal = new PointMass<VectorGaussian>(this.WeightsPosterior);
			this.xTest_marginal = new PointMass<Vector[]>(this.XTest);
			this.Changed_numTesting_weightsPosterior_xTest_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numTesting' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int> NumTestingMarginal()
		{
			return this.numTesting_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'weightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> WeightsPosteriorMarginal()
		{
			return this.weightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'xTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[]> XTestMarginal()
		{
			return this.xTest_marginal;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
