using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Maths;
using MicrosoftResearch.Infer.Factors;
using MicrosoftResearch.Infer.Collections;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 17:02 on domingo, 29 de Setembro de 2013.
	/// </remarks>
	public partial class Model1_EP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the evidence property</summary>
		private bool Evidence;
		/// <summary>Field backing the numTesting property</summary>
		private int NumTesting;
		/// <summary>Field backing the dummyWeightsPosterior property</summary>
		private VectorGaussian DummyWeightsPosterior;
		/// <summary>Field backing the baseFeaturesTest property</summary>
		private Vector[] BaseFeaturesTest;
		/// <summary>Field backing the numEventsTest property</summary>
		private int[] NumEventsTest;
		/// <summary>Field backing the eventsFeatureWeightsPosterior property</summary>
		private VectorGaussian EventsFeatureWeightsPosterior;
		/// <summary>Field backing the eventsFeaturesTest property</summary>
		private Vector[][] EventsFeaturesTest;
		/// <summary>The number of iterations last computed by Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0. Set this to zero to force re-execution of Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0</summary>
		public int Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence. Set this to zero to force re-execution of Changed_evidence</summary>
		public int Changed_evidence_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence_numTesting. Set this to zero to force re-execution of Changed_evidence_numTesting</summary>
		public int Changed_evidence_numTesting_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3. Set this to zero to force re-execution of Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3</summary>
		public int Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_iterationsDone;
		/// <summary>True if Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3 has performed initialisation. Set this to false to force re-execution of Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3</summary>
		public bool Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_isInitialised;
		/// <summary>The number of iterations last computed by Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4. Set this to zero to force re-execution of Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4</summary>
		public int Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5. Set this to zero to force re-execution of Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5</summary>
		public int Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_iterationsDone;
		/// <summary>True if Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5 has performed initialisation. Set this to false to force re-execution of Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5</summary>
		public bool Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_isInitialised;
		/// <summary>The number of iterations last computed by Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6. Set this to zero to force re-execution of Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6</summary>
		public int Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_iterationsDone;
		/// <summary>True if Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6 has performed initialisation. Set this to false to force re-execution of Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6</summary>
		public bool Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_isInitialised;
		/// <summary>The number of iterations last computed by Changed_evidence_numTesting_eventsFeatureWeightsPosterior. Set this to zero to force re-execution of Changed_evidence_numTesting_eventsFeatureWeightsPosterior</summary>
		public int Changed_evidence_numTesting_eventsFeatureWeightsPosterior_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8. Set this to zero to force re-execution of Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8</summary>
		public int Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_iterationsDone;
		/// <summary>True if Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8 has performed initialisation. Set this to false to force re-execution of Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8</summary>
		public bool Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_isInitialised;
		/// <summary>The number of iterations last computed by Changed_evidence_numTesting_numEventsTest. Set this to zero to force re-execution of Changed_evidence_numTesting_numEventsTest</summary>
		public int Changed_evidence_numTesting_numEventsTest_iterationsDone;
		/// <summary>The number of iterations last computed by Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10. Set this to zero to force re-execution of Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10</summary>
		public int Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_iterationsDone;
		/// <summary>True if Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10 has performed initialisation. Set this to false to force re-execution of Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10</summary>
		public bool Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_isInitialised;
		/// <summary>The number of iterations last computed by Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11. Set this to zero to force re-execution of Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11</summary>
		public int Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_iterationsDone;
		/// <summary>True if Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11 has performed initialisation. Set this to false to force re-execution of Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11</summary>
		public bool Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_isInitialised;
		/// <summary>The number of iterations last computed by Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12. Set this to zero to force re-execution of Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12</summary>
		public int Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_iterationsDone;
		/// <summary>True if Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12 has performed initialisation. Set this to false to force re-execution of Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12</summary>
		public bool Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_isInitialised;
		/// <summary>Messages from use of 'dummyContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double>[] dummyContributionsTest_uses_B;
		public DistributionRefArray<VectorGaussian,Vector> vVector14_rep_B;
		public DistributionStructArray<Gaussian,double> dummyContributionsTest_F;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector14_rep_B_toDef;
		public DistributionRefArray<VectorGaussian,Vector> vVector16_rep_F;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_F;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_depth2_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public VectorGaussian vVector16_rep_B_toDef;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<Gaussian></summary>
		public DistributionStructArray<Gaussian,double> dummyContributionsTest_uses_B_Ntest__toDef;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> vVector16_rep_rep_B_toDef;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector16_rep_rep_B;
		/// <summary>Buffer for ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>></summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_uses_B_Ntest__toDef;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public VectorGaussian vVector14_rep_F_marginal;
		public DistributionRefArray<VectorGaussian,Vector> vVector14_rep_F;
		/// <summary>Buffer for InnerProductOp.BMean</summary>
		public PositiveDefiniteMatrix[] vVector14_rep_F_Ntest__BVariance;
		/// <summary>Buffer for InnerProductOp.InnerProductAverageConditional</summary>
		public Vector[] vVector14_rep_F_Ntest__BMean;
		public DistributionStructArray<Gaussian,double> vdouble40_F;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<Gaussian></summary>
		public DistributionStructArray<Gaussian,double> dummyContributionsTest_uses_F_Ntest__marginal;
		/// <summary>Messages to use of 'dummyContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double>[] dummyContributionsTest_uses_F;
		public DistributionStructArray<Gaussian,double> vdouble40_B;
		/// <summary>Message to marginal of 'vVector14'</summary>
		public VectorGaussian vVector14_marginal_F;
		/// <summary>Messages from use of 'eventsContributionsTest'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[] eventsContributionsTest_uses_B;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public VectorGaussian vVector16_rep_F_marginal;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<VectorGaussian></summary>
		public DistributionRefArray<VectorGaussian,Vector> vVector16_rep_rep_F_marginal;
		public DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]> vVector16_rep_rep_F;
		/// <summary>Buffer for InnerProductOp.BMean</summary>
		public PositiveDefiniteMatrix[][] vVector16_rep_rep_F_Etest__BVariance;
		/// <summary>Buffer for InnerProductOp.InnerProductAverageConditional</summary>
		public Vector[][] vVector16_rep_rep_F_Etest__BMean;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble44_F;
		/// <summary>Buffer for ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>></summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_uses_F_Ntest__marginal;
		/// <summary>Messages to use of 'eventsContributionsTest'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[] eventsContributionsTest_uses_F;
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> vdouble44_B;
		/// <summary>Message to marginal of 'dummyContributionsTest'</summary>
		public DistributionStructArray<Gaussian,double> dummyContributionsTest_marginal_F;
		/// <summary>Message to marginal of 'vVector16'</summary>
		public VectorGaussian vVector16_marginal_F;
		public DistributionStructArray<Gaussian,double> observedCountsTest_F;
		/// <summary>Message to marginal of 'eventsContributionsTest'</summary>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> eventsContributionsTest_marginal_F;
		public DistributionStructArray<Gaussian,double> vdouble48_F;
		/// <summary>Message to marginal of 'observedCountsTest'</summary>
		public DistributionStructArray<Gaussian,double> observedCountsTest_marginal_F;
		/// <summary>Message from use of 'observedCountsTest'</summary>
		public DistributionStructArray<Gaussian,double> observedCountsTest_use_B;
		public Bernoulli evidence_marginal;
		public PointMass<int> numTesting_marginal;
		public PointMass<VectorGaussian> dummyWeightsPosterior_marginal;
		public PointMass<Vector[]> baseFeaturesTest_marginal;
		public PointMass<int[]> numEventsTest_marginal;
		public PointMass<VectorGaussian> eventsFeatureWeightsPosterior_marginal;
		public PointMass<Vector[][]> eventsFeaturesTest_marginal;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'evidence'</summary>
		public bool evidence
		{			get {
				return this.Evidence;
			}
			set {
				if (this.Evidence!=value) {
					this.Evidence = value;
					this.numberOfIterationsDone = 0;
					this.Changed_evidence_iterationsDone = 0;
					this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_iterationsDone = 0;
					this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_iterationsDone = 0;
					this.Changed_evidence_numTesting_iterationsDone = 0;
					this.Changed_evidence_numTesting_numEventsTest_iterationsDone = 0;
					this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_iterationsDone = 0;
					this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_iterationsDone = 0;
					this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_iterationsDone = 0;
					this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_iterationsDone = 0;
					this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_iterationsDone = 0;
					this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_iterationsDone = 0;
					this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
					this.Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'numTesting'</summary>
		public int numTesting
		{			get {
				return this.NumTesting;
			}
			set {
				if (this.NumTesting!=value) {
					this.NumTesting = value;
					this.numberOfIterationsDone = 0;
					this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_isInitialised = false;
					this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_isInitialised = false;
					this.Changed_evidence_numTesting_iterationsDone = 0;
					this.Changed_evidence_numTesting_numEventsTest_iterationsDone = 0;
					this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_iterationsDone = 0;
					this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_iterationsDone = 0;
					this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_iterationsDone = 0;
					this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_iterationsDone = 0;
					this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_iterationsDone = 0;
					this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_iterationsDone = 0;
					this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
					this.Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'dummyWeightsPosterior'</summary>
		public VectorGaussian dummyWeightsPosterior
		{			get {
				return this.DummyWeightsPosterior;
			}
			set {
				this.DummyWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_iterationsDone = 0;
				this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_isInitialised = false;
				this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_isInitialised = false;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_iterationsDone = 0;
				this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'baseFeaturesTest'</summary>
		public Vector[] baseFeaturesTest
		{			get {
				return this.BaseFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'baseFeaturesTest\'");
				}
				this.BaseFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_isInitialised = false;
				this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_isInitialised = false;
				this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_isInitialised = false;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_isInitialised = false;
				this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'numEventsTest'</summary>
		public int[] numEventsTest
		{			get {
				return this.NumEventsTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'numEventsTest\'");
				}
				this.NumEventsTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_isInitialised = false;
				this.Changed_evidence_numTesting_numEventsTest_iterationsDone = 0;
				this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_iterationsDone = 0;
				this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_iterationsDone = 0;
				this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_isInitialised = false;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_isInitialised = false;
				this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsFeatureWeightsPosterior'</summary>
		public VectorGaussian eventsFeatureWeightsPosterior
		{			get {
				return this.EventsFeatureWeightsPosterior;
			}
			set {
				this.EventsFeatureWeightsPosterior = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_iterationsDone = 0;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_isInitialised = false;
				this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_iterationsDone = 0;
				this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_iterationsDone = 0;
				this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_iterationsDone = 0;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_isInitialised = false;
				this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'eventsFeaturesTest'</summary>
		public Vector[][] eventsFeaturesTest
		{			get {
				return this.EventsFeaturesTest;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTesting)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTesting)+" was expected for variable \'eventsFeaturesTest\'");
				}
				this.EventsFeaturesTest = value;
				this.numberOfIterationsDone = 0;
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_isInitialised = false;
				this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_isInitialised = false;
				this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_isInitialised = false;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_isInitialised = false;
				this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="evidence") {
				return this.evidence;
			}
			if (variableName=="numTesting") {
				return this.numTesting;
			}
			if (variableName=="dummyWeightsPosterior") {
				return this.dummyWeightsPosterior;
			}
			if (variableName=="baseFeaturesTest") {
				return this.baseFeaturesTest;
			}
			if (variableName=="numEventsTest") {
				return this.numEventsTest;
			}
			if (variableName=="eventsFeatureWeightsPosterior") {
				return this.eventsFeatureWeightsPosterior;
			}
			if (variableName=="eventsFeaturesTest") {
				return this.eventsFeaturesTest;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="evidence") {
				this.evidence = (bool)value;
				return ;
			}
			if (variableName=="numTesting") {
				this.numTesting = (int)value;
				return ;
			}
			if (variableName=="dummyWeightsPosterior") {
				this.dummyWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="baseFeaturesTest") {
				this.baseFeaturesTest = (Vector[])value;
				return ;
			}
			if (variableName=="numEventsTest") {
				this.numEventsTest = (int[])value;
				return ;
			}
			if (variableName=="eventsFeatureWeightsPosterior") {
				this.eventsFeatureWeightsPosterior = (VectorGaussian)value;
				return ;
			}
			if (variableName=="eventsFeaturesTest") {
				this.eventsFeaturesTest = (Vector[][])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="vVector14") {
				return this.VVector14Marginal();
			}
			if (variableName=="dummyContributionsTest") {
				return this.DummyContributionsTestMarginal();
			}
			if (variableName=="vVector16") {
				return this.VVector16Marginal();
			}
			if (variableName=="eventsContributionsTest") {
				return this.EventsContributionsTestMarginal();
			}
			if (variableName=="observedCountsTest") {
				return this.ObservedCountsTestMarginal();
			}
			if (variableName=="evidence") {
				return this.EvidenceMarginal();
			}
			if (variableName=="numTesting") {
				return this.NumTestingMarginal();
			}
			if (variableName=="dummyWeightsPosterior") {
				return this.DummyWeightsPosteriorMarginal();
			}
			if (variableName=="baseFeaturesTest") {
				return this.BaseFeaturesTestMarginal();
			}
			if (variableName=="numEventsTest") {
				return this.NumEventsTestMarginal();
			}
			if (variableName=="eventsFeatureWeightsPosterior") {
				return this.EventsFeatureWeightsPosteriorMarginal();
			}
			if (variableName=="eventsFeaturesTest") {
				return this.EventsFeaturesTestMarginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			if (numberOfIterations<this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone) {
				this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_isInitialised = false;
				this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_isInitialised = false;
				this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_isInitialised = false;
				this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_isInitialised = false;
				this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_isInitialised = false;
				this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_isInitialised = false;
				this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_isInitialised = false;
				this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
			}
			this.Changed_evidence();
			this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12(initialise);
			this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6(initialise);
			this.Changed_evidence_numTesting();
			this.Changed_evidence_numTesting_numEventsTest();
			this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11(initialise);
			this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10(initialise);
			this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior();
			this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8(initialise);
			this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5(initialise);
			this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3(initialise);
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4(numberOfIterations);
			this.Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that depend on the observed value of evidence</summary>
		public void Changed_evidence()
		{
			if (this.Changed_evidence_iterationsDone==1) {
				return ;
			}
			this.Changed_evidence_iterationsDone = 1;
			this.Changed_evidence_numTesting_iterationsDone = 0;
			this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_iterationsDone = 0;
			this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and eventsFeatureWeightsPosterior and must reset on changes to numberOfIterationsDecreased and numTesting and baseFeaturesTest and dummyWeightsPosterior and numEventsTest and eventsFeaturesTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12(bool initialise)
		{
			if ((this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_iterationsDone==1)&&((!initialise)||this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_isInitialised)) {
				return ;
			}
			if (this.Evidence) {
				// Message to 'vVector16_rep' from Replicate factor
				this.vVector16_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.EventsFeatureWeightsPosterior);
			}
			this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_iterationsDone = 1;
			this.Changed_evidence_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeatu12_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and dummyWeightsPosterior and must reset on changes to numberOfIterationsDecreased and numTesting and baseFeaturesTest and numEventsTest and eventsFeaturesTest and eventsFeatureWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6(bool initialise)
		{
			if ((this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_iterationsDone==1)&&((!initialise)||this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_isInitialised)) {
				return ;
			}
			if (this.Evidence) {
				// Message to 'vVector14_rep' from Replicate factor
				this.vVector14_rep_B_toDef = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.DummyWeightsPosterior);
			}
			this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_iterationsDone = 1;
			this.Changed_evidence_dummyWeightsPosterior_Init_numberOfIterationsDecreased_numTesting_baseFeaturesTest_6_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTesting</summary>
		public void Changed_evidence_numTesting()
		{
			if (this.Changed_evidence_numTesting_iterationsDone==1) {
				return ;
			}
			if (this.Evidence) {
				// Create array for 'dummyContributionsTest_uses' Backwards messages.
				this.dummyContributionsTest_uses_B = new DistributionStructArray<Gaussian,double>[this.NumTesting];
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for 'dummyContributionsTest_uses' Backwards messages.
					this.dummyContributionsTest_uses_B[Ntest] = new DistributionStructArray<Gaussian,double>(2);
				}
				// Create array for 'vVector14_rep' Backwards messages.
				this.vVector14_rep_B = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
				// Create array for 'dummyContributionsTest' Forwards messages.
				this.dummyContributionsTest_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.dummyContributionsTest_F[Ntest] = Gaussian.Uniform();
				}
				// Create array for replicates of 'dummyContributionsTest_uses_B_Ntest__toDef'
				this.dummyContributionsTest_uses_B_Ntest__toDef = new DistributionStructArray<Gaussian,double>(this.NumTesting);
				// Create array for 'vVector16_rep' Forwards messages.
				this.vVector16_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
				// Create array for replicates of 'vVector16_rep_rep_B_toDef'
				this.vVector16_rep_rep_B_toDef = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
				// Create array for replicates of 'vVector16_rep_rep_B'
				this.vVector16_rep_rep_B = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
				// Create array for 'eventsContributionsTest' Forwards messages.
				this.eventsContributionsTest_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
				// Create array for 'eventsContributionsTest_depth2' Backwards messages.
				this.eventsContributionsTest_depth2_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
				// Create array for replicates of 'eventsContributionsTest_uses_B_Ntest__toDef'
				this.eventsContributionsTest_uses_B_Ntest__toDef = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
			}
			this.Changed_evidence_numTesting_iterationsDone = 1;
			this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_iterationsDone = 0;
			this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
			this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_iterationsDone = 0;
			this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_iterationsDone = 0;
			this.Changed_evidence_numTesting_numEventsTest_iterationsDone = 0;
			this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTesting and numEventsTest</summary>
		public void Changed_evidence_numTesting_numEventsTest()
		{
			if (this.Changed_evidence_numTesting_numEventsTest_iterationsDone==1) {
				return ;
			}
			if (this.Evidence) {
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for 'vVector16_rep_rep' Backwards messages.
					this.vVector16_rep_rep_B[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
					// Create array for 'eventsContributionsTest' Forwards messages.
					this.eventsContributionsTest_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.eventsContributionsTest_F[Ntest][Etest] = Gaussian.Uniform();
					}
					// Create array for 'eventsContributionsTest_depth2' Backwards messages.
					this.eventsContributionsTest_depth2_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
				}
			}
			this.Changed_evidence_numTesting_numEventsTest_iterationsDone = 1;
			this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
			this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTesting and numEventsTest and must reset on changes to numberOfIterationsDecreased and baseFeaturesTest and dummyWeightsPosterior and eventsFeaturesTest and eventsFeatureWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11(bool initialise)
		{
			if ((this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_iterationsDone==1)&&((!initialise)||this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_isInitialised)) {
				return ;
			}
			if (this.Evidence) {
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.eventsContributionsTest_depth2_B[Ntest][Etest] = Gaussian.Uniform();
					}
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDefInit<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_F[Ntest]);
				}
			}
			this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_iterationsDone = 1;
			this.Changed_evidence_numTesting_numEventsTest_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWei11_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTesting and numEventsTest and eventsFeatureWeightsPosterior and must reset on changes to numberOfIterationsDecreased and baseFeaturesTest and dummyWeightsPosterior and eventsFeaturesTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10(bool initialise)
		{
			if ((this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_iterationsDone==1)&&((!initialise)||this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_isInitialised)) {
				return ;
			}
			if (this.Evidence) {
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.vVector16_rep_rep_B[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsFeatureWeightsPosterior);
					}
				}
			}
			this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_iterationsDone = 1;
			this.Changed_evidence_numTesting_numEventsTest_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecre10_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTesting and eventsFeatureWeightsPosterior</summary>
		public void Changed_evidence_numTesting_eventsFeatureWeightsPosterior()
		{
			if (this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_iterationsDone==1) {
				return ;
			}
			if (this.Evidence) {
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.vVector16_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsFeatureWeightsPosterior);
				}
			}
			this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_iterationsDone = 1;
			this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_iterationsDone = 0;
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTesting and eventsFeatureWeightsPosterior and must reset on changes to numberOfIterationsDecreased and baseFeaturesTest and dummyWeightsPosterior and numEventsTest and eventsFeaturesTest</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8(bool initialise)
		{
			if ((this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_iterationsDone==1)&&((!initialise)||this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_isInitialised)) {
				return ;
			}
			if (this.Evidence) {
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector16_rep_rep' from Replicate factor
					this.vVector16_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDefInit<VectorGaussian>(this.vVector16_rep_F[Ntest]);
				}
			}
			this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_iterationsDone = 1;
			this.Changed_evidence_numTesting_eventsFeatureWeightsPosterior_Init_numberOfIterationsDecreased_baseFeatu8_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTesting and dummyWeightsPosterior and must reset on changes to numberOfIterationsDecreased and baseFeaturesTest and numEventsTest and eventsFeaturesTest and eventsFeatureWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5(bool initialise)
		{
			if ((this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_iterationsDone==1)&&((!initialise)||this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_isInitialised)) {
				return ;
			}
			if (this.Evidence) {
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.vVector14_rep_B[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.DummyWeightsPosterior);
				}
			}
			this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_iterationsDone = 1;
			this.Changed_evidence_numTesting_dummyWeightsPosterior_Init_numberOfIterationsDecreased_baseFeaturesTest_5_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTesting and must reset on changes to numberOfIterationsDecreased and baseFeaturesTest and dummyWeightsPosterior and numEventsTest and eventsFeaturesTest and eventsFeatureWeightsPosterior</summary>
		/// <param name="initialise">If true, reset messages that initialise loops</param>
		public void Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3(bool initialise)
		{
			if ((this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_iterationsDone==1)&&((!initialise)||this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_isInitialised)) {
				return ;
			}
			if (this.Evidence) {
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					for(int _ind = 0; _ind<2; _ind++) {
						this.dummyContributionsTest_uses_B[Ntest][_ind] = Gaussian.Uniform();
					}
					// Message to 'dummyContributionsTest_uses' from Replicate factor
					this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDefInit<Gaussian>(this.dummyContributionsTest_F[Ntest]);
				}
			}
			this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_iterationsDone = 1;
			this.Changed_evidence_numTesting_Init_numberOfIterationsDecreased_baseFeaturesTest_dummyWeightsPosterior_3_isInitialised = true;
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = 0;
		}

		/// <summary>Computations that depend on the observed value of numberOfIterationsDecreased and evidence and numTesting and baseFeaturesTest and dummyWeightsPosterior and numEventsTest and eventsFeaturesTest and eventsFeatureWeightsPosterior</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		public void Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4(int numberOfIterations)
		{
			if (this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone==numberOfIterations) {
				return ;
			}
			if (this.Evidence) {
				// Message to 'vVector14_rep' from Replicate factor
				this.vVector14_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.DummyWeightsPosterior);
				// Create array for 'vVector14_rep' Forwards messages.
				this.vVector14_rep_F = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.vVector14_rep_F[Ntest] = ArrayHelper.MakeUniform<VectorGaussian>(this.DummyWeightsPosterior);
				}
				// Create array for replicates of 'vVector14_rep_F_Ntest__BVariance'
				this.vVector14_rep_F_Ntest__BVariance = new PositiveDefiniteMatrix[this.NumTesting];
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vdouble40' from InnerProduct factor
					this.vVector14_rep_F_Ntest__BVariance[Ntest] = InnerProductOp.BVarianceInit(this.vVector14_rep_F[Ntest]);
				}
				// Create array for replicates of 'vVector14_rep_F_Ntest__BMean'
				this.vVector14_rep_F_Ntest__BMean = new Vector[this.NumTesting];
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vdouble40' from InnerProduct factor
					this.vVector14_rep_F_Ntest__BMean[Ntest] = InnerProductOp.BMeanInit(this.vVector14_rep_F[Ntest]);
				}
				// Create array for replicates of 'vdouble40_F'
				this.vdouble40_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.vdouble40_F[Ntest] = Gaussian.Uniform();
				}
				// Create array for replicates of 'dummyContributionsTest_uses_F_Ntest__marginal'
				this.dummyContributionsTest_uses_F_Ntest__marginal = new DistributionStructArray<Gaussian,double>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'dummyContributionsTest_uses' from Replicate factor
					this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.MarginalInit<Gaussian>(this.dummyContributionsTest_F[Ntest]);
				}
				// Create array for 'dummyContributionsTest_uses' Forwards messages.
				this.dummyContributionsTest_uses_F = new DistributionStructArray<Gaussian,double>[this.NumTesting];
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for 'dummyContributionsTest_uses' Forwards messages.
					this.dummyContributionsTest_uses_F[Ntest] = new DistributionStructArray<Gaussian,double>(2);
					for(int _ind = 0; _ind<2; _ind++) {
						this.dummyContributionsTest_uses_F[Ntest][_ind] = Gaussian.Uniform();
					}
				}
				// Create array for replicates of 'vdouble40_B'
				this.vdouble40_B = new DistributionStructArray<Gaussian,double>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.vdouble40_B[Ntest] = Gaussian.Uniform();
				}
				// Message to 'vVector14_rep' from Replicate factor
				this.vVector14_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector14_rep_B_toDef, this.DummyWeightsPosterior, this.vVector14_rep_F_marginal);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector14_rep' from Replicate factor
					this.vVector14_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector14_rep_B[Ntest], this.vVector14_rep_F_marginal, Ntest, this.vVector14_rep_F[Ntest]);
					// Message to 'vdouble40' from InnerProduct factor
					this.vVector14_rep_F_Ntest__BVariance[Ntest] = InnerProductOp.BVariance(this.vVector14_rep_F[Ntest], this.vVector14_rep_F_Ntest__BVariance[Ntest]);
					// Message to 'vdouble40' from InnerProduct factor
					this.vVector14_rep_F_Ntest__BMean[Ntest] = InnerProductOp.BMean(this.vVector14_rep_F[Ntest], this.vVector14_rep_F_Ntest__BVariance[Ntest], this.vVector14_rep_F_Ntest__BMean[Ntest]);
					// Message to 'vdouble40' from InnerProduct factor
					this.vdouble40_F[Ntest] = InnerProductOp.InnerProductAverageConditional(this.BaseFeaturesTest[Ntest], this.vVector14_rep_F_Ntest__BMean[Ntest], this.vVector14_rep_F_Ntest__BVariance[Ntest]);
					// Message to 'dummyContributionsTest' from GaussianFromMeanAndVariance factor
					this.dummyContributionsTest_F[Ntest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(this.vdouble40_F[Ntest], 5.0);
					// Message to 'dummyContributionsTest_uses' from Replicate factor
					this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<Gaussian>(this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest], this.dummyContributionsTest_F[Ntest], this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest]);
				}
			}
			for(int iteration = this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone; iteration<numberOfIterations; iteration++) {
				if (this.Evidence) {
					for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
						// Message to 'dummyContributionsTest_uses' from Replicate factor
						this.dummyContributionsTest_uses_F[Ntest][0] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.dummyContributionsTest_uses_B[Ntest][0], this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest], 0, this.dummyContributionsTest_uses_F[Ntest][0]);
						// Message to 'dummyContributionsTest_uses' from IsPositive factor
						this.dummyContributionsTest_uses_B[Ntest][0] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), this.dummyContributionsTest_uses_F[Ntest][0]);
						// Message to 'dummyContributionsTest_uses' from Replicate factor
						this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<Gaussian>(this.dummyContributionsTest_uses_B[Ntest], this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest]);
						// Message to 'vdouble40' from GaussianFromMeanAndVariance factor
						this.vdouble40_B[Ntest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest], 5.0);
						// Message to 'vVector14_rep' from InnerProduct factor
						this.vVector14_rep_B[Ntest] = InnerProductOp.BAverageConditional(this.vdouble40_B[Ntest], this.BaseFeaturesTest[Ntest], this.vVector14_rep_B[Ntest]);
					}
					// Message to 'vVector14_rep' from Replicate factor
					this.vVector14_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector14_rep_B, this.vVector14_rep_B_toDef);
					// Message to 'vVector14_rep' from Replicate factor
					this.vVector14_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector14_rep_B_toDef, this.DummyWeightsPosterior, this.vVector14_rep_F_marginal);
					for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
						// Message to 'vVector14_rep' from Replicate factor
						this.vVector14_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector14_rep_B[Ntest], this.vVector14_rep_F_marginal, Ntest, this.vVector14_rep_F[Ntest]);
						// Message to 'vdouble40' from InnerProduct factor
						this.vVector14_rep_F_Ntest__BVariance[Ntest] = InnerProductOp.BVariance(this.vVector14_rep_F[Ntest], this.vVector14_rep_F_Ntest__BVariance[Ntest]);
						// Message to 'vdouble40' from InnerProduct factor
						this.vVector14_rep_F_Ntest__BMean[Ntest] = InnerProductOp.BMean(this.vVector14_rep_F[Ntest], this.vVector14_rep_F_Ntest__BVariance[Ntest], this.vVector14_rep_F_Ntest__BMean[Ntest]);
						// Message to 'vdouble40' from InnerProduct factor
						this.vdouble40_F[Ntest] = InnerProductOp.InnerProductAverageConditional(this.BaseFeaturesTest[Ntest], this.vVector14_rep_F_Ntest__BMean[Ntest], this.vVector14_rep_F_Ntest__BVariance[Ntest]);
						// Message to 'dummyContributionsTest' from GaussianFromMeanAndVariance factor
						this.dummyContributionsTest_F[Ntest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(this.vdouble40_F[Ntest], 5.0);
						// Message to 'dummyContributionsTest_uses' from Replicate factor
						this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<Gaussian>(this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest], this.dummyContributionsTest_F[Ntest], this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest]);
					}
				}
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			if (this.Evidence) {
				this.vVector14_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.DummyWeightsPosterior);
				// Message to 'vVector14_marginal' from Variable factor
				this.vVector14_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector14_rep_B_toDef, this.DummyWeightsPosterior, this.vVector14_marginal_F);
				// Create array for 'eventsContributionsTest_uses' Backwards messages.
				this.eventsContributionsTest_uses_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[this.NumTesting];
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for 'eventsContributionsTest_uses' Backwards messages.
					this.eventsContributionsTest_uses_B[Ntest] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(2);
					for(int _ind = 0; _ind<2; _ind++) {
						// Create array for 'eventsContributionsTest_uses' Backwards messages.
						this.eventsContributionsTest_uses_B[Ntest][_ind] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
						for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
							this.eventsContributionsTest_uses_B[Ntest][_ind][Etest] = Gaussian.Uniform();
						}
					}
				}
				// Message to 'vVector16_rep' from Replicate factor
				this.vVector16_rep_F_marginal = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.EventsFeatureWeightsPosterior);
				// Create array for replicates of 'vVector16_rep_rep_F_marginal'
				this.vVector16_rep_rep_F_marginal = new DistributionRefArray<VectorGaussian,Vector>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector16_rep_rep' from Replicate factor
					this.vVector16_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.MarginalInit<VectorGaussian>(this.vVector16_rep_F[Ntest]);
				}
				// Create array for replicates of 'vVector16_rep_rep_F'
				this.vVector16_rep_rep_F = new DistributionRefArray<DistributionRefArray<VectorGaussian,Vector>,Vector[]>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for 'vVector16_rep_rep' Forwards messages.
					this.vVector16_rep_rep_F[Ntest] = new DistributionRefArray<VectorGaussian,Vector>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.vVector16_rep_rep_F[Ntest][Etest] = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsFeatureWeightsPosterior);
					}
				}
				// Create array for replicates of 'vVector16_rep_rep_F_Etest__BVariance'
				this.vVector16_rep_rep_F_Etest__BVariance = new PositiveDefiniteMatrix[this.NumTesting][];
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for replicates of 'vVector16_rep_rep_F_Etest__BVariance'
					this.vVector16_rep_rep_F_Etest__BVariance[Ntest] = new PositiveDefiniteMatrix[this.NumEventsTest[Ntest]];
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vdouble44' from InnerProduct factor
						this.vVector16_rep_rep_F_Etest__BVariance[Ntest][Etest] = InnerProductOp.BVarianceInit(this.vVector16_rep_rep_F[Ntest][Etest]);
					}
				}
				// Create array for replicates of 'vVector16_rep_rep_F_Etest__BMean'
				this.vVector16_rep_rep_F_Etest__BMean = new Vector[this.NumTesting][];
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for replicates of 'vVector16_rep_rep_F_Etest__BMean'
					this.vVector16_rep_rep_F_Etest__BMean[Ntest] = new Vector[this.NumEventsTest[Ntest]];
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vdouble44' from InnerProduct factor
						this.vVector16_rep_rep_F_Etest__BMean[Ntest][Etest] = InnerProductOp.BMeanInit(this.vVector16_rep_rep_F[Ntest][Etest]);
					}
				}
				// Create array for replicates of 'vdouble44_F'
				this.vdouble44_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for replicates of 'vdouble44_F'
					this.vdouble44_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.vdouble44_F[Ntest][Etest] = Gaussian.Uniform();
					}
				}
				// Create array for replicates of 'eventsContributionsTest_uses_F_Ntest__marginal'
				this.eventsContributionsTest_uses_F_Ntest__marginal = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.MarginalInit<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_F[Ntest]);
				}
				// Create array for 'eventsContributionsTest_uses' Forwards messages.
				this.eventsContributionsTest_uses_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>[this.NumTesting];
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for 'eventsContributionsTest_uses' Forwards messages.
					this.eventsContributionsTest_uses_F[Ntest] = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(2);
					for(int _ind = 0; _ind<2; _ind++) {
						// Create array for 'eventsContributionsTest_uses' Forwards messages.
						this.eventsContributionsTest_uses_F[Ntest][_ind] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
						for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
							this.eventsContributionsTest_uses_F[Ntest][_ind][Etest] = Gaussian.Uniform();
						}
					}
				}
				// Create array for replicates of 'vdouble44_B'
				this.vdouble44_B = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for replicates of 'vdouble44_B'
					this.vdouble44_B[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.vdouble44_B[Ntest][Etest] = Gaussian.Uniform();
					}
				}
				// Message to 'vVector16_rep' from Replicate factor
				this.vVector16_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector16_rep_B_toDef, this.EventsFeatureWeightsPosterior, this.vVector16_rep_F_marginal);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Message to 'vVector16_rep' from Replicate factor
					this.vVector16_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector16_rep_rep_B_toDef[Ntest], this.vVector16_rep_F_marginal, Ntest, this.vVector16_rep_F[Ntest]);
					// Message to 'vVector16_rep_rep' from Replicate factor
					this.vVector16_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector16_rep_rep_B_toDef[Ntest], this.vVector16_rep_F[Ntest], this.vVector16_rep_rep_F_marginal[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						// Message to 'vVector16_rep_rep' from Replicate factor
						this.vVector16_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector16_rep_rep_B[Ntest][Etest], this.vVector16_rep_rep_F_marginal[Ntest], Etest, this.vVector16_rep_rep_F[Ntest][Etest]);
						// Message to 'vdouble44' from InnerProduct factor
						this.vVector16_rep_rep_F_Etest__BVariance[Ntest][Etest] = InnerProductOp.BVariance(this.vVector16_rep_rep_F[Ntest][Etest], this.vVector16_rep_rep_F_Etest__BVariance[Ntest][Etest]);
						// Message to 'vdouble44' from InnerProduct factor
						this.vVector16_rep_rep_F_Etest__BMean[Ntest][Etest] = InnerProductOp.BMean(this.vVector16_rep_rep_F[Ntest][Etest], this.vVector16_rep_rep_F_Etest__BVariance[Ntest][Etest], this.vVector16_rep_rep_F_Etest__BMean[Ntest][Etest]);
						// Message to 'vdouble44' from InnerProduct factor
						this.vdouble44_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsFeaturesTest[Ntest][Etest], this.vVector16_rep_rep_F_Etest__BMean[Ntest][Etest], this.vVector16_rep_rep_F_Etest__BVariance[Ntest][Etest]);
						// Message to 'eventsContributionsTest' from GaussianFromMeanAndVariance factor
						this.eventsContributionsTest_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(this.vdouble44_F[Ntest][Etest], 5.0);
					}
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest], this.eventsContributionsTest_F[Ntest], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest]);
				}
				// Create array for 'dummyContributionsTest_marginal' Forwards messages.
				this.dummyContributionsTest_marginal_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.dummyContributionsTest_marginal_F[Ntest] = Gaussian.Uniform();
					// Message to 'dummyContributionsTest_marginal' from Variable factor
					this.dummyContributionsTest_marginal_F[Ntest] = VariableOp.MarginalAverageConditional<Gaussian>(this.dummyContributionsTest_uses_B_Ntest__toDef[Ntest], this.dummyContributionsTest_F[Ntest], this.dummyContributionsTest_marginal_F[Ntest]);
				}
			}
			for(int iteration = this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone; iteration<numberOfIterations; iteration++) {
				if (this.Evidence) {
					for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
						// Message to 'eventsContributionsTest_uses' from Replicate factor
						this.eventsContributionsTest_uses_F[Ntest][0] = ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_depth2_B[Ntest], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest], 0, this.eventsContributionsTest_uses_F[Ntest][0]);
						for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
							// Message to 'eventsContributionsTest_depth2' from IsPositive factor
							this.eventsContributionsTest_depth2_B[Ntest][Etest] = IsPositiveOp_Proper.XAverageConditional(Bernoulli.PointMass(true), this.eventsContributionsTest_uses_F[Ntest][0][Etest]);
							// Message to 'eventsContributionsTest_uses' from Copy factor
							this.eventsContributionsTest_uses_B[Ntest][0][Etest] = ArrayHelper.SetTo<Gaussian>(this.eventsContributionsTest_uses_B[Ntest][0][Etest], this.eventsContributionsTest_depth2_B[Ntest][Etest]);
						}
						// Message to 'eventsContributionsTest_uses' from Replicate factor
						this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest] = ReplicateOp_Divide.ToDef<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B[Ntest], this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest]);
						for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
							// Message to 'vdouble44' from GaussianFromMeanAndVariance factor
							this.vdouble44_B[Ntest][Etest] = GaussianFromMeanAndVarianceOp.MeanAverageConditional(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest][Etest], 5.0);
							// Message to 'vVector16_rep_rep' from InnerProduct factor
							this.vVector16_rep_rep_B[Ntest][Etest] = InnerProductOp.BAverageConditional(this.vdouble44_B[Ntest][Etest], this.EventsFeaturesTest[Ntest][Etest], this.vVector16_rep_rep_B[Ntest][Etest]);
						}
						// Message to 'vVector16_rep_rep' from Replicate factor
						this.vVector16_rep_rep_B_toDef[Ntest] = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector16_rep_rep_B[Ntest], this.vVector16_rep_rep_B_toDef[Ntest]);
					}
					// Message to 'vVector16_rep' from Replicate factor
					this.vVector16_rep_B_toDef = ReplicateOp_Divide.ToDef<VectorGaussian>(this.vVector16_rep_rep_B_toDef, this.vVector16_rep_B_toDef);
					// Message to 'vVector16_rep' from Replicate factor
					this.vVector16_rep_F_marginal = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector16_rep_B_toDef, this.EventsFeatureWeightsPosterior, this.vVector16_rep_F_marginal);
					for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
						// Message to 'vVector16_rep' from Replicate factor
						this.vVector16_rep_F[Ntest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector16_rep_rep_B_toDef[Ntest], this.vVector16_rep_F_marginal, Ntest, this.vVector16_rep_F[Ntest]);
						// Message to 'vVector16_rep_rep' from Replicate factor
						this.vVector16_rep_rep_F_marginal[Ntest] = ReplicateOp_Divide.Marginal<VectorGaussian>(this.vVector16_rep_rep_B_toDef[Ntest], this.vVector16_rep_F[Ntest], this.vVector16_rep_rep_F_marginal[Ntest]);
						for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
							// Message to 'vVector16_rep_rep' from Replicate factor
							this.vVector16_rep_rep_F[Ntest][Etest] = ReplicateOp_Divide.UsesAverageConditional<VectorGaussian>(this.vVector16_rep_rep_B[Ntest][Etest], this.vVector16_rep_rep_F_marginal[Ntest], Etest, this.vVector16_rep_rep_F[Ntest][Etest]);
							// Message to 'vdouble44' from InnerProduct factor
							this.vVector16_rep_rep_F_Etest__BVariance[Ntest][Etest] = InnerProductOp.BVariance(this.vVector16_rep_rep_F[Ntest][Etest], this.vVector16_rep_rep_F_Etest__BVariance[Ntest][Etest]);
							// Message to 'vdouble44' from InnerProduct factor
							this.vVector16_rep_rep_F_Etest__BMean[Ntest][Etest] = InnerProductOp.BMean(this.vVector16_rep_rep_F[Ntest][Etest], this.vVector16_rep_rep_F_Etest__BVariance[Ntest][Etest], this.vVector16_rep_rep_F_Etest__BMean[Ntest][Etest]);
							// Message to 'vdouble44' from InnerProduct factor
							this.vdouble44_F[Ntest][Etest] = InnerProductOp.InnerProductAverageConditional(this.EventsFeaturesTest[Ntest][Etest], this.vVector16_rep_rep_F_Etest__BMean[Ntest][Etest], this.vVector16_rep_rep_F_Etest__BVariance[Ntest][Etest]);
							// Message to 'eventsContributionsTest' from GaussianFromMeanAndVariance factor
							this.eventsContributionsTest_F[Ntest][Etest] = GaussianFromMeanAndVarianceOp.SampleAverageConditional(this.vdouble44_F[Ntest][Etest], 5.0);
						}
						// Message to 'eventsContributionsTest_uses' from Replicate factor
						this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest] = ReplicateOp_Divide.Marginal<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest], this.eventsContributionsTest_F[Ntest], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest]);
					}
				}
				this.OnProgressChanged(new ProgressChangedEventArgs(iteration));
			}
			if (this.Evidence) {
				this.vVector16_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(this.EventsFeatureWeightsPosterior);
				// Message to 'vVector16_marginal' from Variable factor
				this.vVector16_marginal_F = VariableOp.MarginalAverageConditional<VectorGaussian>(this.vVector16_rep_B_toDef, this.EventsFeatureWeightsPosterior, this.vVector16_marginal_F);
				// Create array for 'observedCountsTest' Forwards messages.
				this.observedCountsTest_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.observedCountsTest_F[Ntest] = Gaussian.Uniform();
					// Message to 'dummyContributionsTest_uses' from Replicate factor
					this.dummyContributionsTest_uses_F[Ntest][1] = ReplicateOp_Divide.UsesAverageConditional<Gaussian>(this.dummyContributionsTest_uses_B[Ntest][1], this.dummyContributionsTest_uses_F_Ntest__marginal[Ntest], 1, this.dummyContributionsTest_uses_F[Ntest][1]);
				}
				// Create array for 'eventsContributionsTest_marginal' Forwards messages.
				this.eventsContributionsTest_marginal_F = new DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					// Create array for 'eventsContributionsTest_marginal' Forwards messages.
					this.eventsContributionsTest_marginal_F[Ntest] = new DistributionStructArray<Gaussian,double>(this.NumEventsTest[Ntest]);
					for(int Etest = 0; Etest<this.NumEventsTest[Ntest]; Etest++) {
						this.eventsContributionsTest_marginal_F[Ntest][Etest] = Gaussian.Uniform();
						// Message to 'eventsContributionsTest_marginal' from Variable factor
						this.eventsContributionsTest_marginal_F[Ntest][Etest] = VariableOp.MarginalAverageConditional<Gaussian>(this.eventsContributionsTest_uses_B_Ntest__toDef[Ntest][Etest], this.eventsContributionsTest_F[Ntest][Etest], this.eventsContributionsTest_marginal_F[Ntest][Etest]);
					}
					// Message to 'eventsContributionsTest_uses' from Replicate factor
					this.eventsContributionsTest_uses_F[Ntest][1] = ReplicateOp_Divide.UsesAverageConditional<DistributionStructArray<Gaussian,double>>(this.eventsContributionsTest_uses_B[Ntest][1], this.eventsContributionsTest_uses_F_Ntest__marginal[Ntest], 1, this.eventsContributionsTest_uses_F[Ntest][1]);
				}
				// Create array for replicates of 'vdouble48_F'
				this.vdouble48_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.vdouble48_F[Ntest] = Gaussian.Uniform();
					// Message to 'vdouble48' from Sum factor
					this.vdouble48_F[Ntest] = FastSumOp.SumAverageConditional(this.eventsContributionsTest_uses_F[Ntest][1]);
				}
				// Create array for 'observedCountsTest_marginal' Forwards messages.
				this.observedCountsTest_marginal_F = new DistributionStructArray<Gaussian,double>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.observedCountsTest_marginal_F[Ntest] = Gaussian.Uniform();
				}
				// Create array for 'observedCountsTest_use' Backwards messages.
				this.observedCountsTest_use_B = new DistributionStructArray<Gaussian,double>(this.NumTesting);
				for(int Ntest = 0; Ntest<this.NumTesting; Ntest++) {
					this.observedCountsTest_use_B[Ntest] = Gaussian.Uniform();
					// Message to 'observedCountsTest' from Plus factor
					this.observedCountsTest_F[Ntest] = DoublePlusOp.SumAverageConditional(this.dummyContributionsTest_uses_F[Ntest][1], this.vdouble48_F[Ntest]);
					// Message to 'observedCountsTest_marginal' from DerivedVariable factor
					this.observedCountsTest_marginal_F[Ntest] = DerivedVariableOp.MarginalAverageConditional<Gaussian>(this.observedCountsTest_use_B[Ntest], this.observedCountsTest_F[Ntest], this.observedCountsTest_marginal_F[Ntest]);
				}
			}
			this.Changed_numberOfIterationsDecreased_evidence_numTesting_baseFeaturesTest_dummyWeightsPosterior_numEv4_iterationsDone = numberOfIterations;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector14' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector14Marginal()
		{
			return this.vVector14_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'dummyContributionsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> DummyContributionsTestMarginal()
		{
			return this.dummyContributionsTest_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'vVector16' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian VVector16Marginal()
		{
			return this.vVector16_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsContributionsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionRefArray<DistributionStructArray<Gaussian,double>,double[]> EventsContributionsTestMarginal()
		{
			return this.eventsContributionsTest_marginal_F;
		}

		/// <summary>
		/// Returns the marginal distribution for 'observedCountsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> ObservedCountsTestMarginal()
		{
			return this.observedCountsTest_marginal_F;
		}

		/// <summary>Computations that depend on the observed value of evidence and numTesting and dummyWeightsPosterior and baseFeaturesTest and numEventsTest and eventsFeatureWeightsPosterior and eventsFeaturesTest</summary>
		public void Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0()
		{
			if (this.Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0_iterationsDone==1) {
				return ;
			}
			this.evidence_marginal = Bernoulli.Uniform();
			this.evidence_marginal = Distribution.SetPoint<Bernoulli,bool>(this.evidence_marginal, this.Evidence);
			this.numTesting_marginal = new PointMass<int>(this.NumTesting);
			this.dummyWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.DummyWeightsPosterior);
			this.baseFeaturesTest_marginal = new PointMass<Vector[]>(this.BaseFeaturesTest);
			this.numEventsTest_marginal = new PointMass<int[]>(this.NumEventsTest);
			this.eventsFeatureWeightsPosterior_marginal = new PointMass<VectorGaussian>(this.EventsFeatureWeightsPosterior);
			this.eventsFeaturesTest_marginal = new PointMass<Vector[][]>(this.EventsFeaturesTest);
			this.Changed_evidence_numTesting_dummyWeightsPosterior_baseFeaturesTest_numEventsTest_eventsFeatureWeight0_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'evidence' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public Bernoulli EvidenceMarginal()
		{
			return this.evidence_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numTesting' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int> NumTestingMarginal()
		{
			return this.numTesting_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'dummyWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> DummyWeightsPosteriorMarginal()
		{
			return this.dummyWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'baseFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[]> BaseFeaturesTestMarginal()
		{
			return this.baseFeaturesTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numEventsTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int[]> NumEventsTestMarginal()
		{
			return this.numEventsTest_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsFeatureWeightsPosterior' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<VectorGaussian> EventsFeatureWeightsPosteriorMarginal()
		{
			return this.eventsFeatureWeightsPosterior_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'eventsFeaturesTest' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[][]> EventsFeaturesTestMarginal()
		{
			return this.eventsFeaturesTest_marginal;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
