using System;
using MicrosoftResearch.Infer;
using MicrosoftResearch.Infer.Maths;
using MicrosoftResearch.Infer.Distributions;
using MicrosoftResearch.Infer.Collections;
using MicrosoftResearch.Infer.Factors;

namespace MicrosoftResearch.Infer.Models.User
{
	/// <summary>
	/// Generated algorithm for performing inference
	/// </summary>
	/// <remarks>
	/// The easiest way to use this class is to wrap an instance in a CompiledAlgorithm object and use
	/// the methods on CompiledAlgorithm to set parameters and execute inference.
	/// 
	/// If you instead wish to use this class directly, you must perform the following steps:
	/// 1) Create an instance of the class
	/// 2) Set the value of any externally-set fields e.g. data, priors
	/// 3) Call the Execute(numberOfIterations) method
	/// 4) Use the XXXMarginal() methods to retrieve posterior marginals for different variables.
	/// 
	/// Generated by Infer.NET 2.5 at 15:10 on segunda-feira, 29 de Julho de 2013.
	/// </remarks>
	public partial class Model_VMP : IGeneratedAlgorithm
	{
		#region Fields
		/// <summary>Field backing the NumberOfIterationsDone property</summary>
		private int numberOfIterationsDone;
		/// <summary>Field backing the numTraining property</summary>
		private int NumTraining;
		/// <summary>Field backing the xTrain property</summary>
		private Vector[] XTrain;
		/// <summary>Field backing the yTrain property</summary>
		private double[] YTrain;
		/// <summary>The number of iterations last computed by Changed_numTraining_xTrain_yTrain. Set this to zero to force re-execution of Changed_numTraining_xTrain_yTrain</summary>
		public int Changed_numTraining_xTrain_yTrain_iterationsDone;
		public PointMass<int> numTraining_marginal;
		public PointMass<Vector[]> xTrain_marginal;
		public DistributionStructArray<Gaussian,double> yTrain_marginal;
		/// <summary>Message to marginal of 'weights'</summary>
		public VectorGaussian weights_marginal_F;
		#endregion

		#region Properties
		/// <summary>The number of iterations done from the initial state</summary>
		public int NumberOfIterationsDone
		{			get {
				return this.numberOfIterationsDone;
			}
		}

		/// <summary>The externally-specified value of 'numTraining'</summary>
		public int numTraining
		{			get {
				return this.NumTraining;
			}
			set {
				if (this.NumTraining!=value) {
					this.NumTraining = value;
					this.numberOfIterationsDone = 0;
					this.Changed_numTraining_xTrain_yTrain_iterationsDone = 0;
				}
			}
		}

		/// <summary>The externally-specified value of 'xTrain'</summary>
		public Vector[] xTrain
		{			get {
				return this.XTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTraining)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTraining)+" was expected for variable \'xTrain\'");
				}
				this.XTrain = value;
				this.numberOfIterationsDone = 0;
				this.Changed_numTraining_xTrain_yTrain_iterationsDone = 0;
			}
		}

		/// <summary>The externally-specified value of 'yTrain'</summary>
		public double[] yTrain
		{			get {
				return this.YTrain;
			}
			set {
				if ((value!=null)&&(value.Length!=this.NumTraining)) {
					throw new ArgumentException(((("Provided array of length "+value.Length)+" when length ")+this.NumTraining)+" was expected for variable \'yTrain\'");
				}
				this.YTrain = value;
				this.numberOfIterationsDone = 0;
				this.Changed_numTraining_xTrain_yTrain_iterationsDone = 0;
			}
		}

		#endregion

		#region Methods
		/// <summary>Get the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object GetObservedValue(string variableName)
		{
			if (variableName=="numTraining") {
				return this.numTraining;
			}
			if (variableName=="xTrain") {
				return this.xTrain;
			}
			if (variableName=="yTrain") {
				return this.yTrain;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>Set the observed value of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="value">Observed value</param>
		public void SetObservedValue(string variableName, object value)
		{
			if (variableName=="numTraining") {
				this.numTraining = (int)value;
				return ;
			}
			if (variableName=="xTrain") {
				this.xTrain = (Vector[])value;
				return ;
			}
			if (variableName=="yTrain") {
				this.yTrain = (double[])value;
				return ;
			}
			throw new ArgumentException("Not an observed variable name: "+variableName);
		}

		/// <summary>The marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		public object Marginal(string variableName)
		{
			if (variableName=="numTraining") {
				return this.NumTrainingMarginal();
			}
			if (variableName=="xTrain") {
				return this.XTrainMarginal();
			}
			if (variableName=="yTrain") {
				return this.YTrainMarginal();
			}
			if (variableName=="weights") {
				return this.WeightsMarginal();
			}
			throw new ArgumentException("This class was not built to infer "+variableName);
		}

		public T Marginal<T>(string variableName)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName));
		}

		/// <summary>The query-specific marginal distribution of the specified variable.</summary>
		/// <param name="variableName">Variable name</param>
		/// <param name="query">QueryType name. For example, GibbsSampling answers 'Marginal', 'Samples', and 'Conditionals' queries</param>
		public object Marginal(string variableName, string query)
		{
			if (query=="Marginal") {
				return this.Marginal(variableName);
			}
			throw new ArgumentException(((("This class was not built to infer \'"+variableName)+"\' with query \'")+query)+"\'");
		}

		public T Marginal<T>(string variableName, string query)
		{
			return Distribution.ChangeType<T>(this.Marginal(variableName, query));
		}

		/// <summary>Update all marginals, by iterating message passing the given number of times</summary>
		/// <param name="numberOfIterations">The number of times to iterate each loop</param>
		/// <param name="initialise">If true, messages that initialise loops are reset when observed values change</param>
		private void Execute(int numberOfIterations, bool initialise)
		{
			this.Changed_numTraining_xTrain_yTrain();
			this.numberOfIterationsDone = numberOfIterations;
		}

		public void Execute(int numberOfIterations)
		{
			this.Execute(numberOfIterations, true);
		}

		public void Update(int additionalIterations)
		{
			this.Execute(this.numberOfIterationsDone+additionalIterations, false);
		}

		private void OnProgressChanged(ProgressChangedEventArgs e)
		{
			// Make a temporary copy of the event to avoid a race condition
			// if the last subscriber unsubscribes immediately after the null check and before the event is raised.
			EventHandler<ProgressChangedEventArgs> handler = this.ProgressChanged;
			if (handler!=null) {
				handler(this, e);
			}
		}

		/// <summary>Reset all messages to their initial values.  Sets NumberOfIterationsDone to 0.</summary>
		public void Reset()
		{
			this.Execute(0);
		}

		/// <summary>Computations that depend on the observed value of numTraining and xTrain and yTrain</summary>
		public void Changed_numTraining_xTrain_yTrain()
		{
			if (this.Changed_numTraining_xTrain_yTrain_iterationsDone==1) {
				return ;
			}
			this.numTraining_marginal = new PointMass<int>(this.NumTraining);
			this.xTrain_marginal = new PointMass<Vector[]>(this.XTrain);
			this.yTrain_marginal = new DistributionStructArray<Gaussian,double>(this.NumTraining, delegate(int iTrain) {
				return Gaussian.Uniform();
			});
			this.yTrain_marginal = Distribution.SetPoint<DistributionStructArray<Gaussian,double>,double[]>(this.yTrain_marginal, this.YTrain);
			// The constant 'vVector0'
			DenseVector vVector0 = DenseVector.FromArray(new double[2] {0.0,0.0});
			// The constant 'vPositiveDefiniteMatrix0'
			PositiveDefiniteMatrix vPositiveDefiniteMatrix0 = new PositiveDefiniteMatrix(new double[2, 2] {{1.0,0.0},{0.0,1.0}});
			VectorGaussian weights_F = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(vVector0.Count));
			this.weights_marginal_F = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(vVector0.Count));
			// Message from use of 'weights'
			VectorGaussian weights_use_B = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(vVector0.Count));
			// Message to 'weights' from VectorGaussian factor
			weights_F = VectorGaussianOp.SampleAverageLogarithm(vVector0, vPositiveDefiniteMatrix0, weights_F);
			// Create array for replicates of 'vdouble1_B'
			DistributionStructArray<Gaussian,double> vdouble1_B = new DistributionStructArray<Gaussian,double>(this.NumTraining);
			for(int iTrain = 0; iTrain<this.NumTraining; iTrain++) {
				vdouble1_B[iTrain] = Gaussian.Uniform();
				// Message to 'vdouble1' from GaussianFromMeanAndVariance factor
				vdouble1_B[iTrain] = GaussianFromMeanAndVarianceOp.MeanAverageLogarithm(this.YTrain[iTrain], 1.0);
			}
			DistributionRefArray<VectorGaussian,Vector> weights_rep_B = default(DistributionRefArray<VectorGaussian,Vector>);
			// Create array for 'weights_rep' Backwards messages.
			weights_rep_B = new DistributionRefArray<VectorGaussian,Vector>(this.NumTraining);
			for(int iTrain = 0; iTrain<this.NumTraining; iTrain++) {
				weights_rep_B[iTrain] = ArrayHelper.MakeUniform<VectorGaussian>(VectorGaussian.Uniform(vVector0.Count));
				// Message to 'weights_rep' from InnerProduct factor
				weights_rep_B[iTrain] = InnerProductOp.BAverageLogarithm(vdouble1_B[iTrain], this.XTrain[iTrain], weights_rep_B[iTrain]);
			}
			// Message to 'weights_use' from Replicate factor
			weights_use_B = ReplicateOp.DefAverageLogarithm<VectorGaussian>(weights_rep_B, weights_use_B);
			// Message to 'weights_marginal' from Variable factor
			this.weights_marginal_F = VariableVmpOp.MarginalAverageLogarithm<VectorGaussian>(weights_use_B, weights_F, this.weights_marginal_F);
			this.Changed_numTraining_xTrain_yTrain_iterationsDone = 1;
		}

		/// <summary>
		/// Returns the marginal distribution for 'numTraining' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<int> NumTrainingMarginal()
		{
			return this.numTraining_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'xTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public PointMass<Vector[]> XTrainMarginal()
		{
			return this.xTrain_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'yTrain' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public DistributionStructArray<Gaussian,double> YTrainMarginal()
		{
			return this.yTrain_marginal;
		}

		/// <summary>
		/// Returns the marginal distribution for 'weights' given by the current state of the
		/// message passing algorithm.
		/// </summary>
		/// <returns>The marginal distribution</returns>
		public VectorGaussian WeightsMarginal()
		{
			return this.weights_marginal_F;
		}

		#endregion

		#region Events
		/// <summary>Event that is fired when the progress of inference changes, typically at the end of one iteration of the inference algorithm.</summary>
		public event EventHandler<ProgressChangedEventArgs> ProgressChanged;
		#endregion

	}

}
